#include "stdafx.h"
#include "DMSService.h"

#ifdef WIN32
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#ifndef _WIN32_WCE
#include <crtdbg.h>
#endif
#else
#include <stdlib.h>
#endif

#include "dbtools.h"
#include "FileSystemTree.h"

extern "C"
{
	#include "ICC_Integration.h"
	#include "debug.h"
extern	TCHAR	gWorkingDir[MAX_PATH_LENGTH];
}

static HANDLE	DMSThreadHandle = NULL; 
static DWORD	DMSThreadId;
static struct	ICCI_State icci_state;
volatile int	DMSRunning = FALSE;

#ifdef OEM_ASUS
WAKE_SYSTEM		WakeSystem = NULL;
#endif

DWORD WINAPI MediaServerService(LPVOID args)
{
	DMSRunning = TRUE;

	memset(&icci_state, 0, sizeof(struct ICCI_State));
	icci_state.FseRootPath = ".\\\0";
	ICCI_SetSortSearchFields(&icci_state);
	ICCI_SetUDN(&icci_state);
	ICCI_SetSerialNum(&icci_state);
	ICCI_SetupContentProviders(&icci_state);
	ICCI_SetupComponentsAndStartUpnp(&icci_state);	

	DMSRunning = FALSE;

	return 0;
}

 int MediaServerStart()
 {
	// Clean previous queue query because it is out-of-date
	CleanQueueQueryInDatabase();	
	
	DMSThreadHandle = ::CreateThread(NULL, 0, MediaServerService, NULL, 0, &DMSThreadId);	
	
	if (DMSThreadHandle == NULL) 
	{
		return FALSE;
	}

#ifdef OEM_ASUS
	if (WakeSystem == NULL)
	{
		HMODULE	hWMLib = LoadLibrary(_T("AsNotify.dll"));
		if (hWMLib)
		{
			// Can find the ASUS Wake-up Nofify DLL
			WakeSystem = (WAKE_SYSTEM) GetProcAddress(hWMLib, "WakeSystem");
		}
	}
#endif

	// Raise the priority of DMS service to overcome other tasks occupy too much resourc,
	// for example, when run rom update and clinet plays streaming video "Pearl Harbor".
	SetThreadPriority(DMSThreadHandle, THREAD_PRIORITY_HIGHEST);

	// Wait 1 seconds to let DMS thread complete its initialization
	//Birdy
	//Sleep(1000);
	Sleep(1500);


	return TRUE;
 }


void MediaServerStop()
{
	ICCI_Stop(&icci_state);

	// Wait 3 seconds to finish some working tasks
	//Birdy
	//Sleep(3000);
	Sleep(1500);

	// Wait until DMS service stops
	while (DMSRunning)
		;

	// DMS thread has tereminated, free its resource
	CloseHandle(DMSThreadHandle);
	DMSThreadHandle = NULL;	
}

void MediaServerRestart()
{
	ICCI_Stop(&icci_state);

	// Wait until DMS service stops
	while (DMSRunning)
		;
	
	// DMS thread has tereminated, free its resource
	CloseHandle(DMSThreadHandle);
	DMSThreadHandle = NULL;	

	MediaServerStart();
}

int IsDMSRunning()
{
	return DMSRunning;
}

#ifdef OEM_ASUS
extern "C" void	WaitUpSystem()
{
	if (WakeSystem)
	{
		WakeSystem();
	}
}
#endif
