// HighColorPropertySheet.cpp : implementation file
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HighColorTab.h"
#include "HighColorPropertySheet.h"

#include "AboutDialog.h"
#include "afxdao.h"
#include "io.h"
#include "dbtools.h"
#include "SystemTray.h"
#include "atltypes.h"
#include "VideoInfo.h"
#include "DMSService.h"
#include "Language.h"
#include ".\highcolorpropertysheet.h"

extern int		skipScanFiles;
extern int		inScanFiles;
//Birdy
//extern int control_icon = 0;
extern int control_importpage_icon = 0;
extern int control_optionspage_icon = 0;
extern int control_scanICON_change = 2;
extern int refreshall_cancel_change;
extern int m_ToolTip_Activate;
extern int mouse_button_down;
extern int control_updata_list;
extern int IS_Change_Language;

//Birdy
extern void start_Youtube(void);

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHighColorPropertySheet

int		fProgExit = FALSE;

IMPLEMENT_DYNAMIC(CHighColorPropertySheet, CResizableSheet)

CHighColorPropertySheet::CHighColorPropertySheet(CWnd* pWndParent)
: CResizableSheet(PROGRAM_NAME, pWndParent)
{
	//Birdy
#ifdef SUPPORT_INTERNET_STREAM
	myDirectshowPage = new CDirectShowPage;
#endif
	mySystemPage = new CSystemPage;
	myOptionsPage = new COptionsPage;	

#ifdef ADD_DIR_METHOD
	myImportPage = new CImportPage2;
#else
	myImportPage = new CImportPage;
#endif

	// Operations
	AddPage( myImportPage );
	AddPage( mySystemPage );
	AddPage( myOptionsPage );

#ifdef SUPPORT_INTERNET_STREAM
	AddPage( myDirectshowPage );   //Birdy
#endif
}

CHighColorPropertySheet::~CHighColorPropertySheet()
{
	// We creat and add these pages in const, so we need to delete and remove thme in dest
	RemovePage( myImportPage );
	RemovePage( mySystemPage );
	RemovePage( myOptionsPage );

#ifdef SUPPORT_INTERNET_STREAM
	RemovePage( myDirectshowPage );   //Birdy
#endif

	delete myImportPage;
	delete mySystemPage;
	delete myOptionsPage;

#ifdef SUPPORT_INTERNET_STREAM
	delete myDirectshowPage;   //Birdy
#endif
}


BEGIN_MESSAGE_MAP(CHighColorPropertySheet, CResizableSheet)
	ON_WM_SYSCOMMAND()
	ON_COMMAND(ID_FILE_MAXMIZE, OnFileMaxmize)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(IDOK, OnFileExit)
	ON_COMMAND(ID_FILE_ABOUT, OnFileAbout)
	ON_COMMAND(ID_APPLY_NOW, OnFileAbout)
	ON_COMMAND(ID_FILE_START_SERVICE, OnFileStartService)
	ON_COMMAND(ID_FILE_STOP_SERVICE, OnFileStopService)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_SIZE()
//	ON_WM_LBUTTONDOWN()
//	ON_WM_RBUTTONDOWN()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHighColorPropertySheet message handlers

BOOL CHighColorPropertySheet::OnInitDialog() 
{
	CWnd	*pWnd;

	BOOL bResult = CResizableSheet::OnInitDialog();

	// Disable close button
	CMenu* pSysMenu = GetSystemMenu(FALSE); 
	//birdy 2007/12/12 enable exit button
	/*if (pSysMenu != NULL) 
	{
		pSysMenu->RemoveMenu(SC_CLOSE, MF_BYCOMMAND);
	}*/

	//tyhsu
	ModifyStyle(0,WS_MINIMIZEBOX,SWP_NOSIZE|SWP_NOMOVE);
	ModifyStyle(0,WS_MAXIMIZEBOX,SWP_NOSIZE|SWP_NOMOVE);

	// Hide default Cancel button
	GetDlgItem(IDCANCEL)->ShowWindow(SW_HIDE);
//	GetDlgItem(ID_FILE_EXIT)->ShowWindow(SW_HIDE);
	GetDlgItem(ID_APPLY_NOW)->ShowWindow(SW_HIDE);
	GetDlgItem(IDOK)->ShowWindow(SW_HIDE);


	//ID_FILE_EXIT

	/*
IDABORT             3
#define IDCLOSE         8
#define IDHELP  
*/


/*
	// Use default OK button as Exit button
	pWnd = GetDlgItem(IDOK);
	if (parseLangConfigOK)
	{
		pWnd->SetWindowText(QueryLangStr(LANG_STR_EXIT));
	}
	else
	{
		pWnd->SetWindowText(_T("Exit"));
	}

	pWnd->ShowWindow(TRUE);
	pWnd->EnableWindow(TRUE);



	// Use default Apply button as About button
	pWnd = GetDlgItem(ID_APPLY_NOW);
	if (parseLangConfigOK)
	{
		pWnd->SetWindowText(QueryLangStr(LANG_STR_ABOUT));
	}
	else
	{
		pWnd->SetWindowText(_T("About"));
	}

	pWnd->ShowWindow(TRUE);
	pWnd->EnableWindow(TRUE);
*/


	// set minimal size
	CRect rc;
	GetWindowRect(&rc);

	//Birdy 2007/11/23
	//SetMinTrackSize(CSize(GetMinWidth(), rc.Height()));
	//SetMaxTrackSize(CSize(GetMinWidth(), rc.Height()));
	SetMinTrackSize(CSize(800, 600));
	SetMaxTrackSize(CSize(800, 600));

	HICON hIcon = ::LoadIcon(AfxGetResourceHandle(), MAKEINTRESOURCE(IDI_ICON_LOGO));  // Icon to use

	// albert add
	SetIcon( hIcon ,TRUE);

	if (!m_TrayIcon.Create(
		NULL,                           // Let icon deal with its own messages
		WM_ICON_NOTIFY,                 // Icon notify message to use
		PROGRAM_NAME,					// tooltip
		hIcon,
		IDR_MENU1,						// ID of tray icon
		FALSE,
		PROGRAM_NAME,					// balloon tip
		_T(""),			                // balloon title
		NIIF_WARNING,                   // balloon icon
		20 ))                           // balloon timeout
	{
		return -1;
	}
	m_TrayIcon.HideIcon();

	// enable save/restore, with active page
	EnableSaveRestore(PROGRAM_NAME, TRUE, TRUE);
	
	// Load the setting from Database, In case that Option page isn't initilialized
	myOptionsPage->LoadFilterSettingFromDB();

	char tempstr[255];
	int i= db_getAVP("MinimizedAtStartUp",tempstr);
	if( strnicmp(tempstr,"TRUE",4) == 0 )
	{
		m_TrayIcon.ShowIcon();
		OnDemoMinimise() ;
	}

	// Create a timer to update transfer status about 1 sec
	m_nTimer = SetTimer(1, 250, 0);	

	return bResult;
}

void CHighColorPropertySheet::OnDestroy()
{
	CResizableSheet::OnDestroy();

	KillTimer(m_nTimer); 
}


void CHighColorPropertySheet::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == SC_MINIMIZE)
	{
		m_TrayIcon.ShowIcon();
		OnDemoMinimise() ;
	}
	else if ((nID & 0xFFF0) == SC_CLOSE)
	{
		//birdy 2007/12/12 exit button the same minimize button
		//OnFileExit();
		m_TrayIcon.ShowIcon();
		OnDemoMinimise() ;
	}
	else
	{
		CResizableSheet::OnSysCommand(nID, lParam);
	}	
}

void CHighColorPropertySheet::OnDemoMaximise() 
{
	CSystemTray::MaximiseFromTray(this);
	m_TrayIcon.SetMenuDefaultItem(ID_FILE_EXIT, FALSE);
}

void CHighColorPropertySheet::OnDemoMinimise() 
{
	CSystemTray::MinimiseToTray(this);
	m_TrayIcon.SetMenuDefaultItem(ID_FILE_MAXMIZE, FALSE);
}

void CHighColorPropertySheet::OnFileMaxmize()
{
	OnDemoMaximise() ;
	m_TrayIcon.HideIcon();
}

void CHighColorPropertySheet::OnFileExit()
{
	// Notify taht the program is exiting, please don't show any message
	fProgExit = TRUE;

	// Let ScanFiles() and ScanVideoFiles() thread skip
	skipScanFiles = TRUE;
	skipScanVideoFiles = TRUE;
	
	m_TrayIcon.RemoveIcon();

	PostQuitMessage(0);
}

void CHighColorPropertySheet::OnFileAbout()
{
	CAboutDialog aboutDlg;
	aboutDlg.DoModal();
	m_TrayIcon.SetMenuDefaultItem(ID_FILE_ABOUT, FALSE);
}

void CHighColorPropertySheet::OnFileStartService()
{
	if (!IsDMSRunning())
	{
		MediaServerStart();
	}
	m_TrayIcon.SetMenuDefaultItem(ID_FILE_START_SERVICE, FALSE);
}

void CHighColorPropertySheet::OnFileStopService()
{
	if (IsDMSRunning())
	{
		MediaServerStop();
	}
	m_TrayIcon.SetMenuDefaultItem(ID_FILE_STOP_SERVICE, FALSE);
}

void CHighColorPropertySheet::OnBnClickedCancel()
{
	OnFileExit();
}

void CHighColorPropertySheet::OnTimer(UINT nIDEvent) 
{
	static CTime	endScanTime;
	static int		endTimeValid = FALSE;

	//Birdy
	static int  importpage2 = 0, optionspage = 0, systempage = 0, mediapage = 0, control_clear = 0;	
	CButtonST *wnd;

	wnd =  ((CButtonST *)myImportPage->GetDlgItem(IDC_BUTTON_REFRESH_ALL));

	myImportPage->m_psp.pszTitle = _T("My Caption");

	if (inScanFiles)
	{
		endScanTime = CTime::GetCurrentTime();
		endTimeValid = TRUE;
	}
	else if (!IsDMSRunning() && endTimeValid)
	{
		CTimeSpan	elapsedTime = 0;
		CTime		currentTime;
		
		currentTime = CTime::GetCurrentTime();
		elapsedTime = currentTime - endScanTime;

		if (mouse_button_down == 1)
		{
			endScanTime = CTime::GetCurrentTime();
			mouse_button_down = 0;
		}

		if (elapsedTime.GetTotalSeconds() > 60)
		{
			// Automatically start serive after 60 seconds from the end of scanning file 
			MediaServerStart();
#ifdef YOUTUBE_SUPPORT
	//YoutubeThreadHandle = ::CreateThread(NULL, 0, YoutubeService, NULL, 0, &YoutubeThreadId);
	start_Youtube();
#endif
			endTimeValid = FALSE;
			//Birdy 2007/2/1 //change ICON
			control_importpage_icon = 1;
            control_optionspage_icon = 1;
		}
	}
	else if (IsDMSRunning() && endTimeValid)
	{
		endTimeValid = FALSE;
	}

	
	if (control_updata_list != 0)
	{
        //myImportPage->m_DirList.DeleteItem(control_updata_list);
		PSharedDirStruct	pSharedDir;
        int					count, i;

	    count = GetSharedDirCount();
        pSharedDir = GetAllSharedDirs();  

		myImportPage->m_DirList.DeleteAllItems();
        for (i = 0; i < count; i++)
        {
            myImportPage->m_DirList.InsertItem(i, pSharedDir[i].DirPath);
            myImportPage->m_DirList.SetItemText(i, 1, pSharedDir[i].DirPath);
        }

		//FREE(pSharedDir);
		control_updata_list = 0;
	}
	
	if (GetActivePage() == myImportPage)
	{
		importpage2 = 1;
	}
	if (GetActivePage() == myOptionsPage)
	{
		optionspage = 1;
	}
	if (GetActivePage() == mySystemPage)
	{
		systempage = 1;
	}
#ifdef SUPPORT_INTERNET_STREAM
	if (GetActivePage() == myDirectshowPage)
	{
		mediapage = 1;
	}
#endif

	if (IsDMSRunning())
	{
		if ( (control_optionspage_icon == 1) && (optionspage == 1) )
		{
#ifdef HDDMA
			myOptionsPage->m_StartServiceButton.SetIcon(IDI_ServerName, 64, 64);
            myOptionsPage->m_StartServiceButton.DrawTransparent();
            myOptionsPage->m_StartServiceButton.SetTooltipText(QueryLangStr(LANG_STR_CHANGE));
            myOptionsPage->Invalidate_Rect(IDC_BUTTON_START_SERVICE);
#endif
			control_optionspage_icon = 0;            	

#ifdef Conceptronic
			myOptionsPage->GetDlgItem(IDC_BUTTON_START_SERVICE)->SetWindowText(QueryLangStr(LANG_STR_CHANGE));
#endif

        }
		if ( (control_importpage_icon == 1) && (importpage2 == 1) )
		{
#ifdef HDDMA
			myImportPage->m_StartServiceButton.SetIcon(IDI_STOP, 64, 64);
            myImportPage->m_StartServiceButton.DrawTransparent();
            myImportPage->m_StartServiceButton.SetTooltipText(QueryLangStr(LANG_STR_STOPSERVICE));
            myImportPage->Invalidate_Rect(IDC_BUTTON_START_SERVICE);	
#endif
			control_importpage_icon = 0;			

#ifdef Conceptronic
			myImportPage->GetDlgItem(IDC_BUTTON_START_SERVICE)->SetWindowText(QueryLangStr(LANG_STR_STOPSERVICE));
#endif
		}        
		        
	}
	else
	{
		if ( (control_optionspage_icon == 1) && (optionspage == 1) )
		{            
#ifdef HDDMA
			myOptionsPage->m_StartServiceButton.SetIcon(IDI_Apply, 64, 64);
            myOptionsPage->m_StartServiceButton.DrawTransparent();
            myOptionsPage->m_StartServiceButton.SetTooltipText(QueryLangStr(LANG_STR_APPLY));
            myOptionsPage->Invalidate_Rect(IDC_BUTTON_START_SERVICE);
#endif
			control_optionspage_icon = 0;

#ifdef Conceptronic
			myOptionsPage->GetDlgItem(IDC_BUTTON_START_SERVICE)->SetWindowText(QueryLangStr(LANG_STR_APPLY));	
#endif
			
		}
		if ( (control_importpage_icon == 1) && (importpage2 == 1) )
		{
#ifdef HDDMA
            myImportPage->m_StartServiceButton.SetIcon(IDI_START, 64, 64);
            myImportPage->m_StartServiceButton.DrawTransparent();
            myImportPage->m_StartServiceButton.SetTooltipText(QueryLangStr(LANG_STR_STARTSERVICE));
            myImportPage->Invalidate_Rect(IDC_BUTTON_START_SERVICE);
#endif
			control_importpage_icon = 0;

#ifdef Conceptronic
			myImportPage->GetDlgItem(IDC_BUTTON_START_SERVICE)->SetWindowText(QueryLangStr(LANG_STR_STARTSERVICE));
#endif
			
		}
		
	}
    

	if (GetActivePage() == mySystemPage)
	{				
		//mySystemPage->UpdateTransferStatus();
		mySystemPage->UpdateTransferStatus1();
	}
    else if (GetActivePage() == myOptionsPage)
	{		
		if (!IsDMSRunning())
		{
			if (inScanFiles)
			{
				myOptionsPage->GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);				
        	}
			else
			{
				myOptionsPage->GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);				
			}			

            if (myOptionsPage->m_TranscodingEnable.GetCheck() == 1)
            {                    
                myOptionsPage->GetDlgItem(IDC_TRANS_VIDEO_QUALITY)->EnableWindow(TRUE);
            }
            else
            {                    
                myOptionsPage->GetDlgItem(IDC_TRANS_VIDEO_QUALITY)->EnableWindow(FALSE);
			}
                
		}
		else
		{			
			myOptionsPage->GetDlgItem(IDC_TRANS_VIDEO_QUALITY)->EnableWindow(FALSE);
			myOptionsPage->GetDlgItem(IDC_TRANSCODING_ENABLE2)->EnableWindow(FALSE);
			//myOptionsPage->GetDlgItem(IDC_VIDEO_QUALITY2)->EnableWindow(FALSE);			
			myOptionsPage->GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);						
		}
	}
	else if (GetActivePage() == myImportPage)
	{
		if (!IsDMSRunning())
		{
			if (inScanFiles)
			{
#ifdef ADD_DIR_METHOD
				myImportPage->GetDlgItem(IDC_BUTTON_REFRESH_ALL)->EnableWindow(TRUE);
				myImportPage->GetDlgItem(IDC_BUTTON_ADD_FOLDER)->EnableWindow(FALSE);
				myImportPage->GetDlgItem(IDC_BUTTON_DELETE_FOLDER)->EnableWindow(FALSE);
				myImportPage->GetDlgItem(IDC_BUTTON_DELETE_ALL)->EnableWindow(FALSE);
				myImportPage->GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);

				if (m_ToolTip_Activate == 1)
				{					
                    if ( wnd->m_hWnd != NULL )
                    {
                        if( wnd->m_ToolTip)
                        {
                            wnd->m_ToolTip.Activate(TRUE);
							m_ToolTip_Activate = 0;
                        }
                    }					
				}
				refreshall_cancel_change = 1;										
				
#else
				myImportPage->GetDlgItem(IDC_BUTTON_SCAN)->EnableWindow(FALSE);
				myImportPage->GetDlgItem(IDC_BUTTON_CLEAR)->EnableWindow(FALSE);
				myImportPage->GetDlgItem(IDC_TREE_FILEBROWSER)->EnableWindow(FALSE);
#endif
			}
			else
			{
#ifdef ADD_DIR_METHOD
				myImportPage->GetDlgItem(IDC_BUTTON_ADD_FOLDER)->EnableWindow(TRUE);
				myImportPage->GetDlgItem(IDC_BUTTON_REFRESH_ALL)->EnableWindow(TRUE);
				myImportPage->GetDlgItem(IDC_BUTTON_DELETE_FOLDER)->EnableWindow(TRUE);
				myImportPage->GetDlgItem(IDC_BUTTON_DELETE_ALL)->EnableWindow(TRUE);
				
				myImportPage->DragAcceptFiles(TRUE);

				if (m_ToolTip_Activate == 1)
				{					
					if ( wnd->m_hWnd != NULL )
                    {
                        if( wnd->m_ToolTip)
                        {
                            wnd->m_ToolTip.Activate(TRUE);
							m_ToolTip_Activate = 0;
                        }
                    }										
				}
				refreshall_cancel_change = 0;			
				
#else
				myImportPage->GetDlgItem(IDC_BUTTON_SCAN)->EnableWindow(TRUE);
				myImportPage->GetDlgItem(IDC_BUTTON_CLEAR)->EnableWindow(TRUE);
				myImportPage->GetDlgItem(IDC_TREE_FILEBROWSER)->EnableWindow(TRUE);
#endif
				myImportPage->GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);
			}			

			//birdy 2008/1/4 add for fix refresh icon bug
			if (control_scanICON_change == 0)
			{
#ifdef HDDMA
                myImportPage->m_Refesh_a_Folder.SetIcon(IDI_Cancel, 64, 64);
                myImportPage->m_Refesh_a_Folder.DrawTransparent();
                myImportPage->m_Refesh_a_Folder.SetTooltipText(QueryLangStr(LANG_STR_CANCEL));
                myImportPage->Invalidate_Rect(IDC_BUTTON_REFRESH_ALL);
#endif

#ifdef Conceptronic
				myImportPage->GetDlgItem(IDC_BUTTON_REFRESH_ALL)->SetWindowText(QueryLangStr(LANG_STR_CANCEL));
#endif
                //control_scanICON_change = 1;
            }
            else if (control_scanICON_change == 1)
            {
#ifdef HDDMA
                myImportPage->m_Refesh_a_Folder.SetIcon(IDI_SCAN, 64, 64);
                myImportPage->m_Refesh_a_Folder.DrawTransparent();
                myImportPage->m_Refesh_a_Folder.SetTooltipText(QueryLangStr(LANG_STR_REFRESHFOLDER));
                myImportPage->Invalidate_Rect(IDC_BUTTON_REFRESH_ALL);
#endif

#ifdef Conceptronic
				myImportPage->GetDlgItem(IDC_BUTTON_REFRESH_ALL)->SetWindowText(QueryLangStr(LANG_STR_REFRESHFOLDER));
#endif

                //control_scanICON_change = 0;
				control_scanICON_change = 2;
            }

			//

		}
		else
		{
			myImportPage->GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);

#ifdef ADD_DIR_METHOD
			myImportPage->GetDlgItem(IDC_BUTTON_ADD_FOLDER)->EnableWindow(FALSE);
			myImportPage->GetDlgItem(IDC_BUTTON_REFRESH_ALL)->EnableWindow(FALSE);
			myImportPage->GetDlgItem(IDC_BUTTON_DELETE_FOLDER)->EnableWindow(FALSE);
			myImportPage->GetDlgItem(IDC_BUTTON_DELETE_ALL)->EnableWindow(FALSE);
			myImportPage->DragAcceptFiles(TRUE);
#else
			myImportPage->GetDlgItem(IDC_BUTTON_SCAN)->EnableWindow(FALSE);
			myImportPage->GetDlgItem(IDC_BUTTON_CLEAR)->EnableWindow(FALSE);
			myImportPage->GetDlgItem(IDC_TREE_FILEBROWSER)->EnableWindow(FALSE);			
#endif            
		}

		myImportPage->RefreshScanDetailInfo();				
	}

	if (IS_Change_Language == 1)
	{
		//birdy 2008/1/7 add for change page name
	    CTabCtrl* pTab = GetTabControl();
        TC_ITEM ti;

        ti.mask = TCIF_TEXT;
        ti.pszText = QueryLangStr(LANG_STR_IMPORTPAGECAPTION);
        pTab->SetItem (0, &ti);

		ti.mask = TCIF_TEXT;
        ti.pszText = QueryLangStr(LANG_STR_SYSTEM);
        pTab->SetItem (1, &ti);

		ti.mask = TCIF_TEXT;
        ti.pszText = QueryLangStr(LANG_STR_OPTIONS);
        pTab->SetItem (2, &ti);

		ti.mask = TCIF_TEXT;
        ti.pszText = QueryLangStr(LANG_STR_Internet_Page);
        pTab->SetItem (3, &ti);
	    //

		IS_Change_Language = 0;

		//if (importpage2 == 1)
		{
            myImportPage->Change_Language();
			CHighColorPropertySheet(CImportPage2);
			//CImportPage2();
		}
		/*if (optionspage == 1)
		{
            myOptioonsPage->Change_Language();
		}*/
		if (systempage == 1)
		{
            mySystemPage->Change_Language();
		}
#ifdef SUPPORT_INTERNET_STREAM
		if (mediapage == 1)
		{
            myDirectshowPage->Change_Language();
		}		
#endif
		//Sleep(2);
    }
	
}

void CHighColorPropertySheet::OnSize(UINT nType, int cx, int cy)
{
	CResizableSheet::OnSize(nType, cx, cy);

	// TODO: b[JzTBz`{X	
	//Invalidate(1);
}
