// HighColorPropertySheet.h : header file
//
///////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_HIGHCOLORPROPERTYSHEET_H__2A258268_3ED7_40AD_886D_19B9B1A24B3A__INCLUDED_)
#define AFX_HIGHCOLORPROPERTYSHEET_H__2A258268_3ED7_40AD_886D_19B9B1A24B3A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
/////////////////////////////////////////////////////////////////////////////
// CHighColorPropertySheet

#include "ResizableSheet.h"

#include "MediafilesPage.h"
#include "ImportPage.h"
#include "ImportPage2.h"
#include "SystemPage.h"
#include "OptionsPage.h"
#include "DirectShowPage.h"
#include "SystemTray.h"
#include "OEM.h"


class CHighColorPropertySheet : public CResizableSheet
{
	DECLARE_DYNAMIC(CHighColorPropertySheet)

// Construction
public:
	//CHighColorPropertySheet(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	//CHighColorPropertySheet(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CHighColorPropertySheet(CWnd* pWndParent = NULL);
	void CHighColorPropertySheet::OnDemoMaximise() ;
	void CHighColorPropertySheet::OnDemoMinimise() ;
	
private:
	CMediafilesPage	*myFilesPage;
	CSystemPage		*mySystemPage;
	COptionsPage	*myOptionsPage;

#ifdef SUPPORT_INTERNET_STREAM
	CDirectShowPage *myDirectshowPage;
#endif

#ifdef ADD_DIR_METHOD
	CImportPage2	*myImportPage;
#else
	CImportPage		*myImportPage;
#endif

	CSystemTray		m_TrayIcon;
	UINT_PTR		m_nTimer;

public:
	virtual ~CHighColorPropertySheet();

protected:
	virtual BOOL OnInitDialog();	

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);	
	afx_msg void OnFileMaxmize();
	afx_msg void OnFileExit();
	afx_msg void OnFileAbout();
	afx_msg void OnFileStartService();
	afx_msg void OnFileStopService();
	afx_msg void OnBnClickedCancel();
	afx_msg	void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
//	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
//	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HIGHCOLORPROPERTYSHEET_H__2A258268_3ED7_40AD_886D_19B9B1A24B3A__INCLUDED_)
