// HighColorTab.cpp : Defines the class behaviors for the application.
//
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "HighColorTab.h"
#include "HighColorPropertySheet.h"
#include "Language.h"

#include "direct.h"
#include "Registry.h"

#ifdef WIN32
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#ifndef _WIN32_WCE
#include <crtdbg.h>
#endif
#else
#include <stdlib.h>
#endif

#include "AboutDialog.h"

#include <stdio.h>
#include <tchar.h>
#include "dbtools.h"
#include "io.h"
#include "Registry.h"
#include "VideoInfo.h"
#include "DMSService.h"
#include "Timer.h"
#include "FolderUtils.h"
#include "Language.h"
#include "ScanFiles.h"

// for thumbnail
#include "myGdiPlus.h"

extern "C"
{
#include "abyss.h"
#include "FileSystemTree.h"
#include "FileIoAbstraction.h"
#include "MyString.h"
#include "debug.h"
}

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Global Variables:
extern HINSTANCE hInst;								// current instance
extern LANGID UILanguage;								// The UI language chosen by the user
extern HANDLE	hScanFilesMutex;

extern "C" char		utf8WorkingDir[MAX_PATH_LENGTH];
extern "C" TCHAR	gWorkingDir[MAX_PATH_LENGTH];
extern "C" int		gPreCacheEnable;
extern "C" int	    gTranscodingEnable;
extern "C" int	    gTransVideoQualitySel;

LPMALLOC		pMalloc = NULL;			// memory manager, for freeing up PIDLs
LPSHELLFOLDER	psfDesktop = NULL;		// namespace root for parsing the path

// for thumbnail
using namespace	Gdiplus; 
ULONG_PTR		gdiplusToken;

/////////////////////////////////////////////////////////////////////////////
// CHighColorTabApp
extern int Youtube_Refresh;

BEGIN_MESSAGE_MAP(CHighColorTabApp, CWinApp)
	//{{AFX_MSG_MAP(CHighColorTabApp)
	//}}AFX_MSG
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHighColorTabApp construction

//birdy add
//test
extern "C"
{
int HandleDump(TSession *r);
int HandleStatus(TSession *r);
int HandleMIMEType(TSession *r);
int HandleTime(TSession *r);
void copyright();
}

//birdy add for lighthttp 2008/6/17
static HANDLE	LighthttpThreadHandle = NULL; 
static DWORD	LighthttpThreadId;
PROCESS_INFORMATION m_LighthttpProcess;
extern void Close_lighthttp();

static HANDLE	WebserverThreadHandle = NULL; 
static DWORD	WebserverThreadId;
extern void Start_UPnP_CP();

DWORD WINAPI WebserverService(LPVOID args)
{
	TServer srv;
	//char *conffile=gWorkingDir;
	TCHAR mimefile[MAX_PATH_LENGTH+100];
	
	_stprintf(mimefile, _T("%s%s"), gWorkingDir, _T("/mime.types"));
	

	#ifdef _WIN32
	copyright();
	printf("\nPress Ctrl+C to stop the server\n");
    #endif

	DateInit();

	MIMETypeInit();

	ServerCreate(&srv,"HTTPServer",80,DEFAULT_DOCS,NULL);

//	ConfReadServerFile((char *)gWorkingDir,&srv);
	srv.keepalivetimeout=10;
						/* Must see what to do with that */
	srv.timeout=10;
	srv.keepalivemaxconn=10;
	ConfReadMIMETypes(mimefile);


	ServerAddHandler(&srv,HandleTime);
	ServerAddHandler(&srv,HandleDump);
	ServerAddHandler(&srv,HandleStatus);
	ServerAddHandler(&srv,HandleMIMEType);

	ServerInit(&srv);

	ServerRun(&srv);

	return 0;
}
//

//birdy add for lighthttp 2008/6/17
void Close_lighthttp()
{
	TerminateProcess(m_LighthttpProcess.hProcess,0);
	CloseHandle(m_LighthttpProcess.hThread);		
	CloseHandle(m_LighthttpProcess.hProcess);	
}

DWORD WINAPI LighthttpService(LPVOID args)
{
	wchar_t CommandLine[1024];
	wchar_t CodecLine[1024];	
	wchar_t TimePath[1024];
	//PROCESS_INFORMATION m_LighthttpProcess;
	STARTUPINFO si;
	BOOL bCreateProc;	
	int i = 0, filesize = 0;		

	//birdy add for work path
	/*CString commandLine = GetCommandLine();
	CString progPath = commandLine.Right(commandLine.GetLength() - commandLine.Find(_T('\"')) -1);
	progPath = progPath.Left(progPath.Find(_T('\"')));
	progPath = progPath.Left(progPath.ReverseFind(_T('\\')));
	progPath.Replace(_T("\\"),_T("/"));
	_tcscpy(WorkingDir, progPath.GetString());*/

	//_snwprintf(TimePath, 1024, L"%s\\time.txt",gWorkingDir);
	_snwprintf(CodecLine, 1024, L"%s\\lighttpd.exe",gWorkingDir);	
	_snwprintf(CommandLine, 1024,L"%s",gWorkingDir);

	bCreateProc = CreateProcess(
			CodecLine, //		    L"Trans.eng ", //phillo
		    CommandLine,
		    NULL,               // LPSECURITY_ATTRIBUTES lpProcessAttributes,
		    NULL,               // LPSECURITY_ATTRIBUTES lpThreadAttributes,
		    FALSE,              // BOOL bInheritHandles,
		    CREATE_NO_WINDOW,//CREATE_NO_WINDOW,   // DWORD dwCreationFlags, //phillo,2007/10/24, 0==> create console
		    NULL,               // LPVOID lpEnvironment,
		    NULL,               // LPCTSTR lpCurrentDirectory,
		    &si,               // LPSTARTUPINFO lpStartupInfo,
		    &m_LighthttpProcess    // LPPROCESS_INFORMATION lpProcessInformation
		);

	return 0;
}
//

CHighColorTabApp::CHighColorTabApp()
{
}

CHighColorTabApp::~CHighColorTabApp()
{
}

CHighColorTabApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CHighColorTabApp initialization

BOOL CHighColorTabApp::InitInstance()
{	
	HWND	hTrayIconWnd, hProgWnd;
	//TCHAR	tpath[MAX_PATH_LENGTH];

	if (hProgWnd = FindWindow(NULL, PROGRAM_NAME))
	{
		// Another Program has been running
		AttachThreadInput(GetCurrentThreadId(), GetWindowThreadProcessId(hProgWnd, NULL), TRUE);
		SetActiveWindow(hProgWnd);
		exit(0);
	}
	
	if (hTrayIconWnd = FindWindow(NULL, TRAYICON_NAME))
	{
		// Another Program has been running in Tray mode
		// Sent this message to Tray Windows, it will maxmize the windows of previous instance
		AttachThreadInput(GetCurrentThreadId(), GetWindowThreadProcessId(hTrayIconWnd, NULL), TRUE);
		SetActiveWindow(hTrayIconWnd);
		::SendMessage(hTrayIconWnd, WM_ICON_NOTIFY, IDR_MENU1, ID_FILE_MAXMIZE);
		exit(0);
	}

	HANDLE progMutexHandle = CreateMutex(NULL, false, PROGRAM_MUTEX_NAME);
	if (GetLastError() == ERROR_ALREADY_EXISTS )
	{
		exit(0);
	}

	// We get the current working directory from command line for later use
	CString commandLine = GetCommandLine();
	CString progPath = commandLine.Right(commandLine.GetLength() - commandLine.Find(_T('\"')) -1);
	progPath = progPath.Left(progPath.Find(_T('\"')));
	progPath = progPath.Left(progPath.ReverseFind(_T('\\')));
	_tcscpy(gWorkingDir, progPath.GetString());
	strToUtf8(utf8WorkingDir, (char *) gWorkingDir, MAX_PATH_LENGTH, IS_WIDE, NULL);
	
	// create the directory
	CString	folderPath;

	folderPath = gWorkingDir;
	folderPath += _T("\\thumbnail");
	CFolderUtils::RemoveFolder(folderPath);
	CreateDirectory(folderPath, NULL);

	folderPath = gWorkingDir;
	folderPath += _T("\\cache");
	CreateDirectory(folderPath, NULL);

	AfxEnableControlContainer();
	//Enable3dControls();

	if (FAILED(SHGetMalloc(&pMalloc)))
	{
		// Cannot get the COM memory manager
		AfxMessageBox(_T("Cannot initialize COM (Malloc)"));
		ReleaseMutex(progMutexHandle);
		exit(0);
	}

	if (FAILED(SHGetDesktopFolder(&psfDesktop)))
	{
		// Cannot get the Desktop Folder
		AfxMessageBox(_T("Cannot initialize Shell Extension (Desktop Folder)"));
		pMalloc->Release();
		ReleaseMutex(progMutexHandle);
		exit(0);
	}

	// Open the MS Firewall for our server service
#if 0
	{

		CRegistry	regMyReg;

		if (regMyReg.Open(_T("SYSTEM\\CurrentControlSet\\Services\\SharedAccess\\Parameters\\FirewallPolicy\\StandardProfile\\AuthorizedApplications\\List")))
		{
			CString		key, data;

			key = gWorkingDir;
			key += _T("\\DigitalMediaServer.exe");
			data = key;
			data += _T(":*:Enabled:");
			data += PROGRAM_NAME;
			regMyReg[key] = data;
			regMyReg.Close();
		}
	}
#endif

	//Birdy 2007/5/29 Set Vista Firewall for our server service
	{
        HKEY rootkey;
        HKEY openkey;
        HKEY hSubkey;
        DWORD mytype = REG_SZ;	        
        LONG RegError;        

        TCHAR execute_path[MAX_PATH_LENGTH];
        TCHAR execute_path_value[MAX_PATH_LENGTH];        
		rootkey = HKEY_CURRENT_USER;
        _stprintf(execute_path, _T("%s\\%s"), gWorkingDir, PROG_EXE_NAME);
		_stprintf(execute_path_value, _T("%s%s%s"), execute_path, _T(":*:Enabled:"), PROG_EXE_NAME);
		//Birdy Vista test
		//_stprintf(execute_path, _T("%s\\%s\\%s"), L"v2.0|Action=Allow|Active=TRUE|Dir=In|App=", gWorkingDir, PROG_EXE_NAME);
        RegError = RegOpenKeyEx( rootkey, NULL, 0, KEY_ALL_ACCESS, ( PHKEY ) &openkey ); //KEY_READ
		//Vista test
		//v2.0|Action=Allow|Active=TRUE|Dir=In|App=C:\Program Files\MSN Messenger\msnmsgr.exe|Name=Windows Live Messenger 8.1
		//RegError = RegOpenKeyEx( openkey, _T("HKEY_LOCAL_MACHINE\\System\\ControlSet001\\Services\\SharedAccess\\Parameters\\FirewallPolicy\\FirewallRules"), 0, KEY_ALL_ACCESS, ( PHKEY ) &hSubkey ); //KEY_READ
        RegError = RegOpenKeyEx( openkey, _T("SYSTEM\\CurrentControlSet\\Services\\SharedAccess\\Parameters\\FirewallPolicy\\StandardProfile\\AuthorizedApplications\\List"), 0, KEY_ALL_ACCESS, ( PHKEY ) &hSubkey ); //KEY_READ
        RegError = RegSetValueEx(hSubkey,execute_path,0,mytype,(LPBYTE)&execute_path_value,wcslen(execute_path_value) * 2);
        
        RegCloseKey( hSubkey );
        RegCloseKey( openkey );
    
	}
	
	if(!InitDatabase())
	{
		if (parseLangConfigOK)
			::MessageBox(NULL, _T("Cannot open database"), QueryLangStr(LANG_STR_ERROR), MB_OK); 
		else
			::MessageBox(NULL, _T("Cannot open database"), _T("Error"), MB_OK); 

		ReleaseMutex(progMutexHandle);
		exit(0);
	}

	// Load language specific string 
	parseLangConfigOK = ParseLangConfig();

	CHighColorPropertySheet dlg;
	m_pMainWnd = &dlg;

	// This mutext is useless after the window is created
	ReleaseMutex(progMutexHandle);

	HINSTANCE hInstance;
	hInstance = this->m_hInstance;

	// Add computer name to the sever name if it is the first time to run this program
	{
		TCHAR	queryResult[MAX_QUERY_STRING_LEN];

		if (db_getAVPT(_T("RunFirstTime"), queryResult)) 
		{
			if (_tcsicmp(queryResult, _T("TRUE")) == 0)
			{
				// indicate the next time is not the first run
				db_setAVPT(_T("RunFirstTime"), _T("FALSE"));

				CRegistry	regMyReg;
				CString		computerName, serverName;

				if (regMyReg.Open(_T("SYSTEM\\CurrentControlSet\\Control\\ComputerName\\ActiveComputerName")))
				{
					computerName = regMyReg[_T("ComputerName")];
					regMyReg.Close();

					if (db_getAVPT(_T("ServerName"), queryResult))
					{
						serverName = queryResult;
					}
					else
					{


#ifdef HDDMA
    #ifdef STOREX
        serverName = _T("STOREX DMS");
	#elif STOREX_Aivx370
		serverName = _T("STOREX-Aivx370 DMS");
    #else
        serverName = _T("HoneyWld DMS");
#endif
						
#endif					

#ifdef Cconceptronic
						serverName = _T("Conceptronic DMS");
#endif

/*#ifdef QMA
						serverName = _T("HoneyWld DMS");
#else
						serverName = _T("HoneyWld DMS");
#endif*/



                        						
					}

					serverName += _T(" (";)
					serverName += computerName;
					serverName += _T(")");
/*#ifdef HDDMA
					serverName = _T("(HD)") + serverName;
#endif*/
					db_setAVPT(_T("ServerName"), serverName);
				}

				//phillo,2007/10/24
				// initialize inter radio&video
				initFSE_QS();
			}
		}
	}

	// Create a scan files mutex with no initial owner.
	hScanFilesMutex = CreateMutex(
		NULL,                       // default security attributes
		FALSE,                      // initially not owned
		NULL);                      // unnamed mutex

	if (hScanFilesMutex == NULL)
	{
		if (parseLangConfigOK)
			::MessageBox(NULL, _T("Cannot create the scan files mutext"), QueryLangStr(LANG_STR_ERROR), MB_OK); 
		else
			::MessageBox(NULL,  _T("Cannot create the scan files mutext"), _T("Error"), MB_OK); 
		ReleaseMutex(progMutexHandle);
		exit(0);
	}

	//qsCount = db_getCount("select MyIndex from FSE_QueryState");
	qsCount = GetMaxMyIndexNoInDatabase() + 1;

	totalFileCount = db_getCount("select MyIndex from FSE_QueryState where ObjectType = 1 and (pIndex=4 or pIndex=7 or pIndex=13 or Flags=17)");
	videoCount = db_getCount("select MyIndex from FSE_QueryState where ObjectType = 1 and  pIndex=4 ");
	playlistCount = db_getCount("select MyIndex from FSE_QueryState where ObjectType = 1 and Flags=17");
	audioCount = db_getCount("select MyIndex from FSE_QueryState where ObjectType = 1 and  pIndex=7") - playlistCount/2;
	imageCount = db_getCount("select MyIndex from FSE_QueryState where ObjectType = 1 and  pIndex=13 ");

	// Initial Gdi , used for thumbnail creater
	GdiplusStartupInput gdiplusStartupInput;
	VERIFY(GdiplusStartup( &gdiplusToken, &gdiplusStartupInput, NULL ) == Ok );

	// Get PreCache setting from database
	{
		char tempstr[255];
        TCHAR NumStr[255];

		db_getAVP("PreCacheEnable",tempstr);
		if (strnicmp(tempstr,"TRUE",4) == 0)
		{
			gPreCacheEnable = TRUE;
		}

        db_getAVP("TranscodingEnable",tempstr);
		if (strnicmp(tempstr,"TRUE",4) == 0)
		{
			gTranscodingEnable = TRUE;
		}
        if (db_getAVPT(_T("TransVideoQuality"), NumStr))
	    {
            gTransVideoQualitySel = _wtoi(NumStr);
	    }
	}

	// Set a timer procedure to monitor something
	//TimerProcStart();

	// Start the thread for generating video index files
	StartScanVideoFilesThread();

	//birdy add for UPnP_CP and webserver
	WebserverThreadHandle = ::CreateThread(NULL, 0, WebserverService, NULL, 0, &WebserverThreadId);
	LighthttpThreadHandle = ::CreateThread(NULL, 0, LighthttpService, NULL, 0, &WebserverThreadId);

	Start_UPnP_CP();

	if (totalFileCount != 0)
	{
		// If there are files in database, start the Media Server Service immediately
		// Otherwise, let user add files into database
		if (!MediaServerStart())
		{
			if (parseLangConfigOK)
				::MessageBox(NULL, _T("Cannot Start Media Server Service"), QueryLangStr(LANG_STR_ERROR), MB_OK); 
			else
				::MessageBox(NULL, _T("Cannot Start Media Server Service"), _T("Error"),MB_OK);
			ReleaseMutex(progMutexHandle);
			exit(0);
		}

		// Wait unitl DMS server starts
		Sleep(1000);
	}
	
	INT_PTR nResponse = dlg.DoModal();

	//TimerProcStop();

	if (IsDMSRunning())
	{
		// Stop DMS service
		MediaServerStop();
	}

	while (WaitForSingleObject(hScanFilesMutex, 100L) != WAIT_OBJECT_0)
		Sleep(100);
	
	CloseHandle(hScanFilesMutex);

	// Terminate the generating of video index files
	TerminateScanVideoFilesThread();

	CloseDatabase();
	
	FreeLangConfigResource();

	// Free the COM resource that we created
	psfDesktop->Release(); 
	pMalloc->Release();

	// Since the dialog has been closed, return FALSE so that we exit the
	// application, rather than start the application's message pump.
	return FALSE;
}
