// ImportPage.cpp
//

#include "stdafx.h"
#include "HighColorTab.h"
#include "ImportPage.h"
#include "Language.h"
#include "DMSService.h"
#include "ScanFiles.h"

extern "C"
{
	#include "FileSystemTree.h"
	//#include "mystring.h"
}


extern TCHAR	currentScanFileName[MAX_PATH_LENGTH];
extern int		inScanFiles;
extern int		skipScanFiles;

IMPLEMENT_DYNAMIC(CImportPage, CResizablePage)

CImportPage::CImportPage(): CResizablePage(CImportPage::IDD)
{
	// Change the title of this page according to the OS language
	if (parseLangConfigOK)
	{
		m_psp.dwFlags |= PSP_USETITLE;
		m_psp.pszTitle = QueryLangStr(LANG_STR_IMPORTPAGECAPTION);
	}
}

CImportPage::~CImportPage()
{
}

void CImportPage::DoDataExchange(CDataExchange* pDX)
{
	CResizablePage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TREE_FILEBROWSER, m_TreeFileBrowser);
	DDX_Control(pDX, IDC_BUTTON_START_SERVICE, m_StartServiceButton);
	DDX_Control(pDX, IDC_BUTTON_STOP_SERVICE, m_StopServiceButton);
}


BEGIN_MESSAGE_MAP(CImportPage, CResizablePage)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE_FILEBROWSER, OnTvnSelchangedTreeFilebrowser)
	ON_BN_CLICKED(IDC_BUTTON_START_SERVICE, OnBnClickedButtonStartService)
	ON_BN_CLICKED(IDC_BUTTON_STOP_SERVICE, OnBnClickedButtonStopService)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnBnClickedButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_SCAN, OnBnClickedButtonScan)
	ON_BN_CLICKED(IDC_BUTTON_CANCEL, OnBnClickedButtonCancel)
END_MESSAGE_MAP()


BOOL CImportPage::OnInitDialog()
{
	BOOL	result; 

	result = CResizablePage::OnInitDialog();

	AddAnchor(IDC_STATIC_FILEBROWSER, TOP_LEFT, ANCHOR(100,60));	
	AddAnchor(IDC_TREE_FILEBROWSER, ANCHOR(2,2), ANCHOR(85,58));	
	AddAnchor(IDC_BUTTON_START_SERVICE, ANCHOR(85,10));
	AddAnchor(IDC_BUTTON_STOP_SERVICE, ANCHOR(85,20));
	AddAnchor(IDC_BUTTON_CLEAR, ANCHOR(85,30));
	AddAnchor(IDC_BUTTON_SCAN, ANCHOR(85,40));
	AddAnchor(IDC_BUTTON_CANCEL, ANCHOR(85,50));
	
	//AddAnchor(IDC_STATIC_DETAIL, ANCHOR(30,60),BOTTOM_RIGHT);
	AddAnchor(IDC_STATIC_DETAIL, ANCHOR(0,60),ANCHOR(30,100));
	AddAnchor(IDC_STATIC15, ANCHOR(6,64));
	AddAnchor(IDC_STATIC_SCANFILE_CAPTION, ANCHOR(36,88));
	AddAnchor(IDC_SCAN_DETAIL_TOTAL, ANCHOR(15,64));
	AddAnchor(IDC_STATIC_SCANFILE, ANCHOR(51,88));
	AddAnchor(IDC_STATIC16, ANCHOR(6,68));
	AddAnchor(IDC_SCAN_DETAIL_TIME, ANCHOR(15,68));

	//AddAnchor(IDC_STATIC_CONTENT, ANCHOR(0,60),ANCHOR(30,100));
	//AddAnchor(IDC_STATIC4, ANCHOR(6,64));
	//AddAnchor(IDC_STATIC5, ANCHOR(6,68));
	//AddAnchor(IDC_STATIC6, ANCHOR(6,72));
	//AddAnchor(IDC_STATIC7, ANCHOR(6,76));
	//AddAnchor(IDC_STATIC8, ANCHOR(6,80));
	//AddAnchor(IDC_STATIC9, ANCHOR(6,84));
	//AddAnchor(IDC_CONTENT_AUDIO, ANCHOR(15,64));
	//AddAnchor(IDC_CONTENT_VIDEO, ANCHOR(15,68));
	//AddAnchor(IDC_CONTENT_PICTURE, ANCHOR(15,72));
	//AddAnchor(IDC_CONTENT_FILTER, ANCHOR(15,76));
	//AddAnchor(IDC_CONTENT_PLAYLIST, ANCHOR(15,80));
	//AddAnchor(IDC_CONTENT_TOTAL, ANCHOR(15,84));
	//AddAnchor(IDC_STATIC10, ANCHOR(36,64));
	//AddAnchor(IDC_STATIC11, ANCHOR(36,68));
	//AddAnchor(IDC_STATIC12, ANCHOR(36,72));
	//AddAnchor(IDC_STATIC13, ANCHOR(36,76));
	//AddAnchor(IDC_STATIC14, ANCHOR(36,80));
	//AddAnchor(IDC_STATIC15, ANCHOR(36,84));
	//AddAnchor(IDC_STATIC_SCANFILE_CAPTION, ANCHOR(36,88));
	//AddAnchor(IDC_SCAN_DETAIL_AUDIO, ANCHOR(51,64));
	//AddAnchor(IDC_SCAN_DETAIL_VIDEO, ANCHOR(51,68));
	//AddAnchor(IDC_SCAN_DETAIL_PICTURE, ANCHOR(51,72));
	//AddAnchor(IDC_SCAN_DETAIL_FILTER, ANCHOR(51,76));
	//AddAnchor(IDC_SCAN_DETAIL_PLAYLIST, ANCHOR(51,80));
	//AddAnchor(IDC_SCAN_DETAIL_TOTAL, ANCHOR(51,84));
	//AddAnchor(IDC_STATIC_SCANFILE, ANCHOR(51,88));
	//AddAnchor(IDC_STATIC16, ANCHOR(66,64));
	//AddAnchor(IDC_STATIC17, ANCHOR(66,68));
	//AddAnchor(IDC_STATIC18, ANCHOR(66,72));
	//AddAnchor(IDC_SCAN_DETAIL_TIME, ANCHOR(81,64));
	//AddAnchor(IDC_SCAN_DETAIL_REJECTED, ANCHOR(81,68));
	//AddAnchor(IDC_SCAN_DETAIL_SKIP, ANCHOR(81,72));
#ifdef OEM_ASUS
	AddAnchor(IDC_STATIC_Logo,TOP_LEFT,TOP_LEFT);
#endif

	m_TreeFileBrowser.DeleteAllItems();
	m_TreeFileBrowser.AddRootFolderContent(NULL);
	m_TreeFileBrowser.Expand(m_TreeFileBrowser.GetRootItem(), TVE_EXPAND);

	// Change the strings in this dialog according to OS language	
	if (parseLangConfigOK)
	{
		CString	str;

		GetDlgItem(IDC_BUTTON_START_SERVICE)->SetWindowText(QueryLangStr(LANG_STR_STARTSERVICE));
		GetDlgItem(IDC_BUTTON_STOP_SERVICE)->SetWindowText(QueryLangStr(LANG_STR_STOPSERVICE));
		GetDlgItem(IDC_BUTTON_CLEAR)->SetWindowText(QueryLangStr(LANG_STR_UNCHECKALL));
		GetDlgItem(IDC_BUTTON_SCAN)->SetWindowText(QueryLangStr(LANG_STR_SCAN));
		GetDlgItem(IDC_BUTTON_CANCEL)->SetWindowText(QueryLangStr(LANG_STR_CANCEL));
		//GetDlgItem(IDC_STATIC_CONTENT)->SetWindowText(QueryLangStr(LANG_STR_CONTENTS));
		GetDlgItem(IDC_STATIC_DETAIL)->SetWindowText(QueryLangStr(LANG_STR_SCANDETAILS));

		/*str = QueryLangStr(LANG_STR_AUDIOFILES);
		str += _T(":");
		//GetDlgItem(IDC_STATIC4)->SetWindowText(str);
		//GetDlgItem(IDC_STATIC10)->SetWindowText(str);
		
		str = QueryLangStr(LANG_STR_VIDEOFILES);
		str += _T(":");
		//GetDlgItem(IDC_STATIC5)->SetWindowText(str);
		//GetDlgItem(IDC_STATIC11)->SetWindowText(str);
		str = QueryLangStr(LANG_STR_PICTUREFILES);
		str += _T(":");
		//GetDlgItem(IDC_STATIC6)->SetWindowText(str);
		//GetDlgItem(IDC_STATIC12)->SetWindowText(str);

		str = QueryLangStr(LANG_STR_FILTEREDFILES);
		str += _T(":");
		//GetDlgItem(IDC_STATIC7)->SetWindowText(str);
		//GetDlgItem(IDC_STATIC13)->SetWindowText(str);

		str = QueryLangStr(LANG_STR_PLAYLISTCOUNT);
		str += _T(":");
		//GetDlgItem(IDC_STATIC8)->SetWindowText(str);
		//GetDlgItem(IDC_STATIC14)->SetWindowText(str);

		str = QueryLangStr(LANG_STR_TOTALFILES);
		str += _T(":");
		//GetDlgItem(IDC_STATIC9)->SetWindowText(str);
		//GetDlgItem(IDC_STATIC15)->SetWindowText(str);
		
		str = QueryLangStr(LANG_STR_SCANTIME);
		str += _T(":");
		GetDlgItem(IDC_STATIC16)->SetWindowText(str);

		str = QueryLangStr(LANG_STR_REJECTEDFILES);
		str += _T(":");
		//GetDlgItem(IDC_STATIC17)->SetWindowText(str);

		str = QueryLangStr(LANG_STR_SKIPFILES);
		str += _T(":");
		//GetDlgItem(IDC_STATIC18)->SetWindowText(str);*/

		str = QueryLangStr(LANG_STR_SCANFILES);
		str += _T(":");
		GetDlgItem(IDC_STATIC_SCANFILE_CAPTION)->SetWindowText(str);
	}
#ifdef OEM_ASUS
	m_StartServiceButton.SetIconID(IDI_START_SERVICE_BUTTON);
	m_StopServiceButton.SetIconID(IDI_STOP_SERVICE_BUTTON);
#endif

	return result; 
}

BOOL CImportPage::OnSetActive() 
{
	((CPropertySheet*)GetParent())->SetWizardButtons(PSWIZB_NEXT);

	// Update the Content Info when users switch to Import Page
	RefreshContentInfo();
	RefreshScanDetailInfo();

	if (IsDMSRunning())
	{
		GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_STOP_SERVICE)->EnableWindow(TRUE);

		GetDlgItem(IDC_BUTTON_SCAN)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_CLEAR)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_CANCEL)->EnableWindow(FALSE);
	}
	else
	{
		if (inScanFiles)
		{
			GetDlgItem(IDC_BUTTON_SCAN)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_CLEAR)->EnableWindow(FALSE);
			GetDlgItem(IDC_TREE_FILEBROWSER)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_CANCEL)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);
		}
		else
		{
			GetDlgItem(IDC_BUTTON_SCAN)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_CLEAR)->EnableWindow(TRUE);
			GetDlgItem(IDC_TREE_FILEBROWSER)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_CANCEL)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_BUTTON_STOP_SERVICE)->EnableWindow(FALSE);
	}

	return CResizablePage::OnSetActive();
}

void CImportPage::OnBnClickedButtonStartService()
{
	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_SCAN)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CANCEL)->m_hWnd);
	
	if (!IsDMSRunning())
	{
		GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_SCAN)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_CLEAR)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_CANCEL)->EnableWindow(FALSE);
		
		MediaServerStart();

		GetDlgItem(IDC_BUTTON_STOP_SERVICE)->EnableWindow(TRUE);
	}
}

void CImportPage::OnBnClickedButtonStopService()
{
	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_SCAN)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CANCEL)->m_hWnd);

	if (IsDMSRunning())
	{
		GetDlgItem(IDC_BUTTON_STOP_SERVICE)->EnableWindow(FALSE);

		MediaServerStop();

		GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_SCAN)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_CLEAR)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_CANCEL)->EnableWindow(TRUE);
	}
}

void CImportPage::OnBnClickedButtonCancel()
{
	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_SCAN)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR)->m_hWnd);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CANCEL)->m_hWnd);

	// Notify ScanFile() to stop scanning
	skipScanFiles = TRUE;
}

void CImportPage::OnBnClickedButtonClear()
{
	HTREEITEM	hTreeSelItem;
	BOOL		isChecked = FALSE;

	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_SCAN)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CANCEL)->m_hWnd);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR)->m_hWnd);

	hTreeSelItem = m_TreeFileBrowser.GetRootItem();

	while (hTreeSelItem != NULL)
	{
		isChecked = m_TreeFileBrowser.GetCheck(hTreeSelItem);
		
		if (isChecked)
		{
			m_TreeFileBrowser.SetCheck(hTreeSelItem,FALSE);			
		}				
		
		hTreeSelItem = m_TreeFileBrowser.GetNextVisibleItem(hTreeSelItem);
	}

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR)->m_hWnd);
	return;
}


void CImportPage::OnBnClickedButtonScan()
{
	HANDLE	ScanThreadHandle; 
	DWORD	ScanThreadId;

	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CANCEL)->m_hWnd);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_SCAN)->m_hWnd);

	inScanFiles = TRUE;
	GetDlgItem(IDC_BUTTON_SCAN)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_CLEAR)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);
	GetDlgItem(IDC_TREE_FILEBROWSER)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_CANCEL)->EnableWindow(TRUE);

	// set the initail value for menu "Scan Details"
	filterCount = 0;
	scan_audioCount=0;
	scan_videoCount=0;
	scan_imageCount=0;
	scan_filterCount=0;
	scan_playlistCount=0;
	scan_rejectCount=0;
	scan_skipCount=0;
	scan_totalFileCount=0;
	m_startTime = CTime::GetCurrentTime();

	ScanThreadHandle = ::CreateThread(NULL, 0, ScanFilesThread, (LPVOID) &m_TreeFileBrowser, 0, &ScanThreadId);
	if (ScanThreadHandle == NULL)
	{
		if (parseLangConfigOK)
			::MessageBox(NULL, _T("Cannot create the scan thread"), QueryLangStr(LANG_STR_ERROR), MB_OK); 
		else
			::MessageBox(NULL, _T("Cannot create the scan thread"), _T("Error"), MB_OK); 
		GetDlgItem(IDC_BUTTON_SCAN)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_CLEAR)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);
		GetDlgItem(IDC_TREE_FILEBROWSER)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_CANCEL)->EnableWindow(FALSE);
		inScanFiles = FALSE;
	}
	
	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_SCAN)->m_hWnd);
	return;
}

void CImportPage::RefreshContentInfo()
{
	TCHAR output[20];

	// When the program is exiting, don't show anything

	_stprintf(output,_T("%-10d"),totalFileCount - playlistCount/2);
	//GetDlgItem(IDC_CONTENT_TOTAL)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),audioCount);
	//GetDlgItem(IDC_CONTENT_AUDIO)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),videoCount);
	//GetDlgItem(IDC_CONTENT_VIDEO)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),imageCount);
	//GetDlgItem(IDC_CONTENT_PICTURE)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),filterCount);
	//GetDlgItem(IDC_CONTENT_FILTER)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),playlistCount/2);
	//GetDlgItem(IDC_CONTENT_PLAYLIST)->SetWindowText(output);
}

void CImportPage::RefreshScanDetailInfo()
{
	TCHAR output[20];

	_stprintf(output,_T("%-10d"),scan_totalFileCount + scan_rejectCount+scan_skipCount+scan_filterCount);
	GetDlgItem(IDC_SCAN_DETAIL_TOTAL)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),scan_audioCount);
	//GetDlgItem(IDC_SCAN_DETAIL_AUDIO)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),scan_videoCount);
	//GetDlgItem(IDC_SCAN_DETAIL_VIDEO)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),scan_imageCount);
	//GetDlgItem(IDC_SCAN_DETAIL_PICTURE)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),scan_filterCount);
	//GetDlgItem(IDC_SCAN_DETAIL_FILTER)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),scan_playlistCount/2);
	//GetDlgItem(IDC_SCAN_DETAIL_PLAYLIST)->SetWindowText(output);

	// Check whether we have initialized this value in scanfile or not
	if (inScanFiles)
	{
		CTimeSpan elapsedTime = 0;
		CTime endTime;

		endTime = CTime::GetCurrentTime();
		elapsedTime = endTime - m_startTime;

		_stprintf(output,_T("%02d:%02d:%02d") ,elapsedTime.GetHours() ,elapsedTime.GetMinutes() , elapsedTime.GetSeconds());
		GetDlgItem(IDC_SCAN_DETAIL_TIME)->SetWindowText(output);
	}

	_stprintf(output,_T("%-10d"),scan_rejectCount);
	//GetDlgItem(IDC_SCAN_DETAIL_REJECTED)->SetWindowText(output);

	_stprintf(output,_T("%-10d"),scan_skipCount + scan_playlistCount/2);	// skip "*.lst" playlist
	//GetDlgItem(IDC_SCAN_DETAIL_SKIP)->SetWindowText(output);

	SetDlgItemText(IDC_STATIC_SCANFILE, currentScanFileName);
}

void CImportPage::OnTvnSelchangedTreeFilebrowser(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	HTREEITEM hParent = pNMTreeView->itemNew.hItem;
	CShellPidl pidlParent = m_TreeFileBrowser.GetItemIDList(hParent);

	GetDlgItem(IDC_STATIC_FILEBROWSER)->SetWindowText(pidlParent.GetPath());

	*pResult = 0;
}
