// MediafilesPage.cpp
//
//Birdy
#if 0
#include "stdafx.h"
#include "afxcview.h"
#include "resource.h"
#include "FolderUtils.h"
#include "HighColorTab.h"
#include "MediafilesPage.h"
#include "MediaInfoDialog.h"
#include "MessageBoxDlg.h"
#include "ImportPage.h"
#include "ado2.h"
#include "dbtools.h"
#include "Language.h"
#include "DMSService.h"
#include "ScanFiles.h"
#include "Utility.h"
#include "myGdiPlus.h"

using namespace Gdiplus; 

extern "C"
{
	#include "FileIoAbstraction.h"
	#include "FileSystemTree.h"
	#include "mystring.h"
	#include "debug.h"
}

extern "C" TCHAR	gWorkingDir[MAX_PATH_LENGTH];
extern int	inScanFiles;

//global
CMediafilesPage     *myMediafilesPage;

int needFreshMediaContent = TRUE;

// CMediafilesPage

IMPLEMENT_DYNAMIC(CMediafilesPage, CResizablePage)

CMediafilesPage::CMediafilesPage() : CResizablePage(CMediafilesPage::IDD)
{
	// Change the title of this page according to the OS language
	if (parseLangConfigOK)
	{
		m_psp.dwFlags |= PSP_USETITLE;
		m_psp.pszTitle = QueryLangStr(LANG_STR_MEDIAFILES);
	}

	m_indexUpdatePos = 0;
	m_indexCount = 0;
}

CMediafilesPage::~CMediafilesPage()
{
}

void CMediafilesPage::DoDataExchange(CDataExchange* pDX)
{
	CResizablePage::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CMediafilesPage)
	DDX_Control(pDX, IDC_MEDIA_LIST, m_Media_List);	
	DDX_Control(pDX, IDC_ALBUMS_LIST, m_Albums_List);	
	DDX_Control(pDX, IDC_ARTISTS_LIST, m_Artists_List);	
	DDX_Control(pDX, IDC_GENRE_LIST, m_Genre_List);	
	DDX_Control(pDX, IDC_CONTENT_LIST, m_Content_List);		
	DDX_Control(pDX, IDC_PIC_LIST, m_Pic_List);		
	DDX_Control(pDX, IDC_BUTTON_ADD_FILE, m_AddEn_Btn);	
	DDX_Control(pDX, IDC_BUTTON_DEL_FILE, m_DelEn_Btn);	
	DDX_Control(pDX, IDC_BUTTON_START_SERVICE, m_StartServiceButton);
	DDX_Control(pDX, IDC_BUTTON_STOP_SERVICE, m_StopServiceButton);
	//}}AFX_DATA_MAP
}

BOOL CMediafilesPage::InitGUI() 
{
	// TODO: Add extra initialization here
	CRect rect;
	InitTableImageList(m_Media_List,0);
	m_Media_List.GetClientRect(&rect);
	if (parseLangConfigOK)
		CMediafilesPage::m_Media_List.InsertColumn(0,  QueryLangStr(LANG_STR_TYPE));	
	else
		CMediafilesPage::m_Media_List.InsertColumn(0,  _T("Type"));	
	CMediafilesPage::m_Media_List.SetColumnWidth(0,rect.Width());
	LV_ITEM		listItem;
	//1
	listItem.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE;
	//lvitem.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE | LVIF_AUDIO | LVIF_VIDEO;
	listItem.state = 0;      
	listItem.stateMask = 0; 

	//listItem.mask      =  LVIF_TEXT | LVIF_IMAGE ;
	listItem.iItem     = 0;
	listItem.iSubItem  = 0;
	listItem.iImage = 0;
	if (parseLangConfigOK)
		listItem.pszText = QueryLangStr(LANG_STR_ALLMEDIA);
	else
		listItem.pszText = _T("All Media";)
	CMediafilesPage::m_Media_List.InsertItem(&listItem);
	
	//2	
	//listItem.mask      = LVIF_TEXT;
	listItem.iItem     = 1;
	listItem.iSubItem  = 0;
	listItem.iImage = 1;
	if (parseLangConfigOK)
		listItem.pszText = QueryLangStr(LANG_STR_ALLMUSIC);
	else
		listItem.pszText   = _T("All Music");	
	CMediafilesPage::m_Media_List.InsertItem(&listItem);
	//3
	//listItem.mask      = LVIF_TEXT;
	listItem.iItem     = 2;
	listItem.iSubItem  = 0;
	listItem.iImage = 2;
	if (parseLangConfigOK)
		listItem.pszText = QueryLangStr(LANG_STR_ALLVIDEO);
	else
		listItem.pszText   = _T("All Videos");	
	CMediafilesPage::m_Media_List.InsertItem(&listItem);
	//2	
	//listItem.mask      = LVIF_TEXT;
	listItem.iItem     = 3;
	listItem.iSubItem  = 0;
	listItem.iImage = 3;
	if (parseLangConfigOK)
		listItem.pszText = QueryLangStr(LANG_STR_ALLIMAGE);
	else
		listItem.pszText   = _T("All Image");	
	CMediafilesPage::m_Media_List.InsertItem(&listItem);

#ifdef OEM_ASUS
	listItem.iItem     = 4;
	listItem.iSubItem  = 0;
	listItem.iImage = 4;
	if (parseLangConfigOK)
		listItem.pszText = QueryLangStr(LANG_STR_MYFAVORITES);
	else
		listItem.pszText   = _T("My Favorites");	
	CMediafilesPage::m_Media_List.InsertItem(&listItem);
#endif

	// We set the default item in Media List is "AllMedia"
	mItemNumInMediaList = 0;
	
	InitTableImageList(m_Albums_List,1);
	m_Albums_List.GetClientRect(&rect);	
	if (parseLangConfigOK)
		CMediafilesPage::m_Albums_List.InsertColumn(0, QueryLangStr(LANG_STR_ALBUM));	
	else
		CMediafilesPage::m_Albums_List.InsertColumn(0,  _T("Album"));	
	CMediafilesPage::m_Albums_List.SetColumnWidth(0,rect.Width());

	InitTableImageList(m_Artists_List,2);
	m_Artists_List.GetClientRect(&rect);
	if (parseLangConfigOK)
		CMediafilesPage::m_Artists_List.InsertColumn(0, QueryLangStr(LANG_STR_ARTIST));	
	else
		CMediafilesPage::m_Artists_List.InsertColumn(0,  _T("Artist"));	
	CMediafilesPage::m_Artists_List.SetColumnWidth(0,rect.Width());

	InitTableImageList(m_Genre_List,3);
	m_Genre_List.GetClientRect(&rect);
	if (parseLangConfigOK)
		CMediafilesPage::m_Genre_List.InsertColumn(0, QueryLangStr(LANG_STR_GENRE));	
	else
		CMediafilesPage::m_Genre_List.InsertColumn(0,  _T("Genre"));	
	CMediafilesPage::m_Genre_List.SetColumnWidth(0,rect.Width());


	InitTableImageList(m_Content_List,0);
	LPARAM lStyle = m_Content_List.SendMessage(LVM_GETEXTENDEDLISTVIEWSTYLE);
	lStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES | LVS_EX_HEADERDRAGDROP;
	m_Content_List.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, 0,	(LPARAM)lStyle);
	LV_COLUMN lvc;

	lvc.mask = LVCF_TEXT | LVCF_SUBITEM | LVCF_WIDTH /*| LVCF_FMT*/;

	lvc.iSubItem = 0;
	if (parseLangConfigOK)
		lvc.pszText = QueryLangStr(LANG_STR_TITLE);
	else
		lvc.pszText = _T("Title");
    lvc.cx = 200;
	m_Content_List.InsertColumn(0,&lvc);

	lvc.iSubItem = 1;
	if (parseLangConfigOK)
		lvc.pszText = QueryLangStr(LANG_STR_ARTIST);
	else
		lvc.pszText = _T("Artist");
	lvc.cx = 100;
	m_Content_List.InsertColumn(1,&lvc);

	lvc.iSubItem = 2;
	if (parseLangConfigOK)
		lvc.pszText = QueryLangStr(LANG_STR_ALBUM);
	else
		lvc.pszText = _T("Album");
	lvc.cx = 100;
	m_Content_List.InsertColumn(2,&lvc);

	lvc.iSubItem = 3;
	if (parseLangConfigOK)
		lvc.pszText = QueryLangStr(LANG_STR_GENRE);
	else
		lvc.pszText = _T("Genre");
	lvc.cx = 100;
	m_Content_List.InsertColumn(3,&lvc);

	lvc.iSubItem = 4;
	if (parseLangConfigOK)
		lvc.pszText = QueryLangStr(LANG_STR_TRACKNO);
	else
		lvc.pszText = _T("Track No.");
	lvc.cx = 100;
	m_Content_List.InsertColumn(4,&lvc);

	lvc.iSubItem = 5;
	if (parseLangConfigOK)
		lvc.pszText = QueryLangStr(LANG_STR_DURATION);
	else
		lvc.pszText = _T("Duration");
	lvc.cx = 100;
	m_Content_List.InsertColumn(5,&lvc);

	lvc.iSubItem = 6;
	if (parseLangConfigOK)
		lvc.pszText = QueryLangStr(LANG_STR_FILEPATH);
	else
		lvc.pszText = _T("FilePath");
	lvc.cx = 100;
	m_Content_List.InsertColumn(6,&lvc);

	lvc.iSubItem = 7;
	if (parseLangConfigOK)
		lvc.pszText = QueryLangStr(LANG_STR_TYPE);
	else
		lvc.pszText = _T("Type");
	lvc.cx = 50;
	m_Content_List.InsertColumn(7,&lvc);

	return TRUE;  
}

BOOL CMediafilesPage::OnInitDialog()
{
	CResizablePage::OnInitDialog();

#ifndef OEM_ASUS
	GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_BUTTON_DEL_FILE)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_BUTTON_ADD_FILE)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_BUTTON_START_SERVICE)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_BUTTON_STOP_SERVICE)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_STATIC_BUTTON_GROUP)->ShowWindow(SW_HIDE);
#endif

	AddAnchor(IDC_MEDIA_LIST, TOP_LEFT, ANCHOR(40,40));
	AddAnchor(IDC_PIC_LIST, ANCHOR(0,50), ANCHOR(40,90));
	AddAnchor(IDD_STATIC_MEDIAFILES_THUMBNAIL_VIEW , ANCHOR(0,40), ANCHOR(40,50));
	AddAnchor(IDC_ALBUMS_LIST, ANCHOR(40,0), ANCHOR(60,30));
	AddAnchor(IDC_ARTISTS_LIST, ANCHOR(60,0), ANCHOR(80,30));
	AddAnchor(IDC_GENRE_LIST, ANCHOR(80,0), ANCHOR(100,30));	
	AddAnchor(IDC_CONTENT_LIST, ANCHOR(40,30), ANCHOR(100,90));

	AddAnchor(IDC_STATIC_BUTTON_GROUP, ANCHOR(0,90), BOTTOM_RIGHT);
	AddAnchor(IDC_BUTTON_START_SERVICE, ANCHOR(10,92));
	AddAnchor(IDC_BUTTON_STOP_SERVICE, ANCHOR(20,92));
	AddAnchor(IDC_BUTTON_CLEAR_DATABASE, ANCHOR(30,92));
	AddAnchor(IDC_BUTTON_ADD_MYFAVORITES, ANCHOR(40,92));
	AddAnchor(IDC_BUTTON_DEL_FILE, ANCHOR(60,92));
	AddAnchor(IDC_BUTTON_ADD_FILE, ANCHOR(70,92));
	AddAnchor(IDC_BUTTON_EDIT_FILE_INFO, ANCHOR(80,92));	

#ifdef OEM_ASUS
	AddAnchor(IDC_STATIC_Logo,TOP_LEFT,TOP_LEFT);
#endif // OEM_ASUS

	myMediafilesPage = this;
	isInitFinished = FALSE;

	InitGUI();

	isInitFinished = TRUE;

	m_ImageListThumb.Create(THUMBNAIL_WIDTH, THUMBNAIL_HEIGHT, ILC_COLOR32, 0, 1);

	m_Pic_List.SetImageList(&m_ImageListThumb, LVSIL_NORMAL);

	// Change the strings in this dialog according to OS language
	if (parseLangConfigOK)
	{
		GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->SetWindowText(QueryLangStr(LANG_STR_MEDIAINFO));
		GetDlgItem(IDC_BUTTON_DEL_FILE)->SetWindowText(QueryLangStr(LANG_STR_DEL));
		GetDlgItem(IDC_BUTTON_ADD_FILE)->SetWindowText(QueryLangStr(LANG_STR_ADD));
		GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->SetWindowText(QueryLangStr(LANG_STR_ADDMYFAVORITES));
		GetDlgItem(IDD_STATIC_MEDIAFILES_THUMBNAIL_VIEW)->SetWindowText(QueryLangStr(LANG_STR_THUMBNAILVIEW));
		GetDlgItem(IDC_BUTTON_START_SERVICE)->SetWindowText(QueryLangStr(LANG_STR_STARTSERVICE));
		GetDlgItem(IDC_BUTTON_STOP_SERVICE)->SetWindowText(QueryLangStr(LANG_STR_STOPSERVICE));
		GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->SetWindowText(QueryLangStr(LANG_STR_CLEARDATABASE));
	}

#ifdef OEM_ASUS
	m_StartServiceButton.SetIconID(IDI_START_SERVICE_BUTTON);
	m_StopServiceButton.SetIconID(IDI_STOP_SERVICE_BUTTON);
#endif

	return TRUE;  	
}

BOOL CMediafilesPage::OnSetActive() 
{
	if (needFreshMediaContent)
	{
		// Refresh content list because scan file thread add new data into database
		UpdateMediaList(mItemNumInMediaList);
		needFreshMediaContent = FALSE;
	}

	((CPropertySheet*)GetParent())->SetWizardButtons(PSWIZB_BACK | PSWIZB_NEXT);

	if (IsDMSRunning())
	{
		GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_ADD_FILE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_DEL_FILE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_ADD_FILE)->EnableWindow(FALSE);

		GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_STOP_SERVICE)->EnableWindow(TRUE);
	}
	else
	{
		if (inScanFiles)
		{
			GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_DEL_FILE)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_ADD_FILE)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);
		}
		else
		{
			GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_DEL_FILE)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_ADD_FILE)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_BUTTON_STOP_SERVICE)->EnableWindow(FALSE);
	}

	// Delete thumbnail to avoid showing deleted files
	m_Pic_List.DeleteAllItems();

	return CResizablePage::OnSetActive();
}


BEGIN_MESSAGE_MAP(CMediafilesPage, CResizablePage)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_MEDIA_LIST, OnLvnItemchangedMediaList)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_ALBUMS_LIST, OnLvnItemchangedAlbumsList)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_ARTISTS_LIST, OnLvnItemchangedArtistsList)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_GENRE_LIST, OnLvnItemchangedGenreList)
	ON_NOTIFY(HDN_ITEMDBLCLICK, 0, OnHdnItemdblclickContentList)
	ON_NOTIFY(LVN_ITEMCHANGING, IDC_CONTENT_LIST, OnLvnItemchangingContentList)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_CONTENT_LIST, OnLvnItemchangedContentList)
	ON_NOTIFY(LVN_ITEMACTIVATE, IDC_CONTENT_LIST, OnLvnItemActivateContentList)
	ON_NOTIFY(NM_RCLICK, IDC_CONTENT_LIST, OnNMRclickContentList)
	ON_BN_CLICKED(IDC_BUTTON_EDIT_FILE_INFO, OnBnClickedButtonEditFileInfo)
	ON_BN_CLICKED(IDC_BUTTON_DEL_FILE, OnBnClickedButtonDel)
	ON_BN_CLICKED(IDC_BUTTON_ADD_FILE, OnBnClickedButtonAdd)
	ON_BN_CLICKED(IDC_BUTTON_START_SERVICE, OnBnClickedButtonStartService)
	ON_BN_CLICKED(IDC_BUTTON_STOP_SERVICE, OnBnClickedButtonStopService)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_DATABASE, OnBnClickedButtonClearDatabase)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_PIC_LIST, OnLvnItemchangedPicList)
	ON_BN_CLICKED(IDC_BUTTON_ADD_MYFAVORITES, OnBnClickedButtonAddMyfavorites)
END_MESSAGE_MAP()


// CMediafilesPage

void CMediafilesPage::RefreshMediaContentList() 
{
	if (needFreshMediaContent)
	{
		// Refresh content list because scan file thread add new data into database
		UpdateMediaList(mItemNumInMediaList);
		needFreshMediaContent = FALSE;
	}
}

BOOL CMediafilesPage::UpdateArtist(const TCHAR *SQLstring) 
{
	CRect rect;
	CADORecordset* pRs = new CADORecordset(g_pDb);
	CString TempSql;
	TCHAR temp[20];
	int j,i = -1;
    LVCOLUMN artistColumn;
	m_Artists_List.DeleteAllItems();
	
	//if(pRs->Open((LPCTSTR)"SELECT distinct Author FROM FSE_QueryState where ObjectType = 1 and FileType = \"Audio\" and author <> \"\"") )
	while (WaitForSingleObject(hDBMutex, 100L) != WAIT_OBJECT_0)
		Sleep(100);	

	if(pRs->Open(SQLstring))
	{
		pRs->SetSort(_T("Author"));
		int count=pRs->GetRecordCount();

		artistColumn.mask = LVCF_TEXT;
		if (parseLangConfigOK)
			_stprintf(temp, _T("%s(%d)"), QueryLangStr(LANG_STR_ARTIST), count);
		else
			_stprintf(temp,_T("Artist(%d)"),count);
		artistColumn.pszText = temp;
		CMediafilesPage::m_Artists_List.SetColumn(0,&artistColumn);

		for(j=0;j<count;j++)
		{
			pRs->GetFieldValue(_T("Author"),TempSql);
			if(TempSql.IsEmpty())
				;
			else {
				CMediafilesPage::m_Artists_List.InsertItem(j+1, TempSql);	
			}

			pRs->MoveNext();
		}
		pRs->Close();
	}
	else
		AfxMessageBox(_T("Database doesn't exist"));

	delete pRs;	
	ReleaseMutex(hDBMutex);
	return TRUE;  
}

BOOL CMediafilesPage::UpdateAlbum(const TCHAR *SQLstring)  
{
	CRect rect;
	CADORecordset* pRs = new CADORecordset(g_pDb);
	CString TempSql;
	TCHAR temp[20];
	int j,i = -1;

	LVCOLUMN artistColumn;

	m_Albums_List.DeleteAllItems();
	
	//
	// initial m_Genre_List ,by albert 20050311
	//
	//if(pRs->Open((LPCTSTR)"SELECT distinct Genre FROM FSE_QueryState where ObjectType = 1 and Genre <> \"\"") )
	while (WaitForSingleObject(hDBMutex, 100L) != WAIT_OBJECT_0)
		Sleep(100);

	if(pRs->Open(SQLstring))
	{
		pRs->SetSort(_T("Album"));
		int count=pRs->GetRecordCount()
			;
		artistColumn.mask = LVCF_TEXT;
		if (parseLangConfigOK)
			_stprintf(temp, _T("%s(%d)"), QueryLangStr(LANG_STR_ALBUM), count);
		else
			_stprintf(temp,_T("Album(%d)"),count);
		artistColumn.pszText = temp;
		CMediafilesPage::m_Albums_List.SetColumn(0,&artistColumn);

		for(j=0;j<count;j++)
		{
			pRs->GetFieldValue(_T("Album"),TempSql);
			if(TempSql.IsEmpty())
				;
			else {
				CMediafilesPage::m_Albums_List.InsertItem(j+1, TempSql);	
			}
			pRs->MoveNext();
		}
		pRs->Close();
	}
	else
		AfxMessageBox(_T("Database doesn't exist"));

	delete pRs;	
	ReleaseMutex(hDBMutex);
	return TRUE;  
}


BOOL CMediafilesPage::UpdateGenre(const TCHAR *SQLstring)  
{
	CRect rect;
	CADORecordset* pRs = new CADORecordset(g_pDb);
	CString TempSql;
	TCHAR temp[20];
	int j,i = -1;

	LVCOLUMN artistColumn;
	m_Genre_List.DeleteAllItems();

	while (WaitForSingleObject(hDBMutex, 100L) != WAIT_OBJECT_0)
		Sleep(100);

	if(pRs->Open(SQLstring))
	{
		pRs->SetSort(_T("Genre"));
		int count=pRs->GetRecordCount();
		
		artistColumn.mask = LVCF_TEXT;
		if (parseLangConfigOK)
			_stprintf(temp, _T("%s(%d)"), QueryLangStr(LANG_STR_GENRE), count);
		else
			_stprintf(temp,_T("Genre(%d)"),count);
		artistColumn.pszText = temp;
		CMediafilesPage::m_Genre_List.SetColumn(0,&artistColumn);

		for(j=0;j<count;j++)
		{
			pRs->GetFieldValue(_T("Genre"),TempSql);
			if(TempSql.IsEmpty())
				;
			else {
				CMediafilesPage::m_Genre_List.InsertItem(j+1, TempSql);	
			}
			pRs->MoveNext();
		}
		pRs->Close();
	}
	else
		AfxMessageBox(_T("Database doesn't exist"));

	delete pRs;	
	ReleaseMutex(hDBMutex);
	return TRUE;  
}

BOOL CMediafilesPage::UpdateContent(const TCHAR *SQLstring)  
{
	LVCOLUMN contentColumn;
	LV_ITEM lvitem;
	TCHAR	temp[MAX_PATH_LENGTH];
	int		i, hours, mins, seconds, count;

	isInitFinished= FALSE;
	
	m_Content_List.DeleteAllItems();
	m_Content_List.SetRedraw(FALSE);
	_tcscpy(m_SQLstring, SQLstring);
	m_indexCount = db_getCountT(SQLstring);

	contentColumn.mask = LVCF_TEXT;
	if (parseLangConfigOK)
	{
		_stprintf(temp, _T("%s(%d)"), QueryLangStr(LANG_STR_TITLE), m_indexCount);
	}
	else
	{
		_stprintf(temp,_T("Title(%d)"), m_indexCount);
	}

	// update the title header without files no.
	contentColumn.pszText = temp;
	m_Content_List.SetColumn(0, &contentColumn);
	lvitem.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE;
	lvitem.state = 0;      
	lvitem.stateMask = 0; 
	lvitem.iSubItem = 0;
	lvitem.cchTextMax = MAX_PATH;

	m_indexUpdatePos = 0;
	if (m_indexUpdatePos < m_indexCount)
	{
		// The remain count
		count = m_indexCount - m_indexUpdatePos;
		if (count > MAX_READ_COUNT_FOR_BROWSE)
		{
			// Set max read count as MAX_READ_COUNT_FOR_BROWSE
			count = MAX_READ_COUNT_FOR_BROWSE;
		}
		count = db_getRecordsT(SQLstring, FSE_QS, m_indexUpdatePos, count);

		for (i = 0; i < count; m_indexUpdatePos++, i++)
		{
			lvitem.iItem = m_indexUpdatePos;
			lvitem.pszText =_itot(m_indexUpdatePos, temp, 10);
			if (_tcscmp( (TCHAR *) FSE_QS[i].FileType, _T("Audio")) ==0)
			{
				lvitem.iImage = 1;
			}
			else if (_tcscmp( (TCHAR *) FSE_QS[i].FileType,_T("Video")) ==0)
			{
				lvitem.iImage = 2;
			}
			else if (_tcscmp( (TCHAR *) FSE_QS[i].FileType,_T("Image")) ==0)
			{
				lvitem.iImage = 3;
			}
			m_Content_List.InsertItem(&lvitem);

			m_Content_List.SetItemText(m_indexUpdatePos, 0, (TCHAR *) FSE_QS[i].Title);
			m_Content_List.SetItemText(m_indexUpdatePos, 1, (TCHAR *) FSE_QS[i].Author);
			m_Content_List.SetItemText(m_indexUpdatePos, 2, (TCHAR *) FSE_QS[i].Album);
			m_Content_List.SetItemText(m_indexUpdatePos, 3, (TCHAR *) FSE_QS[i].Genre);

			_stprintf(temp, _T("%d"), FSE_QS[i].TrackNumber);
			m_Content_List.SetItemText(m_indexUpdatePos, 4, temp);

			if (FSE_QS[i].Duration != 0)
			{
				hours = FSE_QS[i].Duration / 3600;
				mins = FSE_QS[i].Duration / 60;
				seconds = FSE_QS[i].Duration % 60;
			}
			else
			{
				hours = mins = seconds = 0;
			}
			_stprintf(temp,_T("%02d:%02d:%02d"),hours, mins, seconds);
			m_Content_List.SetItemText(m_indexUpdatePos, 5, temp);
			m_Content_List.SetItemText(m_indexUpdatePos, 6, (TCHAR *) FSE_QS[i].FilePath);
			m_Content_List.SetItemText(m_indexUpdatePos, 7, (TCHAR *) FSE_QS[i].FileType);
		}
	}

	m_Content_List.SetRedraw(TRUE);
	isInitFinished = TRUE;

	return TRUE;  
}

void CMediafilesPage::UpdateContentPartial()  
{
	LV_ITEM lvitem;
	TCHAR	temp[MAX_PATH_LENGTH];
	int		i, hours, mins, seconds, count;

	if (m_indexUpdatePos < m_indexCount)
	{
		m_Content_List.SetRedraw(FALSE);
		lvitem.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE;
		lvitem.state = 0;      
		lvitem.stateMask = 0; 
		lvitem.iSubItem = 0;
		lvitem.cchTextMax = MAX_PATH;

		count = m_indexCount - m_indexUpdatePos;		// The remain count
		if (count > MAX_READ_COUNT_FOR_BROWSE)
		{
			// Set max read count as MAX_READ_COUNT_FOR_BROWSE
			count = MAX_READ_COUNT_FOR_BROWSE;
		}
		count = db_getRecordsT(m_SQLstring, FSE_QS, m_indexUpdatePos, MAX_READ_COUNT_FOR_BROWSE);

		for (i = 0; i < count; m_indexUpdatePos++, i++)
		{
			lvitem.iItem = m_indexUpdatePos;
			lvitem.pszText =_itot(m_indexUpdatePos, temp, 10);
			if (_tcscmp( (TCHAR *) FSE_QS[i].FileType, _T("Audio")) ==0)
			{
				lvitem.iImage = 1;
			}
			else if (_tcscmp( (TCHAR *) FSE_QS[i].FileType,_T("Video")) ==0)
			{
				lvitem.iImage = 2;
			}
			else if (_tcscmp( (TCHAR *) FSE_QS[i].FileType,_T("Image")) ==0)
			{
				lvitem.iImage = 3;
			}
			m_Content_List.InsertItem(&lvitem);

			m_Content_List.SetItemText(m_indexUpdatePos, 0, (TCHAR *) FSE_QS[i].Title);
			m_Content_List.SetItemText(m_indexUpdatePos, 1, (TCHAR *) FSE_QS[i].Author);
			m_Content_List.SetItemText(m_indexUpdatePos, 2, (TCHAR *) FSE_QS[i].Album);
			m_Content_List.SetItemText(m_indexUpdatePos, 3, (TCHAR *) FSE_QS[i].Genre);

			_stprintf(temp, _T("%d"), FSE_QS[i].TrackNumber);
			m_Content_List.SetItemText(m_indexUpdatePos, 4, temp);

			if (FSE_QS[i].Duration != 0)
			{
				hours = FSE_QS[i].Duration / 3600;
				mins = FSE_QS[i].Duration / 60;
				seconds = FSE_QS[i].Duration % 60;
			}
			else
			{
				hours = mins = seconds = 0;
			}
			_stprintf(temp,_T("%02d:%02d:%02d"),hours, mins, seconds);
			m_Content_List.SetItemText(m_indexUpdatePos, 5, temp);
			m_Content_List.SetItemText(m_indexUpdatePos, 6, (TCHAR *) FSE_QS[i].FilePath);
			m_Content_List.SetItemText(m_indexUpdatePos, 7, (TCHAR *) FSE_QS[i].FileType);
		}
		
		m_Content_List.SetRedraw(TRUE);
	}
}

void CMediafilesPage::UpdateMediaList(int itemNum)  
{
	CString str;
	TCHAR strSQL[255];

	str = m_Media_List.GetItemText(itemNum,0);

	if(itemNum == 0) // All media
	{
		_stprintf(strSQL,_T("SELECT distinct Author FROM FSE_QueryState where ObjectType = 1 and author <> \"\"  and Favorite = 0"));
		UpdateArtist(strSQL) ;
		_stprintf(strSQL,_T("SELECT distinct Album FROM FSE_QueryState where ObjectType = 1 and Album <> \"\"  and Favorite = 0"));
		UpdateAlbum(strSQL) ; 
		_stprintf(strSQL,_T("SELECT distinct Genre FROM FSE_QueryState where ObjectType = 1 and Genre <> \"\"  and Favorite = 0"));
		UpdateGenre(strSQL);
		_stprintf(strSQL,_T("SELECT * FROM FSE_QueryState where ObjectType = 1 and Favorite = 0 and (pIndex=4 or pIndex=7 or pIndex=13)"));
		UpdateContent(strSQL) ;
	}
	else if(itemNum == 1) // My Music
	{
		_stprintf(strSQL,_T("SELECT distinct Author FROM FSE_QueryState where ObjectType = 1 and FileType = \"Audio\" and author <> \"\"  and Favorite = 0"));
		UpdateArtist(strSQL) ;
		_stprintf(strSQL,_T("SELECT distinct Album FROM FSE_QueryState where ObjectType = 1 and FileType = \"Audio\" and Album <> \"\"  and Favorite = 0"));
		UpdateAlbum(strSQL) ; 
		_stprintf(strSQL,_T("SELECT distinct Genre FROM FSE_QueryState where ObjectType = 1 and FileType = \"Audio\" and Genre <> \"\"  and Favorite = 0"));
		UpdateGenre(strSQL);
		_stprintf(strSQL,_T("SELECT * FROM FSE_QueryState where ObjectType = 1 and FileType = \"Audio\" and Favorite = 0 and pIndex=7"));
		UpdateContent(strSQL) ;
	}
	else if(itemNum == 2) // My Video
	{
		ClearArtistAlbumGenre();
		_stprintf(strSQL,_T("SELECT * FROM FSE_QueryState where ObjectType = 1 and FileType = \"Video\"  and Favorite = 0 and pIndex=4"));
		UpdateContent(strSQL) ;
	}
	else if(itemNum == 3) // My Image
	{
		ClearArtistAlbumGenre();
		_stprintf(strSQL,_T("SELECT * FROM FSE_QueryState where ObjectType = 1 and FileType = \"Image\" and Favorite = 0 and pIndex=13"));
		UpdateContent(strSQL) ;
	}
	else if(itemNum == 4) // My Favorites
	{
		_stprintf(strSQL,_T("SELECT distinct Author FROM FSE_QueryState where ObjectType = 1 and FileType = \"Audio\" and author <> \"\"  and Favorite = 1"));
		UpdateArtist(strSQL) ;
		_stprintf(strSQL,_T("SELECT distinct Album FROM FSE_QueryState where ObjectType = 1 and FileType = \"Audio\" and Album <> \"\"  and Favorite = 1"));
		UpdateAlbum(strSQL) ; 
		_stprintf(strSQL,_T("SELECT distinct Genre FROM FSE_QueryState where ObjectType = 1 and FileType = \"Audio\" and Genre <> \"\"  and Favorite = 1"));
		UpdateGenre(strSQL);
		_stprintf(strSQL,_T("SELECT * FROM FSE_QueryState where ObjectType = 1 and Favorite = 1"));
		UpdateContent(strSQL) ;
	}
}


BOOL CMediafilesPage::ClearArtistAlbumGenre()
{
	LVCOLUMN artistColumn;

	isInitFinished= FALSE;

	m_Content_List.DeleteAllItems();
	m_Artists_List.DeleteAllItems();
	m_Albums_List.DeleteAllItems();
	m_Genre_List.DeleteAllItems();

	// We will blank the names of fields
	artistColumn.mask = LVCF_TEXT;
	if (parseLangConfigOK)
		artistColumn.pszText =  QueryLangStr(LANG_STR_ARTIST);
	else
		artistColumn.pszText =  _T("Artist");
	CMediafilesPage::m_Artists_List.SetColumn(0,&artistColumn);

	if (parseLangConfigOK)
		artistColumn.pszText =  QueryLangStr(LANG_STR_ALBUM);
	else
		artistColumn.pszText =  _T("Album");
	CMediafilesPage::m_Albums_List.SetColumn(0,&artistColumn);

	if (parseLangConfigOK)
		artistColumn.pszText =  QueryLangStr(LANG_STR_GENRE);
	else
		artistColumn.pszText =  _T("Genre");
	CMediafilesPage::m_Genre_List.SetColumn(0,&artistColumn);

	isInitFinished = TRUE;

	return TRUE;  
}


// when change media list
void CMediafilesPage::OnLvnItemchangedMediaList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	int itemNum = pNMLV->iItem;

	// Save this value for refresh Media List
	mItemNumInMediaList = itemNum;
	UpdateMediaList(itemNum);

	*pResult = 0;
}


// when change Album list
void CMediafilesPage::OnLvnItemchangedAlbumsList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	CString str;
	int itemNum = pNMLV->iItem;
	TCHAR strSQL[255];

	str=m_Albums_List.GetItemText(itemNum,0);

	//albert, for bug #25
	/* 
	sprintf(strSQL,"SELECT distinct Author FROM FSE_QueryState where ObjectType = 1 and Album = \"%s\"\0",str);
	UpdateArtist((const char *)strSQL) ;
	sprintf(strSQL,"SELECT distinct Genre FROM FSE_QueryState where ObjectType = 1 and Album = \"%s\"\0",str);
	UpdateGenre((const char *)strSQL);
	*/
	//WideCharToMultiByte(950, 0, str.GetString(), -1, cMediaStr, MAX_MEDIA_STR_LENGTH, NULL, NULL);
	_stprintf(strSQL,_T("SELECT * FROM FSE_QueryState where ObjectType = 1 and (pIndex=4 or pIndex=7) and Album = \"%s\"\0"),str);
	UpdateContent(strSQL) ;
	

	*pResult = 0;
}

// when change Artists list
void CMediafilesPage::OnLvnItemchangedArtistsList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	CString str;
	int itemNum = pNMLV->iItem;
	TCHAR strSQL[255];

	str=m_Artists_List.GetItemText(itemNum,0);
	_stprintf(strSQL,_T("SELECT * FROM FSE_QueryState where ObjectType = 1 and (pIndex=4 or pIndex=7) and Author = \"%s\""),str);
	UpdateContent(strSQL) ;


	*pResult = 0;
}

// when change Genre list
void CMediafilesPage::OnLvnItemchangedGenreList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	CString str;
	int itemNum = pNMLV->iItem;
	TCHAR strSQL[255];

	str=m_Genre_List.GetItemText(itemNum,0);
	_stprintf(strSQL,_T("SELECT * FROM FSE_QueryState where ObjectType = 1 and (pIndex=4 or pIndex=7) and  Genre = \"%s\""),str);
	UpdateContent(strSQL) ;
	
	*pResult = 0;
}

void CMediafilesPage::OnHdnItemdblclickContentList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
	*pResult = 0;
}

void CMediafilesPage::OnLvnItemchangingContentList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	*pResult = 0;
}

void CMediafilesPage::OnLvnItemchangedContentList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	static BOOL needShowText = FALSE;
	
	if (isInitFinished)
	{
		POSITION pos = m_Content_List.GetFirstSelectedItemPosition();

		if (pos != NULL)
		{
			int	nItem = m_Content_List.GetNextSelectedItem(pos);
			CString str = m_Content_List.GetItemText(nItem, 7);

			if (str.CompareNoCase(_T("Image"))==0)
			{
				ShowThumbnail();
				needShowText = TRUE;
			}
			else
			{
				if(needShowText == TRUE)
				{
					myMediafilesPage->m_Pic_List.DeleteAllItems();
					needShowText = FALSE;
				}
			}
		}
	}

	*pResult = 0;
}

void CMediafilesPage::OnLvnItemActivateContentList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	*pResult = 0;
}

void CMediafilesPage::OnNMRclickContentList(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;
}

// Edit MP3 File Tag Info
void CMediafilesPage::OnBnClickedButtonEditFileInfo()
{
	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_DEL_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->m_hWnd);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->m_hWnd);

	CMediaInfoDialog MediaInfoDialog;
	MediaInfoDialog.DoModal();

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->m_hWnd);
}

// Press the "delete" button
void CMediafilesPage::OnBnClickedButtonDel()
{
	POSITION	pos;
	int			nitem;

	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->m_hWnd);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_DEL_FILE)->m_hWnd);

	pos = m_Content_List.GetFirstSelectedItemPosition();
	while (pos)
	{
		CString		deletedFilePath;

		//delete from database
		nitem = m_Content_List.GetNextSelectedItem(pos);
		deletedFilePath = m_Content_List.GetItemText(nitem ,6);

		if (mItemNumInMediaList == 4)
		{
			// We are in MyFavorite folder, so we only need to remove the item with Favorite flag set
			DeleteOneFileFromDB(deletedFilePath, TRUE);
		}
		else
		{
			DeleteOneFileFromDB(deletedFilePath, FALSE);
		}
	}

	// remove deleted items from content list
	pos = m_Content_List.GetFirstSelectedItemPosition();
	while (pos)
	{			
		nitem = m_Content_List.GetNextSelectedItem(pos);

		//delete from database
		m_Content_List.DeleteItem(nitem);
	}

	UpdateMediaList(mItemNumInMediaList);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_DEL_FILE)->m_hWnd);
}

// add a new file into Database
void CMediafilesPage::OnBnClickedButtonAdd()
{
	CFileDialog	dlgFile(TRUE, NULL, NULL, OFN_ALLOWMULTISELECT);
	POSITION	pos;

	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_DEL_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->m_hWnd);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_FILE)->m_hWnd);

	dlgFile.m_ofn.Flags |= OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_ALLOWMULTISELECT;
	dlgFile.m_ofn.lpstrFilter = _T("");
	dlgFile.m_ofn.lpstrTitle = _T("Open media file");

	if (dlgFile.DoModal() != IDOK)
	{
		// User cancel the action
		return;
	}

	pos = dlgFile.GetStartPosition();
	while (pos)
	{
		CString		newFilePath;

		newFilePath = dlgFile.GetNextPathName(pos);
		AddOneFileToDB(newFilePath);
	}

	UpdateMediaList(mItemNumInMediaList);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_FILE)->m_hWnd);
}

BOOL CMediafilesPage::PromptForFileName(CString& fileName, UINT nIDSTitle, 
										DWORD dwFlags, BOOL bOpenFileDialog, int* pType)
{
	// Can use shift to do multiple selection
	CFileDialog dlgFile(bOpenFileDialog, NULL, NULL, OFN_ALLOWMULTISELECT);
	CString title;
	if (bOpenFileDialog) title="Open media file"; else title="Save media file";

	dlgFile.m_ofn.Flags |= dwFlags;


	int nDocType = (pType != NULL) ? *pType : 1;//CXIMAGE_FORMAT_BMP;

	CString strFilter="";
	dlgFile.m_ofn.lpstrFilter = strFilter;
	dlgFile.m_ofn.lpstrTitle = title;
	dlgFile.m_ofn.lpstrFile = fileName.GetBuffer(_MAX_PATH);

	BOOL bRet = (dlgFile.DoModal() == IDOK) ? TRUE : FALSE;
	fileName.ReleaseBuffer();
	if (bRet){
		/*
		if (pType != NULL){
		//int nIndex = (int)dlgFile.m_ofn.nFilterIndex - 1;
		//ASSERT(nIndex >= 0);
		//*pType = GetTypeFromIndex(nIndex, bOpenFileDialog);
		}
		*/
	}
	return bRet;
}

void CMediafilesPage::InitTableImageList(HWND hTableList,int listType)
{
	HINSTANCE hInst = AfxGetInstanceHandle();	
	int MAX_LISTITEM = 5 ;
	HICON hIcon;
	HIMAGELIST hImageList, hImageNormal;
	hImageNormal = ImageList_Create(32, 32, ILC_COLOR8 | ILC_MASK, (MAX_LISTITEM + 1), 1);
	hImageList = ImageList_Create(16, 16, ILC_COLOR8 | ILC_MASK, (MAX_LISTITEM + 1), 1);
	
	if(listType == 0) // media list and content list
	{
		hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_ALLMEDIA));
		ImageList_AddIcon(hImageNormal, hIcon);
		ImageList_AddIcon(hImageList, hIcon);
		DestroyIcon(hIcon);

		hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_AUDIO));
		ImageList_AddIcon(hImageNormal, hIcon);
		ImageList_AddIcon(hImageList, hIcon);
		DestroyIcon(hIcon);

		hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_VIDEO));
		ImageList_AddIcon(hImageNormal, hIcon);
		ImageList_AddIcon(hImageList, hIcon);
		DestroyIcon(hIcon);

		hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_PHOTO));
		ImageList_AddIcon(hImageNormal, hIcon);
		ImageList_AddIcon(hImageList, hIcon);
		DestroyIcon(hIcon);

		hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_MYFAVORATE));
		ImageList_AddIcon(hImageNormal, hIcon);
		ImageList_AddIcon(hImageList, hIcon);
		DestroyIcon(hIcon);
	}

	if(listType == 1) // ARTISTS list
	{
			hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_ALBUM));
			ImageList_AddIcon(hImageNormal, hIcon);
			ImageList_AddIcon(hImageList, hIcon);
			DestroyIcon(hIcon);
	}

	if(listType == 2) // ALBUM list
	{
		hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_ARTIST));
		ImageList_AddIcon(hImageNormal, hIcon);
		ImageList_AddIcon(hImageList, hIcon);
		DestroyIcon(hIcon);
	}

	if(listType == 3) // GENRE list
	{
		hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON_GENRE));
		ImageList_AddIcon(hImageNormal, hIcon);
		ImageList_AddIcon(hImageList, hIcon);
		DestroyIcon(hIcon);
	}

	::SendMessage(hTableList, LVM_SETIMAGELIST, LVSIL_NORMAL, (LPARAM)hImageNormal);
	::SendMessage(hTableList, LVM_SETIMAGELIST, LVSIL_SMALL, (LPARAM)hImageList);
}


void CMediafilesPage::OnLvnItemchangedPicList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	*pResult = 0;
}


// add a favorite file into database
void CMediafilesPage::OnBnClickedButtonAddMyfavorites()
{
	POSITION	pos;

	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_DEL_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->m_hWnd);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->m_hWnd);

	pos = myMediafilesPage->m_Content_List.GetFirstSelectedItemPosition();
	while (pos)
	{
		CString		filePath;
		int			nitem;

		nitem = m_Content_List.GetNextSelectedItem(pos);
		filePath = m_Content_List.GetItemText(nitem, 6);
		AddMyFavoriteFileToDB(filePath);
	}

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->m_hWnd);
}


void CMediafilesPage::OnBnClickedButtonStartService()
{
	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_DEL_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->m_hWnd);

	if (!IsDMSRunning())
	{
		GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_DEL_FILE)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_ADD_FILE)->EnableWindow(FALSE);
		
		MediaServerStart();

		GetDlgItem(IDC_BUTTON_STOP_SERVICE)->EnableWindow(TRUE);
	}
}

void CMediafilesPage::OnBnClickedButtonStopService()
{
	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_DEL_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->m_hWnd);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->m_hWnd);

	if (IsDMSRunning())
	{
		GetDlgItem(IDC_BUTTON_STOP_SERVICE)->EnableWindow(FALSE);

		MediaServerStop();

		GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_DEL_FILE)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_ADD_FILE)->EnableWindow(TRUE);
	}
}

void CMediafilesPage::OnBnClickedButtonClearDatabase()
{
	INT_PTR		msgResult;

	if (parseLangConfigOK)
	{
		CMessageBoxDlg	msgBox(QueryLangStr(LANG_STR_CLEARDATABASE),
						   QueryLangStr(LANG_STR_CLEARDATABASEMSG),
						   QueryLangStr(LANG_STR_OK),
						   QueryLangStr(LANG_STR_CANCEL));
		msgResult = msgBox.DoModal();
	}
	else
	{
		CMessageBoxDlg	msgBox(_T("Clear Database"), 
							   _T("Do you really want to clear database ?"),
							   _T("OK"), _T("Cancel"));
		msgResult = msgBox.DoModal();
	}

	if (msgResult == IDCANCEL)
	{
		// user cancel the action
		return;
	}

	m_Pic_List.DeleteAllItems();

	// Solve the focus will lose if disable and renable these button
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_DEL_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_FILE)->m_hWnd);
	CLEAR_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->m_hWnd);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->m_hWnd);

	GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_DEL_FILE)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_ADD_FILE)->EnableWindow(FALSE);

	ClearAllFilesInDB();

	GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_ADD_MYFAVORITES)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_EDIT_FILE_INFO)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_DEL_FILE)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_ADD_FILE)->EnableWindow(TRUE);

	SET_DEF_PUSHBUTTON(GetDlgItem(IDC_BUTTON_CLEAR_DATABASE)->m_hWnd);
}

void CMediafilesPage::ShowThumbnail()
{
	CString		filePath,fileName; 
	POSITION	pos;
	int			nItem, destX = 0, destY = 0;

	pos = m_Content_List.GetFirstSelectedItemPosition();
	if (pos == NULL)
	{
		// No selection
		return;
	}

	nItem = m_Content_List.GetNextSelectedItem(pos);
	fileName = m_Content_List.GetItemText(nItem, 0);
	filePath = m_Content_List.GetItemText(nItem ,6);

	// clear the image in the list
	for (int i = 0; i < m_ImageListThumb.GetImageCount(); i++)
	{
		m_ImageListThumb.Remove(i);	
	}
	m_ImageListThumb.SetImageCount(1);

	m_Pic_List.DeleteAllItems();
	m_Pic_List.InsertItem(0, fileName, 0);

	if (IsFileTypeJ2K(fileName))
	{
		PROCESS_INFORMATION	pi;
		STARTUPINFO			si = {sizeof(si)};
		TCHAR				szCmdLine[MAX_PATH * 3], szOutFilePath[MAX_PATH];
		DWORD				dwExitCode;

		_stprintf(szOutFilePath, _T("%s\\thumbnail\\thumbnail.bmp"), gWorkingDir);
		DeleteFile(szOutFilePath);

		_stprintf(szCmdLine, _T("%s\\convert -resize %dx%d \"%s\" \"%s\\thumbnail\\thumbnail.bmp\""), gWorkingDir, 
				  THUMBNAIL_WIDTH, THUMBNAIL_HEIGHT, filePath, gWorkingDir);

		BOOL ret = CreateProcess(NULL, szCmdLine, NULL, NULL, FALSE, CREATE_NO_WINDOW, NULL, NULL, &si, &pi);

		if (ret) 
		{
			CloseHandle(pi.hThread);
			WaitForSingleObject(pi.hProcess, INFINITE);
			GetExitCodeProcess(pi.hProcess, &dwExitCode);
			CloseHandle(pi.hProcess);

			filePath = szOutFilePath;
		}
		else
		{
			filePath = _T("");
		}
	}

	Bitmap	image(filePath.AllocSysString());

	if (image.GetFlags() != ImageFlagsNone)
	{
		HBITMAP		hbmReturn = NULL; 
		Bitmap		*bmPhoto  = NULL;
		CBitmap		bmpThumbnail;

		m_Pic_List.SetRedraw(FALSE);
		int sourceWidth  = image.GetWidth();
		int sourceHeight = image.GetHeight();

		if(sourceWidth == 0 || sourceHeight == 0)
		{
			return;
		}
		
		// accounting the ratio to create the thumbnail
		float nPercent;
		float nPercentW = ((float)THUMBNAIL_WIDTH / (float)sourceWidth);;
		float nPercentH = ((float)THUMBNAIL_HEIGHT / (float)sourceHeight);

		if(nPercentH < nPercentW)
		{
			nPercent = nPercentH;
			destX = (int)((THUMBNAIL_WIDTH - (sourceWidth * nPercent))/2);
		}
		else
		{
			nPercent = nPercentW;
			destY = (int)((THUMBNAIL_HEIGHT - (sourceHeight * nPercent))/2);
		}

		int destWidth = (int) (sourceWidth * nPercent);
		int destHeight = (int) (sourceHeight * nPercent);

		bmPhoto = new Bitmap(THUMBNAIL_WIDTH, THUMBNAIL_HEIGHT, PixelFormat24bppRGB);
		bmPhoto->SetResolution(image.GetHorizontalResolution(), image.GetVerticalResolution());

		Graphics *grPhoto = Graphics::FromImage(bmPhoto);
		Color colorW(255, 255, 255, 255);
		grPhoto->Clear(colorW);
		grPhoto->SetInterpolationMode(InterpolationModeHighQualityBicubic);
		grPhoto->DrawImage(&image, Rect(destX, destY, destWidth, destHeight));

		bmPhoto->GetHBITMAP(colorW, &hbmReturn);

		bmpThumbnail.Attach(hbmReturn);
		m_ImageListThumb.Replace(0, &bmpThumbnail, NULL);

		m_Pic_List.SetRedraw(TRUE);
		m_Pic_List.Invalidate();

		delete grPhoto;
		delete bmPhoto;
		
		bmpThumbnail.Detach();
		DeleteObject(hbmReturn);
	}
}
#endif
