#pragma once
#include "afxcmn.h"

#include "ResizablePage.h"
#include "IconButton.h"

extern "C"
{
	#include "FileSystemTree.h"
}

#define		MAX_READ_COUNT_FOR_BROWSE		250


class CMediafilesPage : public CResizablePage
{
	DECLARE_DYNAMIC(CMediafilesPage)

	CIconButton		m_StartServiceButton;
	CIconButton		m_StopServiceButton;
	//LPNMLISTVIEW	contentListView ;
	CImageList		m_ImageListThumb;
	BOOL			isInitFinished;
	int				m_indexUpdatePos;
	int				m_indexCount;
	int				mItemNumInMediaList;

	DBQueryState	FSE_QS[MAX_READ_COUNT_FOR_BROWSE];
	TCHAR			m_SQLstring[MAX_SQL_STR_LENGTH];

	BOOL	InitGUI();
	void	UpdateMediaList(int itemNum);
	void	ShowThumbnail();
	void	InitTableImageList(HWND hTableList,int fileType);
	BOOL	UpdateArtist(const TCHAR *strSQL) ;
	BOOL	UpdateAlbum(const TCHAR *strSQL) ; 
	BOOL	UpdateGenre(const TCHAR *strSQL);
	BOOL	UpdateContent(const TCHAR *strSQL);
	BOOL	ClearArtistAlbumGenre();
	BOOL	PromptForFileName(CString& fileName, UINT nIDSTitle, DWORD dwFlags, BOOL bOpenFileDialog, int* pType);

public:
	CMediafilesPage();
	virtual ~CMediafilesPage();

	void UpdateContentPartial();
	void RefreshMediaContentList();

	//{{AFX_DATA(CMediafilesPage)
#ifndef ADD_DIR_METHOD
	enum { IDD = IDD_MEDIAFILES_DIALOG };
#else
	enum { IDD = IDD_MEDIAFILES_DIALOG2 };
#endif
	CListCtrl	m_Media_List;	
	CListCtrl	m_Albums_List;
	CListCtrl	m_Artists_List;
	CListCtrl	m_Genre_List;
	CListCtrl	m_Content_List;
	CListCtrl	m_Content_List_AllAudio;
	CListCtrl	m_Content_List_AllVideo;
	CListCtrl	m_Content_List_AllImage;
	CListCtrl	m_Pic_List;
	CButton     m_AddEn_Btn;	
	CButton     m_DelEn_Btn;
	//}}AFX_DATA

protected:
	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 䴩
	virtual BOOL OnSetActive();

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnLvnItemActivateMediaList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedMediaList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedAlbumsList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedArtistsList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedGenreList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnHdnItemdblclickContentList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangingContentList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedContentList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemActivateContentList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMRclickContentList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedButtonEditFileInfo();
	afx_msg void OnBnClickedButtonDel();
	afx_msg void OnBnClickedButtonAdd();
	afx_msg void OnBnClickedButtonStartService();
	afx_msg void OnBnClickedButtonStopService();
	afx_msg void OnBnClickedButtonClearDatabase();
	afx_msg void OnLvnItemchangedPicList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedButtonAddMyfavorites();
};
