#include "stdafx.h"
#include "MessageBoxDlg.h"


IMPLEMENT_DYNAMIC(CMessageBoxDlg, CDialog)

CMessageBoxDlg::CMessageBoxDlg(TCHAR *pCaption, TCHAR *pMessage, TCHAR *pOK) : 
	CDialog(CMessageBoxDlg::IDD)
{
	m_pCaption = pCaption;
	m_pMessage = pMessage;
	m_pOK = pOK;
	m_type = 1;				// has only OK button
}

CMessageBoxDlg::CMessageBoxDlg(TCHAR *pCaption, TCHAR *pMessage, TCHAR *pOK, TCHAR *pCancel) : 
	CDialog(CMessageBoxDlg::IDD)
{
	m_pCaption = pCaption;
	m_pMessage = pMessage;
	m_pOK = pOK;
	m_pCancel = pCancel;
	m_type = 0;				// has OK and Cancel buttons
}


CMessageBoxDlg::~CMessageBoxDlg()
{
}

void CMessageBoxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CMessageBoxDlg,  CDialog)
	ON_BN_CLICKED(IDC_MESSAGE_BOX_OK1, OnBnClickedOk)
	ON_BN_CLICKED(IDC_MESSAGE_BOX_OK2, OnBnClickedOk)
	ON_BN_CLICKED(IDC_MESSAGE_BOX_CANCEL, OnBnClickedCancel)
END_MESSAGE_MAP()


BOOL CMessageBoxDlg::OnInitDialog()
{
	BOOL	result;

	result = CDialog::OnInitDialog();
	
	SetWindowText(m_pCaption);
	GetDlgItem(IDC_MESSAGE_BOX_MESSAGE)->SetWindowText(m_pMessage);

	if (m_type == 0)
	{
		// has OK and Cancel buttons
		GetDlgItem(IDC_MESSAGE_BOX_OK1)->SetWindowText(m_pOK);
		GetDlgItem(IDC_MESSAGE_BOX_CANCEL)->SetWindowText(m_pCancel);
		GetDlgItem(IDC_MESSAGE_BOX_OK1)->ShowWindow(TRUE);
		GetDlgItem(IDC_MESSAGE_BOX_CANCEL)->ShowWindow(TRUE);
		GetDlgItem(IDC_MESSAGE_BOX_OK2)->ShowWindow(FALSE);
	}
	else
	{
		// has only OK button
		GetDlgItem(IDC_MESSAGE_BOX_OK2)->SetWindowText(m_pOK);
		GetDlgItem(IDC_MESSAGE_BOX_OK2)->ShowWindow(TRUE);
		GetDlgItem(IDC_MESSAGE_BOX_OK1)->ShowWindow(FALSE);
		GetDlgItem(IDC_MESSAGE_BOX_CANCEL)->ShowWindow(FALSE);
	}

	return result;
}


void CMessageBoxDlg::OnBnClickedOk()
{
	CDialog::OnOK();
}

void CMessageBoxDlg::OnBnClickedCancel()
{
	CDialog::OnCancel();
}

