#include "stdafx.h"
#include "FolderUtils.h"
#include "HighColorTab.h"
#include "ImportPage.h"
#include "ImportPage2.h"
#include "ado2.h"
#include "dbtools.h"
#include "VideoInfo.h"
#include "Language.h"
#include "ScanFiles.h"
#include "isoparser.h"
#include "bk.hpp"
extern "C"
{
	#include "FileSystemTree.h"
	#include "mystring.h"
	#include "debug.h"
}

extern LPMALLOC			pMalloc;
extern LPSHELLFOLDER	psfDesktop;

extern "C" TCHAR	gWorkingDir[MAX_PATH_LENGTH];

extern int		fProgExit;
//Birdy
//extern int		needFreshMediaContent;
extern int control_updata_list = 0;

extern TCHAR szFileFilterVideo[20][10];
extern TCHAR szFileFilterAudio[20][10];
extern TCHAR szFileFilterImage[20][10];
extern TCHAR szFileFilterPlaylist[20][10];
extern TCHAR szFileFilterSubTitle[20][10];
extern TCHAR szFileFilterJ2K[20][10];

int		inScanFiles = FALSE;
int		skipScanFiles;
HANDLE	hScanFilesMutex; 

TCHAR	currentScanFileName[MAX_PATH_LENGTH];

int M3U_parent = 0;
extern void set_YoutubeRefresh(int i);

//birdy 2007/12/25 add for susped and resume Youtube thread
extern HANDLE	YoutubeThreadHandle;
extern int control_scanICON_change;

extern HANDLE	Renew_M3U_FreeBox_hreadHandle;
extern HANDLE	Renew_M3UT_hreadHandle;

extern HANDLE	Read_Local_FreeBox_ThreadHandle = NULL;
static DWORD	Read_Local_FreeBox_ThreadId;
DWORD WINAPI Read_Local_FreeBox_Thread(LPVOID args);
extern void freebox_http_parse(char *ptr, int bufsize, CString filepath);
void deleteIsoEmptyDirFromDB(TCHAR *filePath);
unsigned int addIsoContentstoDB(BkFileBase* base, int numSpaces,TCHAR *filePath,int *flags);
static gWriteThread = 0;
int IsoDirLevel=0;
// Description: Determine the uppermost parent ID in database
// Input:
// 		fileBrowser: the file browser tree control
// 		hItem: the item that user seleted
// 		nUpLevel: the level to the uppermost parent
// 		pPartialRootID:
// Output:
//      Return: the ID of the uppermost parent in database
long FindPartialCheckRootID(CShellTreeCtrl *fileBrowser, HTREEITEM hItem, int nUpLevel, 
							long pPartialRootID)
{
	CShellPidl		pidl;
	CString			*parentPathArray;
	DBQueryState	queryState;
	TCHAR			strQuery[MAX_SQL_STR_LENGTH];
	long			pID;

	parentPathArray = new CString[nUpLevel];

	// Record all parent's path name and get the uppermost parent
	for (int i = 0; i < nUpLevel; i++)
	{
		hItem = fileBrowser->GetParentItem(hItem);
		pidl = fileBrowser->GetItemIDList(hItem);
		parentPathArray[i] = pidl.GetPath();
	}

	pID = pPartialRootID;
	for (int i = nUpLevel-1; i >= 0; i--)
	{
		_stprintf(strQuery, 
				  _T("select * from FSE_QueryState where FilePath =\"%s\" and pIndex=%d"), 
				  parentPathArray[i], pID);
		if (db_getOneRecordT(strQuery, &queryState) != 0)
		{
			pID = queryState.Index;
		}
		else
		{
			pID = pPartialRootID;
			break;
		}
	}

	delete[]	parentPathArray;

	return pID;
}


// Description: Add files in the selected directories to database
// Input:
// 		args: the file browser tree control contains the selected directory
// Output:
//      Return: None
DWORD WINAPI ScanFilesThread(LPVOID args)
{
	CShellTreeCtrl	*fileBrowser;
	HTREEITEM		hTreeSelItem;
	TCHAR			strSQL[MAX_SQL_STR_LENGTH];
	long			pIDAudio, pIDVideo, pIDPhoto, ID;
	int				subDirStatus;

	while (WaitForSingleObject(hScanFilesMutex, 100L) != WAIT_OBJECT_0)
	{
		Sleep(100);
	}

	skipScanFiles = FALSE;

	fileBrowser = (CShellTreeCtrl *) args;
    hTreeSelItem = fileBrowser->GetRootItem();

	do
	{
		if (fileBrowser->GetCheck(hTreeSelItem))
		{
			HTREEITEM	hParentItem;
			int			nState, nParentState, nScanSubFolder, nScan, nUpLevel;

			nState = fileBrowser->GetItemState(hTreeSelItem, TVIS_STATEIMAGEMASK ) >> 12;
			hParentItem = fileBrowser->GetParentItem(hTreeSelItem);

			if (hParentItem)
				nParentState = fileBrowser->GetItemState(hParentItem, TVIS_STATEIMAGEMASK ) >> 12;
			else
				nParentState = CSTC_CHECK_OFF;

			nScan = FALSE;
			if (nState == CSTC_CHECK_ON)
			{
				// if the parent item is fully check, this subfolder has been scanned
				if (nParentState != CSTC_CHECK_ON)
				{
					nScan = TRUE;
					nScanSubFolder = TRUE;
				}
			}
			else
			{
				// This folder is partial check, so we only scan it and don't scan subfolders
				nScan = TRUE;
				nScanSubFolder = FALSE;
			}

			nUpLevel = 0;
			if (nParentState == CSTC_CHECK_PARTIAL)
			{
				while (nParentState == CSTC_CHECK_PARTIAL)
				{
					nUpLevel++;
					hParentItem = fileBrowser->GetParentItem(hParentItem);
					if (hParentItem)
					{
						nParentState = fileBrowser->GetItemState(hParentItem, TVIS_STATEIMAGEMASK ) >> 12;
					}
					else
					{
						nParentState = CSTC_CHECK_OFF;
					}
				}		
			}

			if (nScan)
			{
				CShellPidl pidlParent = fileBrowser->GetItemIDList(hTreeSelItem);
				CString strPath = pidlParent.GetPath();
				
				if (strPath.IsEmpty() && nScanSubFolder)
				{
                    SShellFolderPtr pParentFolder(fileBrowser->m_pDesktopFolder, pidlParent);
					CShellPidl pidl;

					if(!pParentFolder.IsValid())
					{
						// nothing to add
						continue;
					}

					SEnumIDListPtr pEnumIDList(pParentFolder, 
											   SHCONTF_FOLDERS | SHCONTF_STORAGE, NULL);
	
					if (!pEnumIDList.IsValid())
					{
						// nothing to add
						continue;
					}

					while ((NOERROR == pEnumIDList->Next(1, pidl.GetPointer(), NULL)) && !skipScanFiles)
					{
						CShellPidl pidlCombine;
						pidlCombine.Combine(pidlParent, pidl);
						CString strPath = pidlCombine.GetPath();
						
						if (strPath.IsEmpty())
						{
							// nothing to add
							continue;
						}

						ID = DB_AUDIO_MY_FOLDERS;
						if (nUpLevel)
						{
							// Get the uppermost audio folder parent ID in database
							ID = FindPartialCheckRootID(fileBrowser, hTreeSelItem, nUpLevel, ID);
						}
						pIDAudio = addFSE(ID, FSE_OT_Directory, strPath.GetString(), strPath.GetString(), FILE_TYPE_AUDIO) - 1;
					
						ID = DB_VIDEO_MY_FOLDERS;
						if (nUpLevel)
						{
							// Get the uppermost video folder parent ID in database
							ID = FindPartialCheckRootID(fileBrowser, hTreeSelItem, nUpLevel, ID);
						}
						pIDVideo = addFSE(ID, FSE_OT_Directory, strPath.GetString(), strPath.GetString(), FILE_TYPE_VIDEO) - 1;
						
						ID = DB_IMAGE_MY_FOLDERS;
						if (nUpLevel)
						{
							// Get the uppermost image folder parent ID in database
							ID = FindPartialCheckRootID(fileBrowser, hTreeSelItem, nUpLevel, ID);
						}
						pIDPhoto = addFSE(ID, FSE_OT_Directory, strPath.GetString(), strPath.GetString(), FILE_TYPE_PHOTO) -1 ;

						// Add all sub-diretories
						subDirStatus = AddFilesInDirToDB(pidlCombine, pIDAudio, pIDVideo, pIDPhoto, nScanSubFolder);
	
						if (!(subDirStatus & (FILE_TYPE_AUDIO | FILE_TYPE_PLAYLIST)))
						{
							// There is no audio file, remove this directory from datatbase
							_stprintf(strSQL,_T("delete from FSE_QueryState where MyIndex = %d"), pIDAudio);
							db_executeT(strSQL);
						}
						if (!(subDirStatus & FILE_TYPE_VIDEO))
						{
							// There is no video file, remove this directory from datatbase
							_stprintf(strSQL,_T("delete from FSE_QueryState where MyIndex = %d"), pIDVideo);
							db_executeT(strSQL);
						}
						if (!(subDirStatus & FILE_TYPE_PHOTO))
						{
							// There is no photo file, remove this directory from datatbase
							_stprintf(strSQL,_T("delete from FSE_QueryState where MyIndex = %d"), pIDPhoto);
							db_executeT(strSQL);
						}
					}	
				}
				else
				{
					ID = DB_AUDIO_MY_FOLDERS;
					if (nUpLevel)
					{
						ID = FindPartialCheckRootID(fileBrowser, hTreeSelItem, nUpLevel, ID);
					}
					pIDAudio = addFSE(ID, FSE_OT_Directory, strPath.GetString(), strPath.GetString(), FILE_TYPE_AUDIO) - 1;

					ID = DB_VIDEO_MY_FOLDERS;
					if (nUpLevel)
					{
						ID = FindPartialCheckRootID(fileBrowser, hTreeSelItem, nUpLevel, ID);
					}
					pIDVideo = addFSE(ID, FSE_OT_Directory, strPath.GetString(), strPath.GetString(), FILE_TYPE_VIDEO) - 1;

					ID = DB_IMAGE_MY_FOLDERS;
					if (nUpLevel)
					{
						ID = FindPartialCheckRootID(fileBrowser, hTreeSelItem, nUpLevel, ID);
					}
					pIDPhoto = addFSE(ID, FSE_OT_Directory, strPath.GetString(), strPath.GetString(), FILE_TYPE_PHOTO) -1 ;

					subDirStatus = AddFilesInDirToDB(pidlParent, pIDAudio, pIDVideo, pIDPhoto, nScanSubFolder);
	
					if (!(subDirStatus & (FILE_TYPE_AUDIO  | FILE_TYPE_PLAYLIST)))
					{
						// There is no audio file, remove this directory from datatbase
						_stprintf(strSQL, _T("delete from FSE_QueryState where MyIndex = %d"), pIDAudio);
						db_executeT(strSQL);
					}
					if (!(subDirStatus & FILE_TYPE_VIDEO))
					{
						// There is no video file, remove this directory from datatbase
						_stprintf(strSQL, _T("delete from FSE_QueryState where MyIndex = %d"), pIDVideo);
						db_executeT(strSQL);
					}
					if (!(subDirStatus & FILE_TYPE_PHOTO))
					{
						// There is no photo file, remove this directory from datatbase
						_stprintf(strSQL, _T("delete from FSE_QueryState where MyIndex = %d"), pIDPhoto);
						db_executeT(strSQL);
					}
				}
			}
		}

		// has next item
		if (!fProgExit)
		{
			hTreeSelItem = fileBrowser->GetNextVisibleItem(hTreeSelItem);
		}

	} while (hTreeSelItem != NULL && !skipScanFiles);

	ReleaseMutex(hScanFilesMutex);

	// Clear the scanned file name when the scan finishs
	_tcscpy(currentScanFileName, _T(""));
	inScanFiles = FALSE;
	
	// Clear the queued database query
	FlushCacheDBQuery();

	return TRUE;
}


// Description: Add files in the selected directory to database
// Input:
// 		pidlIn: the PIDL of selected directory
// Output:
//      Return: the file types has been added to database
//				FILE_TYPE_NONE, FILE_TYPE_AUDIO, FILE_TYPE_VIDEO, FILE_TYPE_AUDIO, FILE_TYPE_PHOTO
int	AddFilesInDirToDB(CShellPidl pidlIn, long parentIDAudio, long parentIDVideo, long parentIDPhoto, 
					  int nScanSubFolder)
{
	CShellPidl	pidl;
	CString		str, fileName, strExt;
	long		pIDAudio, pIDVideo, pIDPhoto, pID, parentID;
	int			fileType, result = 0, filterType, nPos;
	DWORD 		dwAttributes;	

	// Add new data into database, notify media file page should update its content lists
	//needFreshMediaContent = TRUE;   //Birdy

	// If we directly use input pidl, the files under "My Document" cannot be correctly 
	// enumerated in Win2K. We get the real path and create another pidl to fix this problem.
	CShellPidl pidlFolder(pidlIn.GetPath());

	SShellFolderPtr pFolder(psfDesktop, pidlFolder);

	if(!pFolder.IsValid())
	{
		return (FILE_TYPE_NONE);
	}

	// Fix that scanning files does not work in Win2K
	//SEnumIDListPtr pEnumIDList(pFolder, SHCONTF_FOLDERS | SHCONTF_STORAGE);
	SEnumIDListPtr pEnumIDList(pFolder, SHCONTF_FOLDERS | SHCONTF_NONFOLDERS | SHCONTF_STORAGE);

	if (!pEnumIDList.IsValid())
	{
		return (FILE_TYPE_NONE);
	}

	while ((NOERROR == pEnumIDList->Next(1, pidl.GetPointer(), NULL)) && !skipScanFiles)
	{
		CShellPidl pidlCombine;

		pidlCombine.Combine(pidlFolder, pidl);

		dwAttributes = SFGAO_FOLDER | SFGAO_FILESYSTEM;
		LPCITEMIDLIST pidlRel = pidlCombine.GetLastChild();
		pFolder->GetAttributesOf(1, &pidlRel, &dwAttributes);

		if (dwAttributes & (SFGAO_LINK | SFGAO_COMPRESSED))
		{
			// We don't want to a link or compreseed files
			continue;
		}

		if (dwAttributes & SFGAO_FOLDER)
		{
			// Cannot use SFGAO_COMPRESSED to filter compressed files, we check file extension here to filter
			str = pidlCombine.GetPath();	

			
			if (str.IsEmpty())
			{
				// nothing to add
				continue;
			}

			if (GetFileAttributes(str) & (FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM))
			{
				// skip if the dir has hidden or system attr
				continue;
			}

			if ((nPos = str.ReverseFind(_T('.'))) != -1)
			{
				strExt = str.Right(str.GetLength()- nPos);
				if (strExt.CompareNoCase(_T(".zip")) == 0 ||
					strExt.CompareNoCase(_T(".rar")) == 0 ||
					strExt.CompareNoCase(_T(".cab")) == 0)
				{
					// Don't scan into compressed files
					continue;
				}
			}

			if (nScanSubFolder)
			{
				TCHAR	strSQL[MAX_SQL_STR_LENGTH];
				int		subDirStatus;

				nPos = str.ReverseFind(_T('\\'));
				fileName = str.Right(str.GetLength() - nPos - 1);
				
				pIDAudio = addFSE(parentIDAudio, FSE_OT_Directory, str, fileName, FILE_TYPE_AUDIO) - 1;
				pIDVideo = addFSE(parentIDVideo, FSE_OT_Directory, str, fileName, FILE_TYPE_VIDEO) - 1;
				pIDPhoto = addFSE(parentIDPhoto, FSE_OT_Directory, str, fileName, FILE_TYPE_PHOTO) - 1;
				subDirStatus = AddFilesInDirToDB(pidlCombine, pIDAudio, pIDVideo, pIDPhoto, nScanSubFolder);
	
				if (!(subDirStatus & FILE_TYPE_AUDIO))
				{
					// There is no audio file, remove this directory from datatbase
					_stprintf(strSQL, _T("delete from FSE_QueryState where MyIndex = %d"), pIDAudio);
					db_executeT(strSQL);
				}
				if (!(subDirStatus & FILE_TYPE_VIDEO))
				{
					// There is no video file, remove this directory from datatbase
					_stprintf(strSQL, _T("delete from FSE_QueryState where MyIndex = %d"), pIDVideo);
					db_executeT(strSQL);
				}
				if (!(subDirStatus & FILE_TYPE_PHOTO))
				{
					// There is no photo file, remove this directory from datatbase
					_stprintf(strSQL, _T("delete from FSE_QueryState where MyIndex = %d"), pIDPhoto);
					db_executeT(strSQL);
				}

				// Report the files type in this sub folder
				result |= subDirStatus;
			}
		}
		else
		{
			str = pidlCombine.GetPath();

			if (str.IsEmpty())
			{
				// nothing to add
				continue;
			}

			if (GetFileAttributes(str) & (FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM))
			{
				// skip if the file has hidden or system attr
				continue;
			}

			// Store the current scanning file, it will be shown in CHighColorPropertySheet::OnTimer
			_tcscpy(currentScanFileName, str.GetString());
				
			fileType = SFGetFileType(str);
			nPos = str.ReverseFind(_T('\\'));
			fileName = str.Right(str.GetLength() - nPos - 1);

			if (fileType & FILE_TYPE_PLAYLIST)
			{
				if (IsFilteredFile(str, FILE_TYPE_PLAYLIST))
				{
					//TCHAR	lstFilePath[MAX_PATH_LENGTH];

					//_stprintf(lstFilePath, _T("%s\\cache\\%d%s.lst"), gWorkingDir, qsCount, 
					//		  fileName.Left(fileName.ReverseFind(_T('.'))));
					CString		lstFilePath;
					//TCHAR		sqlStr[MAX_SQL_STR_LENGTH];

					//2008 birdy close for fix watcher bug
					//lstFilePath = str.Left(str.ReverseFind(_T('.')));
					//lstFilePath += _T(".lst");				
					//_stprintf(sqlStr, _T("select * from FSE_QueryState where FilePath =\"%s\""), lstFilePath);
					//if (db_selectT(sqlStr) == 0)
					{
						addFSE(DB_AUDIO_ALL_MUSIC_ID, FSE_OT_File, lstFilePath, fileName, fileType);
						pID = addFSE(parentIDAudio, FSE_OT_File, lstFilePath, fileName, fileType) - 1;

						//birdy 2008/1/31 fix watcher bug,move .lst file to cache
						char number[1024];

						sprintf(number,"%d",pID);
                        lstFilePath = gWorkingDir;
                        lstFilePath += _T("\\cache\\");
                        lstFilePath += number;
                        lstFilePath += _T(".lst");

						// we generate a new playlist file, named xxx.lst
						// when render query for xxx.m3u or xxx.pls, 
						// the server will response with a xxx.lst
						GenerateNewPlaylist(str, lstFilePath, pID);
					}
				}
			}
			else if (fileType != FILE_TYPE_NONE)
			{
				if (fileType & FILE_TYPE_AUDIO)
				{
					pID = DB_AUDIO_ALL_MUSIC_ID;
					parentID = parentIDAudio;
					filterType = FILE_TYPE_AUDIO;					
				}
				else if (fileType & FILE_TYPE_PHOTO) 
				{
					pID = DB_IMAGE_ALL_IMAGE_ID;
					parentID = parentIDPhoto;
					filterType = FILE_TYPE_PHOTO;
				}
				else if (fileType & FILE_TYPE_VIDEO) 
				{
					TCHAR	sqlStr[MAX_SQL_STR_LENGTH];

					pID = DB_VIDEO_ALL_VIDEO_ID;
					parentID = parentIDVideo;
					filterType = FILE_TYPE_VIDEO;

					// Don't generate video index files if the file is already in database
					_stprintf(sqlStr, _T("select * from FSE_QueryState where FilePath =\"%s\""), str);

					if (db_selectT(sqlStr) == 0)
					{
						// We don't create video index files in removable device (CDROM or DVDROM);
						if (!(dwAttributes & SFGAO_REMOVABLE))
						{
							if ((nPos = str.ReverseFind(_T('.'))) != -1)
							{
								strExt = str.Right(str.GetLength() - nPos);

								// add this file to scan video list, we will start a thread to scan them later
								/*if ((strExt.CompareNoCase(_T(".vob")) == 0) || 
									(strExt.CompareNoCase(_T(".mpeg2")) == 0) ||  
									(strExt.CompareNoCase(_T(".mpg")) == 0) ||
									(strExt.CompareNoCase(_T(".avi")) == 0))*/

								//birdy 2007/5/14 support TS,M2TS,TP
								if ((strExt.CompareNoCase(_T(".vob")) == 0) || 
									(strExt.CompareNoCase(_T(".mpeg2")) == 0) ||  
									(strExt.CompareNoCase(_T(".mpg")) == 0) ||
									(strExt.CompareNoCase(_T(".avi")) == 0) ||
									(strExt.CompareNoCase(_T(".ts")) == 0) ||
									(strExt.CompareNoCase(_T(".m2ts")) == 0) ||
									(strExt.CompareNoCase(_T(".tp")) == 0)   ||
									(strExt.CompareNoCase(_T(".mpeg")) == 0)
									)
								{
									AddVideoFileToScanList(str);
								}
							}
						}
					}
				}


#ifdef _ISO_PROJECT_
				int flag[3];
				struct BkFileBase *base;
				struct VolInfo *volInfo;
				//char *srcPathAndName,*destDir;

				volInfo = (struct VolInfo*)malloc(sizeof(VolInfo));
				//srcPathAndName = (char*)malloc(1000*sizeof(char));
				//destDir = (char*)malloc(1000*sizeof(char));
				
				if(fileType & FILE_TYPE_ISO)
				{
					int res=0;
					
					//char argv[150];
					//TCHAR	sqlStr[MAX_SQL_STR_LENGTH];
					TCHAR *sqlStr;
					char *tmpPath;
					TCHAR *filePath;
					//TCHAR  unicodeFilePath[MAX_PATH_LENGTH];
					TCHAR *unicodeFilePath;

					unicodeFilePath = (TCHAR*)malloc(MAX_PATH_LENGTH*sizeof(TCHAR));
					sqlStr = (TCHAR*)malloc(MAX_SQL_STR_LENGTH *sizeof(TCHAR));
					tmpPath = (char*)currentScanFileName;
					filePath= currentScanFileName;
					Utf8ToWide(unicodeFilePath,tmpPath,MAX_PATH_LENGTH);
					int pos=fileName.ReverseFind(_T('.'));
					TCHAR *filename;
					
					filename = (TCHAR*)malloc(1000*sizeof(TCHAR));
					memset(filename,0x00,1000*sizeof(TCHAR));
					wcsncpy(filename,fileName,pos);
					wcscat(filename,_T("(iso)"));
//					CString strExt = filepath.Right(filepath.GetLength() - pos);
					
					flag[0]=qsCount;
					_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType,  FilePath, FileName, FileType, ObjectType) \
						values(%d, %d,%d, %d, \"%s\",\"%s\",\"%s\" ,%d)"), qsCount,FLAGS_ISO,parentIDAudio,FSE_OT_Directory ,filePath,filename,_T("Audio") ,FSE_OT_Directory);

					db_executeT(sqlStr);
					qsCount++;

					flag[1]=qsCount;
					_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType,  FilePath, FileName, FileType, ObjectType) \
						values(%d, %d,%d, %d, \"%s\",\"%s\",\"%s\" ,%d)"), qsCount,FLAGS_ISO,parentIDVideo,FSE_OT_Directory ,filePath,filename,_T("Video") ,FSE_OT_Directory);

					db_executeT(sqlStr);
					qsCount++;

					flag[2]=qsCount;
					_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType,  FilePath, FileName, FileType, ObjectType) \
						values(%d, %d,%d, %d, \"%s\",\"%s\",\"%s\" ,%d)"), qsCount,FLAGS_ISO,parentIDPhoto,FSE_OT_Directory ,filePath,filename,_T("Image") ,FSE_OT_Directory);

					db_executeT(sqlStr);
					qsCount++;


					res=fnIsoparser(filePath,volInfo);

					base = (BkFileBase*)BK_BASE_PTR( &(volInfo->dirTree) );
					

					_stprintf(sqlStr, _T("select * from FSE_QueryState where Flags = 256 and (pIndex = %d and FileName = \"%s\")"),parentIDAudio,filename);
					
					int dbCount = db_selectT(sqlStr);

					if ( dbCount == 0)
					{
						return 0;
					}
					int i;
					for (i = 0; i < dbCount; i++)
					{
						flag[0]=testFSE_QS[i].Index;
					}	

					_stprintf(sqlStr, _T("select * from FSE_QueryState where Flags = 256 and (pIndex = %d and FileName = \"%s\")"),parentIDVideo,filename);

					dbCount = db_selectT(sqlStr);

					if ( dbCount == 0)
					{
						return 0;
					}

					for (i = 0; i < dbCount; i++)
					{
						flag[1]=testFSE_QS[i].Index;
					}	
					
					_stprintf(sqlStr, _T("select * from FSE_QueryState where Flags = 256 and (pIndex = %d and FileName = \"%s\")"),parentIDPhoto,filename);

					dbCount = db_selectT(sqlStr);
					if ( dbCount == 0)
					{
						return 0;
					}

					for (i = 0; i < dbCount; i++)
					{
						flag[2]=testFSE_QS[i].Index;
					}

					IsoDirLevel=0;
					int subStatus=addIsoContentstoDB(base,10,currentScanFileName,flag);
					void *ptr = (void*)volInfo;
					Iso_destroy_vol_info(ptr);
					for(i=0;i < 10;i++)
					{
						deleteIsoEmptyDirFromDB(currentScanFileName);
						//FlushCacheDBQuery();
					}
					IsoDirLevel=0;
					free(unicodeFilePath);
					free(sqlStr);

					free(filename);
					result |=subStatus;
				}else
				{
					addFSE(pID, FSE_OT_File, str, fileName, filterType);
					addFSE_FilesOnly(parentID, FSE_OT_File, str, fileName, filterType, 0);

					if (fileType & FILE_TYPE_SUBTITLE)
					{
					// filter out this folder if it only contain subtitle
						fileType &= ~FILE_TYPE_VIDEO;
					}
				}
				//free(srcPathAndName);
				//free(destDir);
				free(volInfo);
#else
					addFSE(pID, FSE_OT_File, str, fileName, filterType);
					addFSE_FilesOnly(parentID, FSE_OT_File, str, fileName, filterType, 0);

					if (fileType & FILE_TYPE_SUBTITLE)
					{
					// filter out this folder if it only contain subtitle
						fileType &= ~FILE_TYPE_VIDEO;
					}
#endif
			}

			else 
			{
				scan_skipCount++;
			}
			
			// indicate what file types are in this directory
			result |= fileType;
		}

		// Add new data into database, notify media file page should update its content lists
		//needFreshMediaContent = TRUE;   //Birdy
	}
	
	return result;
}

void deleteIsoEmptyDirFromDB(TCHAR *filePath)
{
	TCHAR	sqlStr[MAX_SQL_STR_LENGTH];
//	int len= wcslen(filePath);
	//fileName;
	Sleep(100);
	_stprintf(sqlStr, _T("select * from FSE_QueryState where Flags = 256 and (ObjectType = %d)"),FSE_OT_Directory);

	int dbCount = db_selectT(sqlStr);

	if ( dbCount == 0)
	{
		return ;
	}else{
        //	int *pIndex = malloc(dbCount*sizeof(int));
		FSE_QueryState *tmpState = (FSE_QueryState*)malloc(dbCount*sizeof(FSE_QueryState));
		for(int i=0;i<dbCount;i++)
		{
			tmpState[i]= testFSE_QS[i];

		}

		int j=0;
		for(int i=0;i<dbCount;i++)
		{
			int pIndex = tmpState[i].Index;
			CString fileName = tmpState[i].FilePath;
			TCHAR UnicodeString[255];
			Utf8ToWide(UnicodeString,tmpState[i].FilePath,255);
			if(!_tcsncmp(filePath,UnicodeString,wcslen(UnicodeString)*sizeof(TCHAR)))
			{
				_stprintf(sqlStr,_T("select * from FSE_QueryState where Flags = 256 and ( ObjectType = %d and pIndex =%d)"),FSE_OT_File,pIndex);
				int Count = db_selectT(sqlStr);
			
				_stprintf(sqlStr,_T("select * from FSE_QueryState where Flags = 256 and ( ObjectType = %d and pIndex =%d)"),FSE_OT_Directory,pIndex);
				int Count2 = db_selectT(sqlStr);
				if(Count ==0 && Count2==0)
				{

					_stprintf(sqlStr,_T("delete from FSE_QueryState where MyIndex = %d"),pIndex);
					db_executeT(sqlStr);
				}else 
					j++;
			}
		}
		free(tmpState);
		if (j ==dbCount) return;
//		deleteIsoEmptyDirFromDB(filePath);
	}
	return;
}
unsigned int addIsoContentstoDB(BkFileBase* base, int numSpaces,TCHAR *filePath,int *flags)
{
//    int count;
    struct BkFileBase *child;
	wchar_t *ptr,FileName[MAX_PATH_LENGTH];
	TCHAR	sqlStr[MAX_SQL_STR_LENGTH];
	TCHAR dbFilePath[MAX_PATH_LENGTH];
//	int parent;
	CString fileType;
	unsigned int status=0;

	int subflags[3];

    if(IS_DIR(base->posixFileMode))
    {

		ptr = (wchar_t*) base->name;
		LPBYTE tmp_p=(LPBYTE)ptr;
		int len ;//wcslen(ptr);
//		wchar_t Name_W[UCHAR_MAX];

//		int i;

		len = (int)_tcslen(ptr);
		len = (int)wcslen(ptr);

		wcsncpy(FileName,ptr,len+1);

/*
		if(!wcscmp(FileName,_T("AUDIO_TS"))| !wcscmp(FileName,_T("VIDEO_TS")))
		{
			subflags[0]=flags[0];
			subflags[1]=flags[1];
			subflags[2]=flags[2];
		}
		else if(!wcscmp(FileName,_T("audio_ts"))| !wcscmp(FileName,_T("video_ts")))
		{
			subflags[0]=flags[0];
			subflags[1]=flags[1];
			subflags[2]=flags[2];
		}else 
*/		if(len)
		{// not the iso directory
			subflags[0]=qsCount;
			_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType,  FilePath, FileName, FileType, ObjectType) \
				values(%d, %d,%d, %d, \"%s\",\"%s\",\"%s\" ,%d)"), qsCount,FLAGS_ISO,flags[0],FSE_OT_Directory ,filePath,FileName,_T("Audio") ,FSE_OT_Directory);

			db_executeT(sqlStr);
			qsCount++;
			
			
			
			subflags[1] = qsCount;
			_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType,  FilePath, FileName, FileType, ObjectType) \
				values(%d, %d,%d, %d, \"%s\",\"%s\",\"%s\" ,%d)"), qsCount,FLAGS_ISO,flags[1],FSE_OT_Directory ,filePath,FileName,_T("Video") ,FSE_OT_Directory);

			db_executeT(sqlStr);
			qsCount++;
			
			subflags[2]=qsCount;
			_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType,  FilePath, FileName, FileType, ObjectType) \
				values(%d, %d,%d, %d, \"%s\",\"%s\",\"%s\" ,%d)"), qsCount,FLAGS_ISO,flags[2],FSE_OT_Directory ,filePath,FileName,_T("Image") ,FSE_OT_Directory);

			db_executeT(sqlStr);
			qsCount++;
			
			IsoDirLevel++;
		}else 
		{
			status =0;
			subflags[0]=flags[0];
			subflags[1]=flags[1];
			subflags[2]=flags[2];
		}

		child=BK_DIR_PTR(base)->children;
        while(child != NULL)
        {

			len = (int)wcslen(filePath);
			wcsncpy(dbFilePath,filePath,len+1);

            status |=addIsoContentstoDB(child, numSpaces + 2,dbFilePath,subflags);
            child = child->next;
        }
    }
    else if(IS_REG_FILE(base->posixFileMode))
    {
        
		ptr = (wchar_t*) base->name;
		int len = (int)wcslen(ptr);
//		wchar_t tmp,tmp_l;
		
		int size = BK_FILE_PTR(base)->size;
		__int64 offset=BK_FILE_PTR(base)->position;
		

		CString filename=ptr;
		int pos=filename.ReverseFind(';');
		CString fileName;
		if(pos ==-1)
			fileName = filename;
		else 
			fileName = filename.Left( pos);
		CString filepath = filePath;
		TCHAR offsetStr[2000];
		filepath+=_T("\\%%offset%%");
		swprintf(offsetStr,_T("%I64d"),offset);
		filepath+=offsetStr;
		filepath+=_T("\\");
		filepath+=fileName;
		
		int filetype=SFGetFileType(fileName);
		if(filetype & FILE_TYPE_AUDIO){
			status |=FILE_TYPE_AUDIO;
			fileType= _T("Audio");
			_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType, FilePathLen, FilePath, FileName, FileType, ObjectType,FileSize) \
			values(%d, %d,%d, %d, %d,\"%s\",\"%s\",\"%s\" ,%d,%d)"), qsCount,FLAGS_ISO,flags[0],FSE_OT_File,fileName.GetLength() ,filepath, fileName,fileType ,FSE_OT_File,size);

		}else if(filetype & FILE_TYPE_VIDEO){
				status |=FILE_TYPE_VIDEO;
				fileType = _T("Video");
				
				_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType, FilePathLen, FilePath, FileName, FileType, ObjectType,FileSize) \
				values(%d, %d,%d, %d, %d,\"%s\",\"%s\",\"%s\" ,%d,%d)"), qsCount,FLAGS_ISO,flags[1],FSE_OT_File,fileName.GetLength() ,filepath, fileName,fileType ,FSE_OT_File,size);

			
		}else if(filetype & FILE_TYPE_PHOTO)
		{
			status |=FILE_TYPE_PHOTO;
			fileType = _T("Image");
				_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType, FilePathLen, FilePath, FileName, FileType, ObjectType,FileSize) \
				values(%d, %d,%d, %d, %d,\"%s\",\"%s\",\"%s\" ,%d,%d)"), qsCount,FLAGS_ISO,flags[2],FSE_OT_File,fileName.GetLength() ,filepath, fileName,fileType ,FSE_OT_File,size);


		}else
		{
			return status;
		}
		

		db_executeT(sqlStr);
		qsCount++;
//		addFSE(100, FSE_OT_File, ptr, ptr, FILE_TYPE_ISO);
        printf("%s (regular file), size %u\n", base->name, BK_FILE_PTR(base)->size);
    }
    else if(IS_SYMLINK(base->posixFileMode))
    {
       
        printf("%s -> %s (symbolic link)\n", base->name, BK_SYMLINK_PTR(base)->target);
		return status;
	}
	return status;

}
// Description: Get one line from buffer and add the end of line
// Input:
//		buffer: the start position that we want to get a new line
//		end: the end of the whole buffer
// Output:
//      Return: The pointer to this new line
TCHAR	*SFGetNextLine(TCHAR *buffer, TCHAR *end)
{
	TCHAR	*endOfLine;

	// Search to the end of line 
	while (1)
	{
		if (buffer >= end)
		{
			// end of file
			return NULL;
		}

		if (*buffer == _T('\n'))
		{
			break;
		}

		buffer++;
	}

	// skip white space
	while (1)
	{
		if (*buffer == _T(' ') || *buffer == _T('\t') || *buffer == _T('\n') || *buffer == _T('\r'))
		{
			buffer++;

			if (buffer >= end)
			{
				// end of file
				return NULL;
			}
		}
		else
		{
			break;
		}
	} 

	endOfLine = buffer;
	while (1) {
		if ((endOfLine == end) || (*endOfLine == _T('\n')) || (*endOfLine == _T('\r')))
		{
			*endOfLine = 0x0;
			break;
		}
		endOfLine++;
	} 

	return buffer;
}

// Description: Translate the playlist to our DMA format and put all files to database
// Input:
//      filename: the file name need to be translated
// 		outputFilepath: the file path of new playlist (.lst)
//		parentIDAudio: the parent ID of audio files in this playlist
// Output:
//      Return:
//          TURE: The file belongs to the selected file type
//          FALSE: The file doesn't belong to the selected file type
void GenerateNewPlaylist(CString& fileName, CString& outputFilePath, long parentIDAudio)
{
    CStdioFile  playListFile;
	CFile		outputFile;
	CFileStatus	fileStatus;
	CString     readline, strExt, audioFilePath, audioFileName;
    int		    nPos, fileType, fileIsNotUnicode;
	DWORD		fileSize, fileReadCount; 
	TCHAR		*startBuffer, *buffer, *endBuffer;

    if ((nPos = fileName.ReverseFind(_T('.'))) == -1)
    {
        // Cannot find the extension name
        return;
    }

    strExt = fileName.Right(fileName.GetLength()- nPos);

    if (strExt.CompareNoCase(_T(".m3u")) == 0)
    {
		fileType = FILE_TYPE_PLAYLIST_M3U;
    }
    else if (strExt.CompareNoCase(_T(".pls")) == 0)
    {
		fileType = FILE_TYPE_PLAYLIST_PLS;
    }
    else if (strExt.CompareNoCase(_T(".asx")) == 0)
    {
		fileType = FILE_TYPE_PLAYLIST_ASX;
    }
    else if (strExt.CompareNoCase(_T(".wpl")) == 0)
    {
		fileType = FILE_TYPE_PLAYLIST_WPL;
    }

	else
	{
		// Unkonw playlist type
		return;
	}

	try
	{
		if (!playListFile.Open(fileName, CFile::modeRead | CFile::typeText | CFile::shareDenyNone))
		{
			//Cannot open this playlist, skip it
			return;
		}

		// Create the new output playlist file
		if (CFile::GetStatus(outputFilePath, fileStatus))
		{
			fileStatus.m_attribute &= ~0x02;				// Remove hidden attribute;
			CFile::SetStatus(outputFilePath, fileStatus);
			CFile::Remove(outputFilePath);
		}

		if (!outputFile.Open(outputFilePath, CFile::modeCreate | CFile::modeWrite | CFile::typeBinary))
		{
			playListFile.Close();
			return;
		}
	}
	catch (CFileException* pEx)
	{
		pEx->Delete();
		return;
	}

	// Create the path of audio files in the playlist
	if ((nPos = fileName.ReverseFind(_T('\\'))) != -1)
	{
		audioFilePath = fileName.Left(nPos);
	}

	audioFilePath += _T('\\');


	if (!playListFile.ReadString(readline))
	{
		// file is empty
		return;
	}

	fileIsNotUnicode = TRUE;
	if ((readline.GetAt(0) == 0xFF) && (readline.GetAt(1) == 0xFE))
	{
		// Unicode file starts with "0xFF 0xFE"
		fileIsNotUnicode = FALSE;

		try
		{
			playListFile.Seek(2, CFile::begin);
			fileSize = (DWORD) playListFile.GetLength();
			startBuffer = (TCHAR *) MALLOC(fileSize);
			memset(startBuffer, 0, fileSize);
			fileReadCount = playListFile.Read(startBuffer, fileSize);
			endBuffer = (TCHAR *) ((char *) startBuffer + fileReadCount);
		}
		catch (CFileException* pEx)
		{
			pEx->Delete();
			if (startBuffer != NULL)
			{
				FREE(startBuffer);
			}
			return;
		}

		buffer = startBuffer;
	}
	else 
	{
		 playListFile.SeekToBegin();
	}

	while (1)
	{
		WCHAR	wStr[MAX_PATH_LENGTH];
		char	cStr[MAX_PATH_LENGTH];
		int		strLen;

		if (fileIsNotUnicode)
		{
			if (!playListFile.ReadString(readline))
			{
				// end of file
				break;
			}

			// remove space 0x00 beteen chatacters (strange thing)
			WideCharToSingleByte(cStr, readline.GetString(), MAX_PATH_LENGTH);

			// translate multi-bytes to Unicode
			MultiByteToWideChar(codepage, 0, cStr, -1, wStr, MAX_PATH_LENGTH);
			readline = wStr;	
		}
		else
		{
			if ((buffer = SFGetNextLine(buffer, endBuffer)) == NULL)
			{	
				// end of file
				break;
			}

			readline = buffer;
		}

		if (fileType == FILE_TYPE_PLAYLIST_M3U)
		{
			if ((readline.GetLength() == 0) || (readline.GetAt(0) == _T('#')))
			{
				continue;
			}

			audioFileName = readline;
		}
		else if (fileType == FILE_TYPE_PLAYLIST_PLS)
		{
			if (_tcsnicmp(readline, _T("file"), 4) == 0)
			{	
				// The line contain the audio file
				nPos = readline.ReverseFind(_T('='));
				audioFileName = readline.Right(readline.GetLength() - nPos - 1);
			}
			else
			{
				continue;
			}
		}
		else if (fileType == FILE_TYPE_PLAYLIST_ASX)
		{
			CString	readlineLC = readline;
			int		startPos, endPos, findFileName;

			findFileName = FALSE;

			readlineLC.MakeLower();
			if ((nPos = readlineLC.Find(_T("href"))) != -1)
			{
				startPos = readlineLC.Find(_T('\"'), nPos + 1);

				if (startPos != -1 && startPos > nPos)
				{
					endPos = readlineLC.Find(_T('\"'), startPos + 1);
					if (endPos != -1)
					{
						audioFileName = readline.Mid(startPos + 1, (endPos - startPos - 1));
						findFileName = TRUE;
					}
				}
			}

			if (!findFileName)
			{
				continue;
			}
		}
		else if (fileType == FILE_TYPE_PLAYLIST_WPL)
		{			
			CString	readlineLC = readline;
			int	mediaPos, srcPos, startPos, endPos, findFileName;
			
			findFileName = FALSE;

			readlineLC.MakeLower();
			if ((mediaPos = readlineLC.Find(_T("media"))) != -1)
			{
				if ((srcPos = readlineLC.Find(_T("src"), mediaPos + 1)) != -1)
				{
					if ((startPos = readlineLC.Find(_T('\"'), srcPos + 1)) != -1)
					{
						if ((endPos = readlineLC.Find(_T('\"'), startPos + 1)) != -1)
						{
							audioFileName = readline.Mid(startPos + 1, (endPos - startPos - 1));
							findFileName = TRUE;
						}
					}
				}
			}

			if (!findFileName)
			{
				continue;
			}
		}
		else
		{
			continue;
		}

		if (PathIsRelative(audioFileName))
		{
			// related path, expand it to absolute path
			TCHAR	wAudioFullPathName[MAX_PATH_LENGTH];

			_tcscpy(wAudioFullPathName, audioFilePath);
			_tcscat(wAudioFullPathName, audioFileName);
			PathCanonicalize(wStr, wAudioFullPathName);
			audioFileName = wStr;
		}

		// Should this file be filtered ?
		if (!IsFilteredFile(audioFileName, FILE_TYPE_AUDIO))
		{
			continue;
		}

		DBQueryState	queryState;
		TCHAR			strQuery[MAX_SQL_STR_LENGTH];

		_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath =\"%s\" and pIndex=%d"), 
				  audioFileName, DB_AUDIO_ALL_MUSIC_ID);

		// check the file doesn't exist in the database or not
		if (db_getOneRecordT(strQuery, &queryState) == 0)
		{
			// check the file exists or not
			if (CFile::GetStatus(audioFileName, fileStatus))
			{
				CString audioFileNameOnly;
				long	ID;

				nPos = audioFileName.ReverseFind(_T('\\'));
				audioFileNameOnly = audioFileName.Right(audioFileName.GetLength() - nPos - 1);

				ID = addFSE(parentIDAudio, FSE_OT_File, audioFileName, audioFileNameOnly, 
							FILE_TYPE_FILE_IN_PLAYLIST);
				_stprintf(wStr, _T("%d/%s\r\n"), (ID - 1), audioFileNameOnly.GetString());
			}
			else
			{
				// This file doesn't exist, don't add to database
				continue;
			}
		}
		else
		{
			_stprintf(wStr, _T("%d/%s\r\n"), queryState.Index, queryState.FileName);
		}

		strLen = strToUtf8(cStr, (char *) wStr, MAX_PATH_LENGTH, IS_WIDE, NULL);
		outputFile.Write(&cStr, strLen);
	} 

	playListFile.Close();
	outputFile.Close();
	
	if (!fileIsNotUnicode && (startBuffer != NULL))
	{
		FREE(startBuffer);
	}
}

// Description: Determine the type of a file according to its extension name
// Input: 
//      fileName: the file name need to be determined the file type
// Output: 
//      Return: the flags of file types
//          FILE_TYPE_NONE: Unkonown Type
//          FILE_TYPE_VIDEO: Video files
//          FILE_TYPE_AUDIO: Audio files
//          FILE_TYPE_Photo: Photo files
//          FILE_TYPE_PLAYLIST: Playlist files
//          FILE_TYPE_SUBTITLE: Video Subtitle files
int SFGetFileType(CString& fileName)
{
	CString strExt,tt = ".mpeg";
	int		index, nPos;

	if ((nPos = fileName.ReverseFind(_T('.'))) == -1)
	{
        // Cannot find the extension name
		return FILE_TYPE_NONE;
	}

	strExt = fileName.Right(fileName.GetLength() - nPos);

	strExt.MakeLower();
	//birdy 2007/10/25 add for support ".mpeg"
	if (_tcsicmp(strExt,tt) == 0)
	{
		strExt = ".mpg";
	}

	CString iso=".iso";

	if(_tcsicmp(strExt,iso)==0)
	{
		strExt=".iso";
		return FILE_TYPE_ISO;
	}
	index = 0;
	while (szFileFilterVideo[index][0] != '\0')
	{
		if (_tcsicmp(strExt, szFileFilterVideo[index]) == 0)
		{
			for (int i = 0; szFileFilterSubTitle[i][0] != '\0'; i++)
			{
				if (_tcsicmp(strExt, szFileFilterSubTitle[i]) == 0)
				{
					return (FILE_TYPE_VIDEO | FILE_TYPE_SUBTITLE);
				}
			}
			return FILE_TYPE_VIDEO;
		}
		index ++;
	}

	index = 0;
	while (szFileFilterAudio[index][0] != '\0')
	{
		if(_tcsicmp(strExt, szFileFilterAudio[index]) == 0)
		{
			return FILE_TYPE_AUDIO;
		}
		index ++;
	}

	index = 0;
	while (szFileFilterImage[index][0] != '\0')
	{
		if(0 == _tcsicmp(strExt, szFileFilterImage[index]))
		{
			return FILE_TYPE_PHOTO;
		}
		index ++;
	}

	index = 0;
	while(szFileFilterPlaylist[index][0]!='\0')
	{
		if(0 == _tcsicmp(strExt, szFileFilterPlaylist[index]))
		{
			return FILE_TYPE_PLAYLIST;
		}
		index ++;
	}

	if(0 == _tcsicmp(strExt, _T(".lst")))
	{
		return FILE_TYPE_PLAYLIST;
	}

	return FILE_TYPE_NONE;
}


int IsFileTypeJ2K(CString& fileName)
{
	CString strExt;
	int		index, nPos;

	if ((nPos = fileName.ReverseFind(_T('.'))) == -1)
	{
        // Cannot find the extension name
		return FILE_TYPE_NONE;
	}

	strExt = fileName.Right(fileName.GetLength() - nPos);

	index = 0;
	while (szFileFilterJ2K[index][0] != '\0')
	{
		if(0 == _tcsicmp(strExt, szFileFilterJ2K[index]))
		{
			return TRUE;
		}
		index ++;
	}

	return FALSE;
}

// Description: Determine the file belong to selected file type or nor
// Input:
//      fileName: the file name need to be checked
//      FileFilter: the selected file type
// Output:
//      Return:
//          TURE: The file belongs to the selected file type
//          FALSE: The file doesn't belong to the selected file type
BOOL IsFilteredFile(CString& fileName, int FileFilter)
{
	CString strExt;
	int		i, nPos;

	if ((nPos = fileName.ReverseFind(_T('.'))) == -1)
    {
        // Cannot find the extension name
        return FALSE;
    }

	strExt = fileName.Right(fileName.GetLength()- nPos);
	
	if (FileFilter & FILE_TYPE_VIDEO)
	{
		i = 0;
		while(szFileFilterVideo[i][0]!='\0')
		{
			if(0 == _tcsicmp(strExt, szFileFilterVideo[i]))
			{
				return TRUE;
			}
			i++;
		}
	}

	if(FileFilter & FILE_TYPE_AUDIO)
	{
		i = 0;
		while(szFileFilterAudio[i][0]!='\0')
		{
			if(0 == _tcsicmp(strExt, szFileFilterAudio[i]))
			{
				return TRUE;
			}
			i++;
		}
	}

	if(FileFilter & FILE_TYPE_PHOTO)
	{
		i = 0;
		while(szFileFilterImage[i][0]!='\0')
		{
			if(0 == _tcsicmp(strExt, szFileFilterImage[i]))
			{
				return TRUE;
			}
			i++;
		}
	}

	if(FileFilter & FILE_TYPE_PLAYLIST)
	{
		i = 0;
		while(szFileFilterPlaylist[i][0]!='\0')
		{
			if(0 == _tcsicmp(strExt, szFileFilterPlaylist[i]))
			{
				return TRUE;
			}
			i++;
		}
	}

	return FALSE;
}



//birdy add watch
void ScanOneSharedDir_watcher(CString& dirPath)
{
	LPSHELLFOLDER	psfFolder = NULL;
	LPITEMIDLIST	pidl = NULL;
	CString	fileName, dirName, compare, dirPath_compare;
	int		nPos, check = 0, times = 0, check_nofile = 0, dir_Count, first = 0;
//	long	ID;
//	char *check_filetype;
	TCHAR			strQuery[MAX_SQL_STR_LENGTH];
	int				Count, number;
//	int             parentIndex;	
	int             myIndex = 0;
	PSharedDirStruct	pSharedDir;
	long			pIDAudio = 0, pIDVideo = 0, pIDPhoto = 0;
	int audio[100], video[100], photo[100], audio_times = 0, video_times = 0, photo_times = 0;
	long            myIndex_video = 0, myIndex_audio = 0, myIndex_image = 0;

	if (FAILED(psfDesktop->ParseDisplayName(NULL, NULL, (LPOLESTR) dirPath.GetString(), NULL, &pidl, NULL)))
	{
		// Cannot get the folder with dirPath
		DeleteOneSharedDirThread(&dirPath);
		//CImportPage2::updataList();
		//return -1;
	}

	if (FAILED(psfDesktop->BindToObject(pidl, NULL, IID_IShellFolder, (void**)&psfFolder)))
	{
		pMalloc->Free(pidl);
		//return FALSE;
	}
	
	nPos = dirPath.ReverseFind('\\');
	fileName = dirPath.Right(dirPath.GetLength() - nPos - 1);
	dirName = dirPath.Left(nPos);
	
	_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath =\"%s\" "), dirName);
	
	Count = db_selectT(strQuery);
	totalFileCount -= Count;

	dir_Count = GetSharedDirCount();
    pSharedDir = GetAllSharedDirs();

	while(dir_Count != 0)
	{
		myIndex = 0;
		compare = (CString)pSharedDir[dir_Count - 1].DirPath;

		if (dirPath.GetLength() > compare.GetLength())
		{
			dirPath_compare = dirPath.Left(compare.GetLength());
			number = compare.GetLength();
		}

		if (compare.Compare(dirPath_compare))
		{
			dir_Count--;
			continue;
		}
		else
		{
			first = 0;
			myIndex_video = 0;
			myIndex_audio = 0;
			myIndex_image = 0;
			while(1)
			{				
				_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath = \"%s\""), compare);
                Count = db_selectT(strQuery);

				nPos = compare.ReverseFind('\\');
				dirName = compare.Right(compare.GetLength() - nPos - 1);

				//
				if(compare.Compare(dirPath))
				{					
                    if (first == 0)
					{
						myIndex_video = addFSE(6, FSE_OT_Directory, compare, dirName, FILE_TYPE_VIDEO) - 1;
						myIndex_audio = addFSE(12, FSE_OT_Directory, compare, dirName, FILE_TYPE_AUDIO) - 1;
						myIndex_image = addFSE(15, FSE_OT_Directory, compare, dirName, FILE_TYPE_PHOTO) - 1;

						audio[audio_times] = myIndex_audio;
						audio_times++;
						video[video_times] = myIndex_video;
						video_times++;
						photo[photo_times] = myIndex_image;
						photo_times++;					
						first = 1;
					}
					else
					{
						myIndex_video = addFSE(myIndex_video, FSE_OT_Directory, compare, dirName, FILE_TYPE_VIDEO) - 1;
						myIndex_audio = addFSE(myIndex_audio, FSE_OT_Directory, compare, dirName, FILE_TYPE_AUDIO) - 1;
						myIndex_image = addFSE(myIndex_image, FSE_OT_Directory, compare, dirName, FILE_TYPE_PHOTO) - 1;

						audio[audio_times] = myIndex_audio;
						audio_times++;
						video[video_times] = myIndex_video;
						video_times++;
						photo[photo_times] = myIndex_image;
						photo_times++;
					}						
				}
				else
				{
					myIndex_video = addFSE(myIndex_video, FSE_OT_Directory, compare, dirName, FILE_TYPE_VIDEO) - 1;
					myIndex_audio = addFSE(myIndex_audio, FSE_OT_Directory, compare, dirName, FILE_TYPE_AUDIO) - 1;
					myIndex_image = addFSE(myIndex_image, FSE_OT_Directory, compare, dirName, FILE_TYPE_PHOTO) - 1;

					audio[audio_times] = myIndex_audio;
					audio_times++;
					video[video_times] = myIndex_video;
					video_times++;
					photo[photo_times] = myIndex_image;
					photo_times++;						

					AddFilesInDirToDB(pidl, myIndex_audio, myIndex_video, myIndex_image, TRUE);
				}

				if(!compare.Compare(dirPath))
				{					
					dir_Count--;
					break;
				}

				number = dirPath.Find(_T('\\'), number + 1);	
				if (number != -1)
				{
                    compare = dirPath.Left(number);
				}
				else
				{
					compare = dirPath;
				}
			}
		}
	}	

	// Clear the queued database query    
	FlushCacheDBQuery();
}

//birdy add for watch
void DeleteOneFileFromDB_watcher(CString dirPath)
{	
	TCHAR			strQuery[MAX_SQL_STR_LENGTH];			
	CString	fileName, dirName, type, compare_dirPath;
	int		i, nPos, fileType, check, Count, first = 0, file_parentIndex[100];	
	char *check_filetype;
	

	compare_dirPath = dirPath;

	_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath = \"%s\""), dirPath);
    Count = db_selectT(strQuery);
	
	nPos = dirPath.ReverseFind('\\');	
    dirName = dirPath.Left(nPos);
	
	fileType = SFGetFileType(dirPath);

	if (fileType == 1)
	{
		check_filetype = "Video";
		type = _T("Video");
	}
	else if(fileType == 2)
	{
		check_filetype = "Audio";
		type = _T("Audio");
	}
	else if(fileType == 4)
	{
		check_filetype = "Image";
		type = _T("Image");
	}
	else
	{
		for (i = 0; i< Count; i++)
		{
			file_parentIndex[i] = testFSE_QS[i].Index;
		}

		for (i = 0; i< Count; i++)
	    {			
			DeleteOneParentIndexFromDB(file_parentIndex[i]);
        }
        //return;
	}

	if (fileType != 0)
	{
        _stprintf(strQuery, _T("delete from FSE_QueryState where FilePath =\"%s\""), dirPath);
        check = db_executeT(strQuery);
	}

	while(1)
	{
		nPos = compare_dirPath.ReverseFind('\\');
        compare_dirPath = compare_dirPath.Left(nPos);

		_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath = \"%s\""), compare_dirPath);
		Count = db_selectT(strQuery);

		if (Count == 0)
		{
			break;
		}

		for (i = 0; i < Count; i++)
	    {
            file_parentIndex[i] = testFSE_QS[i].Index;
		}

		for (i = 0; i < Count; i++)
		{			
			_stprintf(strQuery, _T("select * from FSE_QueryState where pIndex = %d"), file_parentIndex[i]);
		    check = db_selectT(strQuery);

			if (check == 0)
			{				
				_stprintf(strQuery, _T("delete from FSE_QueryState where MyIndex = %d"), file_parentIndex[i]);
				db_executeT(strQuery);
			}
		}

		if (compare_dirPath.GetLength() == 2)
		{
			break;
		}
	}	
		
	FlushCacheDBQuery();
	
}
//
//birdy add for watch ISO 2008/7/15
void AddOneISOToDB_watcher(CString dirPath)
{	
	LPSHELLFOLDER	psfFolder = NULL;
	LPITEMIDLIST	pidl = NULL;
	CString	fileName, dirName, compare, dirPath_compare;
	int		nPos, check = 0, times = 0, check_nofile = 0, dir_Count, first = 0;
//	long	ID;
//	char *check_filetype;
	TCHAR			strQuery[MAX_SQL_STR_LENGTH];
	int				Count, number;
//	int             parentIndex;	
	int             myIndex = 0;
	PSharedDirStruct	pSharedDir;
	long			pIDAudio = 0, pIDVideo = 0, pIDPhoto = 0;
	int audio[100], video[100], photo[100], audio_times = 0, video_times = 0, photo_times = 0;
	long            myIndex_video = 0, myIndex_audio = 0, myIndex_image = 0;
	TCHAR	sqlStr[MAX_SQL_STR_LENGTH];
		
	nPos = dirPath.ReverseFind('\\');
	fileName = dirPath.Right(dirPath.GetLength() - nPos - 1);
	dirName = dirPath.Left(nPos);
	
	_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath =\"%s\" "), dirName);
	
	Count = db_selectT(strQuery);
	totalFileCount -= Count;

	dir_Count = GetSharedDirCount();
    pSharedDir = GetAllSharedDirs();

	while(dir_Count != 0)
	{
		myIndex = 0;
		compare = (CString)pSharedDir[dir_Count - 1].DirPath;

		if (dirPath.GetLength() > compare.GetLength())
		{
			dirPath_compare = dirPath.Left(compare.GetLength());
			number = compare.GetLength();
		}

		if (compare.Compare(dirPath_compare))
		{
			dir_Count--;
			continue;
		}
		else
		{
			first = 0;
			myIndex_video = 0;
			myIndex_audio = 0;
			myIndex_image = 0;
			while(1)
			{				
				_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath = \"%s\""), compare);
                Count = db_selectT(strQuery);

				nPos = compare.ReverseFind('\\');
				dirName = compare.Right(compare.GetLength() - nPos - 1);

				//
				if(compare.Compare(dirPath))
				{					
                    if (first == 0)
					{
						myIndex_video = addFSE(6, FSE_OT_Directory, compare, dirName, FILE_TYPE_VIDEO) - 1;
						myIndex_audio = addFSE(12, FSE_OT_Directory, compare, dirName, FILE_TYPE_AUDIO) - 1;
						myIndex_image = addFSE(15, FSE_OT_Directory, compare, dirName, FILE_TYPE_PHOTO) - 1;

						audio[audio_times] = myIndex_audio;
						audio_times++;
						video[video_times] = myIndex_video;
						video_times++;
						photo[photo_times] = myIndex_image;
						photo_times++;					
						first = 1;
					}
					else
					{
						myIndex_video = addFSE(myIndex_video, FSE_OT_Directory, compare, dirName, FILE_TYPE_VIDEO) - 1;
						myIndex_audio = addFSE(myIndex_audio, FSE_OT_Directory, compare, dirName, FILE_TYPE_AUDIO) - 1;
						myIndex_image = addFSE(myIndex_image, FSE_OT_Directory, compare, dirName, FILE_TYPE_PHOTO) - 1;

						audio[audio_times] = myIndex_audio;
						audio_times++;
						video[video_times] = myIndex_video;
						video_times++;
						photo[photo_times] = myIndex_image;
						photo_times++;
					}						
				}
				else
				{
					//myIndex_video = addFSE(myIndex_video, FSE_OT_Directory, compare, dirName, FILE_TYPE_VIDEO) - 1;
					//myIndex_audio = addFSE(myIndex_audio, FSE_OT_Directory, compare, dirName, FILE_TYPE_AUDIO) - 1;
					//myIndex_image = addFSE(myIndex_image, FSE_OT_Directory, compare, dirName, FILE_TYPE_PHOTO) - 1;

					audio[audio_times] = myIndex_audio;
					audio_times++;
					video[video_times] = myIndex_video;
					video_times++;
					photo[photo_times] = myIndex_image;
					photo_times++;						

					//AddFilesInDirToDB(pidl, myIndex_audio, myIndex_video, myIndex_image, TRUE);
					int flag[3];
					struct BkFileBase *base;
					struct VolInfo *volInfo;
					volInfo = (struct VolInfo*)malloc(sizeof(VolInfo));

					//Utf8ToWide(unicodeFilePath,tmpPath,MAX_PATH_LENGTH);
					//int pos=fileName.ReverseFind(_T('.'));
					//TCHAR *filename;
					
					//filename = (TCHAR*)malloc(1000*sizeof(TCHAR));
					//memset(filename,0x00,1000*sizeof(TCHAR));
					//wcsncpy(filename,fileName,pos);
					//wcscat(fileName,_T("(iso)"));
					fileName = fileName + _T("(iso)");
//					CString strExt = filepath.Right(filepath.GetLength() - pos);
					
					flag[0]=qsCount;
					_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType,  FilePath, FileName, FileType, ObjectType) \
						values(%d, %d,%d, %d, \"%s\",\"%s\",\"%s\" ,%d)"), qsCount,FLAGS_ISO,myIndex_audio,FSE_OT_Directory ,dirPath,fileName,_T("Audio") ,FSE_OT_Directory);

					db_executeT(sqlStr);
					qsCount++;

					flag[1]=qsCount;
					_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType,  FilePath, FileName, FileType, ObjectType) \
						values(%d, %d,%d, %d, \"%s\",\"%s\",\"%s\" ,%d)"), qsCount,FLAGS_ISO,myIndex_video,FSE_OT_Directory ,dirPath,fileName,_T("Video") ,FSE_OT_Directory);

					db_executeT(sqlStr);
					qsCount++;

					flag[2]=qsCount;
					_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,Flags,pIndex, ProcessObjectType,  FilePath, FileName, FileType, ObjectType) \
						values(%d, %d,%d, %d, \"%s\",\"%s\",\"%s\" ,%d)"), qsCount,FLAGS_ISO,myIndex_image,FSE_OT_Directory ,dirPath,fileName,_T("Image") ,FSE_OT_Directory);

					db_executeT(sqlStr);
					qsCount++;

					//flag[0] = myIndex_audio;
					//flag[1] = myIndex_video;
					//flag[2] = myIndex_image;
					
					//res=fnIsoparser(dirPath,volInfo);
					fnIsoparser((TCHAR *)dirPath.GetString(),volInfo);

					base = (BkFileBase*)BK_BASE_PTR( &(volInfo->dirTree) );
					


					int subStatus=addIsoContentstoDB(base,10,(TCHAR *)dirPath.GetString(),flag);
				}

				if(!compare.Compare(dirPath))
				{					
					dir_Count--;
					break;
				}

				number = dirPath.Find(_T('\\'), number + 1);	
				if (number != -1)
				{
                    compare = dirPath.Left(number);
				}
				else
				{
					compare = dirPath;
				}
			}
		}
	}	

	// Clear the queued database query    
	FlushCacheDBQuery();

}

void AddOneFileToDB_watcher(CString filePath)
{
	CString	fileName, dirName, compare, filePath_compare;
	int		nPos, fileType, check = 0, times = 0, check_nofile = 0, dir_Count;
	long	ID;
	char *check_filetype;
	TCHAR			strQuery[MAX_SQL_STR_LENGTH];
	int				i = 0, Count, number;
//	int             parentIndex;	
	int             myIndex = 0;
	PSharedDirStruct	pSharedDir;

	_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath =\"%s\" "), filePath);
	Count = db_selectT(strQuery);

	if (Count != 0)
	{
		return;
	}

	nPos = filePath.ReverseFind('\\');
	fileName = filePath.Right(filePath.GetLength() - nPos - 1);
	dirName = filePath.Left(nPos);
	
	_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath =\"%s\" "), dirName);
	
	Count = db_selectT(strQuery);
	totalFileCount -= Count;

	fileType = SFGetFileType(fileName);

	if (fileType == 1 || fileType == 17)
	{
		check_filetype = "Video";		
	}
	else if(fileType == 2)
	{
		check_filetype = "Audio";		
	}
	else if(fileType == 4)
	{
		check_filetype = "Image";		
	}
	else if(fileType == 64)
	{
        AddOneISOToDB_watcher(filePath);
		return;
	}
	else
	{
		return;
	}
	
	dir_Count = GetSharedDirCount();
    pSharedDir = GetAllSharedDirs();

	while(dir_Count != 0)
	{
		myIndex = 0;
		compare = (CString)pSharedDir[dir_Count - 1].DirPath;

		if (filePath.GetLength() > compare.GetLength())
		{
			filePath_compare = filePath.Left(compare.GetLength());
			number = compare.GetLength();
		}

		if (compare.Compare(filePath_compare))
		{
			dir_Count--;
			continue;
		}
		else
		{
			while(1)
			{				
				_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath = \"%s\" and FileType = \"%s\""), compare, check_filetype);
                Count = db_selectT(strQuery);

                if (Count == 0)
                {
					if (myIndex == 0)
					{
						if (fileType == 1 || fileType == 17)
	                    {
                            myIndex = 6;
						}
                        else if(fileType == 2)
                        {
                            myIndex = 12;
						}
                        else if(fileType == 4)
                        {
                            myIndex = 15;
						}
                    }

                    nPos = compare.ReverseFind('\\');
					dirName = compare.Right(compare.GetLength() - nPos - 1);	

					if(compare.Compare(filePath))
					{
                        ID = addFSE(myIndex, FSE_OT_Directory, compare, dirName, fileType);		
                        myIndex = ID - 1;
					}
					else
					{
						ID = addFSE(myIndex, FSE_OT_File, compare, dirName, fileType);		
                        myIndex = ID - 1;
					}
                }
				else
				{
					myIndex = testFSE_QS[i].pIndex;
				}


				if(!compare.Compare(filePath))
				{					
					dir_Count--;
					break;
				}

				number = filePath.Find(_T('\\'), number + 1);	
				if (number != -1)
				{
                    compare = filePath.Left(number);
				}
				else
				{
					compare = filePath;
				}
			}
		}
	}

	// Clear the queued database query    
	FlushCacheDBQuery();
}
//

//birdy 2007/11/29 add for m3ulist
void AddOneDirectoryToDB_M3u(CString filePath, CString Title, int FileType)
{
	TCHAR	sqlStr[MAX_SQL_STR_LENGTH];

	int parent;
	CString fileType;

    if (FileType == 1) 
	{
		parent = 16;
		fileType = "Video";
	}
	else if (FileType == 0) 
	{
		parent = 18;	
		fileType = "Audio";
	}

	_stprintf(sqlStr,_T("Insert into FSE_QueryState (MyIndex,pIndex, ProcessObjectType, FilePathLen, FilePath, FileName, FileType, ObjectType) \
				   values(%d, %d, %d, %d,\"%s\",\"%s\",\"%s\" ,%d)"), qsCount,parent,FSE_OT_Directory,filePath.GetLength() ,filePath, Title,fileType ,FSE_OT_Directory);

	db_executeT(sqlStr);
	M3U_parent = qsCount;
	qsCount++;	
}

//birdy 2008/2/1 add for Neuf m3ulist
void AddOneURLToDB_M3U_Neuf(CString filePath, CString Title, int FileType)
{	
	// FileType = 0-->AUDEO, FileType = 1-->VIDIO	
	if (FileType == 1) 
	{
		addFSE_FilesOnly(27, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);		
	}
	else if (FileType == 0) 
	{
		addFSE_FilesOnly(27, FSE_OT_File, filePath, Title, FILE_TYPE_AUDIO, 2);
	}
	// Clear the queued database query
	FlushCacheDBQuery();
}
//

//birdy 2007/12/27 add for FreeBox m3ulist
void AddOneURLToDB_M3U_FreeBox(CString filePath, CString Title, int FileType)
{	
	// FileType = 0-->AUDEO, FileType = 1-->VIDIO	
	if (FileType == 1) 
	{
		addFSE_FilesOnly(26, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);		
	}
	else if (FileType == 0) 
	{
		addFSE_FilesOnly(26, FSE_OT_File, filePath, Title, FILE_TYPE_AUDIO, 2);
	}
	// Clear the queued database query
	FlushCacheDBQuery();
}
//

//birdy 2007/11/29 add for m3ulist
void AddOneURLToDB_M3U(CString filePath, CString Title, int FileType)
{	
	// FileType = 0-->AUDEO, FileType = 1-->VIDIO	
	if (FileType == 1) 
	{
		addFSE_FilesOnly(M3U_parent, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);		
	}
	else if (FileType == 0) 
	{
		addFSE_FilesOnly(M3U_parent, FSE_OT_File, filePath, Title, FILE_TYPE_AUDIO, 2);
	}
	// Clear the queued database query
	FlushCacheDBQuery();
}
//

//birdy 2007/12/21 add for Youtube
void AddYoutubeToDB(CString filePath, CString Title, int FileTypeint, int Youtube_type)
{
	long	ID;
	// FileType = 0-->AUDEO, FileType = 1-->VIDIO

#ifdef STOREX
	if (Youtube_type == 0) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(28, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);	
	}
	else if (Youtube_type == 1) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(29, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 2) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(30, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 3) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(31, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 4) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(32, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 5) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(33, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 6) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(34, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 7) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(35, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
#else YOUTUBE_SUPPORT
	if (Youtube_type == 0) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(21, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);	
	}
	else if (Youtube_type == 1) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(22, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 2) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(23, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 3) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(24, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 4) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(25, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 5) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(26, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 6) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(27, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (Youtube_type == 7) 
	{
		//ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(28, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}

#endif
	
	FlushCacheDBQuery();
}
//

//birdy 200710/1
void AddOneURLToDB(CString filePath, CString Title, int FileType)
{
	long	ID;
	// FileType = 0-->AUDEO, FileType = 1-->VIDIO
	if (FileType == 1) 
	{
		ID = addFSE_FilesOnly(16, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	else if (FileType == 0) 
	{
		ID = addFSE_FilesOnly(18, FSE_OT_File, filePath, Title, FILE_TYPE_AUDIO, 2);
		ID = addFSE_FilesOnly(19, FSE_OT_File, filePath, Title, FILE_TYPE_AUDIO, 2);
	}
	else
	{
		ID = addFSE_FilesOnly(FileType, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
		ID = addFSE_FilesOnly(17, FSE_OT_File, filePath, Title, FILE_TYPE_VIDEO, 1);
	}
	// Clear the queued database query
	FlushCacheDBQuery();
}
//

void AddOneFileToDB(CString filePath)
{
	CString	fileName, dirName;
	int		nPos, fileType;
	long	ID;

	nPos = filePath.ReverseFind('\\');
	fileName = filePath.Right(filePath.GetLength() - nPos - 1);
	dirName = filePath.Left(nPos);

	fileType = SFGetFileType(fileName);
	if (fileType & FILE_TYPE_VIDEO) 
	{
		ID = addFSE(DB_VIDEO_ALL_VIDEO_ID, FSE_OT_File, filePath, fileName, FILE_TYPE_VIDEO);
		ID = addFSE_FilesOnly(DB_VIDEO_MY_FOLDERS, FSE_OT_File, filePath, fileName, FILE_TYPE_VIDEO, 0);

		LPSHELLFOLDER	psfFolder = NULL;
		LPITEMIDLIST	pidl = NULL;
		DWORD			dwAttributes = SFGAO_REMOVABLE;

		if (SUCCEEDED(psfDesktop->ParseDisplayName(NULL, NULL, (LPOLESTR) dirName.GetString(), 
												   NULL, &pidl, NULL)))
		{
			if (SUCCEEDED(psfDesktop->BindToObject(pidl, NULL, IID_IShellFolder, (void**)&psfFolder)))
			{
				psfFolder->GetAttributesOf(1, (LPCITEMIDLIST*) &pidl, &dwAttributes);
				psfFolder->Release();
			}
			pMalloc->Free(pidl);
		}

		CString  strExt = fileName.Right(fileName.GetLength() - fileName.ReverseFind(_T('.')));
			
		// We don't create video index files in removable device (CDROM or DVDROM);
		if (!(dwAttributes & SFGAO_REMOVABLE))
		{						
			/*if ((strExt.CompareNoCase(_T(".vob")) == 0) || 
				(strExt.CompareNoCase(_T(".mpeg2")) == 0) ||  
				(strExt.CompareNoCase(_T(".mpg")) == 0) ||
				(strExt.CompareNoCase(_T(".avi")) == 0))*/
			//birdy 2007/5/14 support TS,M2TS,TP
			if ((strExt.CompareNoCase(_T(".vob")) == 0) ||
                (strExt.CompareNoCase(_T(".mpeg2")) == 0) ||  
				(strExt.CompareNoCase(_T(".mpg")) == 0) ||
				(strExt.CompareNoCase(_T(".avi")) == 0) ||
				(strExt.CompareNoCase(_T(".ts")) == 0) ||
				(strExt.CompareNoCase(_T(".m2ts")) == 0) ||
				(strExt.CompareNoCase(_T(".tp")) == 0)   ||
				(strExt.CompareNoCase(_T(".mpeg")) == 0)
				)
			{
				// scan video file and create GOP(I frame) index for render
				AddVideoFileToScanList(filePath);
			}
		}
	}
	else if (fileType & FILE_TYPE_AUDIO) 
	{
		ID = addFSE(DB_AUDIO_ALL_MUSIC_ID, FSE_OT_File, filePath, fileName, FILE_TYPE_AUDIO);
		ID = addFSE_FilesOnly(DB_AUDIO_MY_FOLDERS, FSE_OT_File, filePath, fileName, FILE_TYPE_AUDIO, 0);
	}
	else if (fileType & FILE_TYPE_PHOTO) 
	{
		ID = addFSE(DB_IMAGE_ALL_IMAGE_ID, FSE_OT_File, filePath, fileName, FILE_TYPE_PHOTO);
		ID = addFSE_FilesOnly(DB_IMAGE_MY_FOLDERS, FSE_OT_File, filePath, fileName, FILE_TYPE_PHOTO, 0);
	}
	else if (fileType & FILE_TYPE_PLAYLIST) 
	{
		if (IsFilteredFile(fileName, FILE_TYPE_PLAYLIST))
		{
			//TCHAR	lstFilePath[MAX_PATH_LENGTH];

			//_stprintf(lstFilePath, _T("%s\\cache\\%d%s.lst"), gWorkingDir, qsCount, 
			//		  fileName.Left(fileName.ReverseFind(_T('.'))));
			CString		lstFilePath;
			TCHAR		sqlStr[MAX_SQL_STR_LENGTH];

			lstFilePath = filePath.Left(filePath.ReverseFind(_T('.')));
			lstFilePath += _T(".lst");

			_stprintf(sqlStr, _T("select * from FSE_QueryState where FilePath =\"%s\""), lstFilePath);

			if (db_selectT(sqlStr) == 0)
			{
				addFSE(DB_AUDIO_ALL_MUSIC_ID, FSE_OT_File, lstFilePath, fileName, fileType);
				ID = addFSE(DB_AUDIO_MY_FOLDERS, FSE_OT_File, lstFilePath, fileName, fileType) - 1;

				// we generate a new playlist file, named xxx.lst
				// when render query for xxx.m3u or xxx.pls, 
				// the server will response with a xxx.lst
				GenerateNewPlaylist(filePath, lstFilePath, ID);
			}
		}
	}

	// Clear the queued database query
	FlushCacheDBQuery();
}

void AddMyFavoriteFileToDB(CString filePath)
{
	CString	fileName, dirName;
	int		nPos, fileType;

	nPos = filePath.ReverseFind('\\');
	fileName = filePath.Right(filePath.GetLength() - nPos - 1);

	fileType = SFGetFileType(fileName);
	
	if (fileType & FILE_TYPE_VIDEO) 
	{
		addFSE_FilesOnly(DB_VIDEO_MY_FAVORITES_ID, FSE_OT_File, filePath, fileName, FILE_TYPE_VIDEO, 0);
	}
	else if (fileType & (FILE_TYPE_AUDIO |  FILE_TYPE_PLAYLIST)) 
	{
		addFSE_FilesOnly(DB_AUDIO_MY_FAVORITES_ID, FSE_OT_File, filePath, fileName, FILE_TYPE_AUDIO, 0);
	}
	else if (fileType & FILE_TYPE_PHOTO) 
	{
		addFSE_FilesOnly(DB_IMAGE_MY_FAVORITES_ID, FSE_OT_File, filePath, fileName, FILE_TYPE_PHOTO, 0);
	}

	// Clear the queued database query
	FlushCacheDBQuery();
}

void DeleteOneFileFromDB(CString filePath, int isMyFavoriteFile)
{
	CList<int, int>	m_pList(100);
	TCHAR			strQuery[MAX_SQL_STR_LENGTH];
	int				i, dbCount, parentIndex;
	
	if (SFGetFileType(filePath) == FILE_TYPE_VIDEO)
	{
		// Video file, delete the index file if it exists
		DeleteVideoIndexFile(filePath);
	}

	_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath =\"%s\" "), filePath);
		
	dbCount = db_selectT(strQuery);						
	totalFileCount -= dbCount;

	for (i = 0; i < dbCount; i++)
	{
		parentIndex = testFSE_QS[i].pIndex;

		// decrease count if the related files are remove
		if (parentIndex == DB_VIDEO_ALL_VIDEO_ID)
		{
			videoCount--;
		}
		else if (parentIndex == DB_AUDIO_ALL_MUSIC_ID)
		{
			if (testFSE_QS[i].Flags & FLAGS_PLAYLIST)
			{
				playlistCount--;

				// Remove all files under this playlist ID
				if (!m_pList.Find(testFSE_QS[i].Index))
				{
					m_pList.AddTail(testFSE_QS[i].Index);
				}
			}
			else
			{
				audioCount--;
			}
		}
		else if (parentIndex == DB_IMAGE_ALL_IMAGE_ID)
		{
			imageCount--;
		}

		if ((parentIndex > 15) && !m_pList.Find(parentIndex))
		{
			// keep the record of the parent ID of deleted items
			m_pList.AddTail(parentIndex);
		}
	}

	if (isMyFavoriteFile)
	{
		// remove the item with Favorite flag set
		_stprintf(strQuery, _T("delete from FSE_QueryState where FilePath =\"%s\" and Favorite = 1"), filePath);
	}
	else 
	{
		_stprintf(strQuery, _T("delete from FSE_QueryState where FilePath =\"%s\""), filePath);
	}

	db_executeT(strQuery);

	// Search to find there is any parent item that should be remove (no child)
	while (!m_pList.IsEmpty())
	{
		parentIndex = m_pList.GetHead();
		m_pList.RemoveHead();

		_stprintf(strQuery, _T("select * from FSE_QueryState where pIndex =%d "), parentIndex);
		dbCount = db_getCountT(strQuery);

		if ((dbCount == 0) && parentIndex > 15)
		{
			DBQueryState	queryState;

			_stprintf(strQuery, _T("select * from FSE_QueryState where MyIndex =%d "), parentIndex);
			db_getOneRecordT(strQuery, &queryState);

			_stprintf(strQuery, _T("delete from FSE_QueryState where FilePath =\"%s\" "), (TCHAR *) queryState.FilePath);
			db_executeT(strQuery);
			
			if ((queryState.pIndex > 15) && (parentIndex != queryState.pIndex) &&
				(!m_pList.Find(queryState.pIndex)))
			{
				m_pList.AddTail(queryState.pIndex);
			}
		}
	}

	// Clear the queued database query
	FlushCacheDBQuery();
}


// Description: Add a user shared directories in database
// Input: 
//		dirPath: the path of directory that user want to add
// Output:
//      Return: TRUE: success, FASLE: fail
int	AddOneSharedDirToDB(CString& dirPath)
{
	SharedDirStruct	sharedDir;
	TCHAR			strSQL[MAX_SQL_STR_LENGTH];

	if (SelectSharedDir(dirPath, &sharedDir) == TRUE)
	{
		// The selected dir already was in database
		CleanQueueQueryInDatabase();
		return FALSE;
	}

	_stprintf(strSQL, _T("Insert into Shared_Folder (DirPath, Flags, VolumeName) values(\"%s\", %d,  \"%s\")"),
			  dirPath, 0, _T(""));

	if (db_executeT(strSQL))
	{
		// Add this dir successfully
		return TRUE;
	}
	else
	{
		// Fail to add this dir
		return FALSE;
	}
}

// Description: The thread that scans one shared dir
// Input:
// 		args: the selected shared directory path
// Output:
//      Return: None
DWORD WINAPI ScanOneSharedDirThread(LPVOID args)
{
	CString		*dirPath;

	//birdy 2008/1/4 add for fix refresh icon bug
	control_scanICON_change = 0;
	//
	while (WaitForSingleObject(hScanFilesMutex, 100L) != WAIT_OBJECT_0)
	{
		Sleep(100);
	}

	skipScanFiles = FALSE;

	dirPath = (CString *) args;

	ScanOneSharedDir(*dirPath);

	ReleaseMutex(hScanFilesMutex);

	// Clear the scanned file name when the scan finishs
	_tcscpy(currentScanFileName, _T(""));
	inScanFiles = FALSE;
	
	// Clear the queued database query
	FlushCacheDBQuery();

	//birdy 2008/1/4 add for fix refresh icon bug
	control_scanICON_change = 1;
	//
	return TRUE;
}

// Description: The thread that scans one shared dir
// Input:
// 		args: a array of the selected shared directory path
// Output:
//      Return: None
DWORD WINAPI ScanMultiSharedDirThread(LPVOID args)
{
	CString		*dirPath;

	//birdy 2008/1/4 add for fix refresh icon bug
	control_scanICON_change = 0;

	while (WaitForSingleObject(hScanFilesMutex, 100L) != WAIT_OBJECT_0)
	{
		Sleep(100);
	}

	skipScanFiles = FALSE;

	dirPath = (CString *) args;

	//while (_tcscmp(*dirPath,  _T("")))
	while (*dirPath != _T(""))
	{
		ScanOneSharedDir(*dirPath);
		dirPath++;
	}

	ReleaseMutex(hScanFilesMutex);

	dirPath = (CString *) args;

	delete[] dirPath;

	// Clear the scanned file name when the scan finishs
	_tcscpy(currentScanFileName, _T(""));
	inScanFiles = FALSE;
	
	// Clear the queued database query
	FlushCacheDBQuery();

	//birdy 2008/1/4 add for fix refresh icon bug
	control_scanICON_change = 1;

	return TRUE;
}

// Description: Get the information of all user shared directories in database
// Input: 
//		dirPath: the path of directory that user want to add
// Output:
//      Return: TRUE: success, FASLE: fail
int	ScanOneSharedDir(CString& dirPath)
{
	LPSHELLFOLDER	psfFolder = NULL;
	LPITEMIDLIST	pidl = NULL;
	TCHAR			strSQL[MAX_SQL_STR_LENGTH];
	long			pIDAudio, pIDVideo, pIDPhoto;
	int				subDirStatus;
	
	if (FAILED(psfDesktop->ParseDisplayName(NULL, NULL, (LPOLESTR) dirPath.GetString(), NULL, &pidl, NULL)))
	{
		// Cannot get the folder with dirPath
		DeleteOneSharedDirThread(&dirPath);
		//CImportPage2::updataList();
		return -1;
	}

	if (FAILED(psfDesktop->BindToObject(pidl, NULL, IID_IShellFolder, (void**)&psfFolder)))
	{
		pMalloc->Free(pidl);
		return FALSE;
	}

	pIDAudio = addFSE(DB_AUDIO_MY_FOLDERS, FSE_OT_Directory, dirPath, dirPath, FILE_TYPE_AUDIO) - 1;
	pIDVideo = addFSE(DB_VIDEO_MY_FOLDERS, FSE_OT_Directory, dirPath, dirPath, FILE_TYPE_VIDEO) - 1;
	pIDPhoto = addFSE(DB_IMAGE_MY_FOLDERS, FSE_OT_Directory, dirPath, dirPath, FILE_TYPE_PHOTO) -1 ;

	subDirStatus = AddFilesInDirToDB(pidl, pIDAudio, pIDVideo, pIDPhoto, TRUE);
	
	if (!(subDirStatus & (FILE_TYPE_AUDIO  | FILE_TYPE_PLAYLIST)))
	{
		// There is no audio file, remove this directory from datatbase
		_stprintf(strSQL, _T("delete from FSE_QueryState where MyIndex = %d"), pIDAudio);
		db_executeT(strSQL);
	}

	if (!(subDirStatus & FILE_TYPE_VIDEO))
	{
		// There is no video file, remove this directory from datatbase
		_stprintf(strSQL, _T("delete from FSE_QueryState where MyIndex = %d"), pIDVideo);
		db_executeT(strSQL);
	}

	if (!(subDirStatus & FILE_TYPE_PHOTO))
	{
		// There is no photo file, remove this directory from datatbase
		_stprintf(strSQL, _T("delete from FSE_QueryState where MyIndex = %d"), pIDPhoto);
		db_executeT(strSQL);
	}

	// release all remaining interface pointers
   	pMalloc->Free(pidl);
	psfFolder->Release();

	return TRUE;
}

// Description: The thread that scans one shared dir
// Input: None
// Output:
//      Return: None
DWORD WINAPI ScanAllSharedDirThread(LPVOID args)
{
	PSharedDirStruct	pSharedDir;
	CString				dirPath;
	int					count, i;

	while (WaitForSingleObject(hScanFilesMutex, 100L) != WAIT_OBJECT_0)
	{
		Sleep(100);
	}

	skipScanFiles = FALSE;

	// Load the all shared directories from database
	count = GetSharedDirCount();
	pSharedDir = GetAllSharedDirs();

	for (i = 0; i < count; i++)
	{
		dirPath = pSharedDir[i].DirPath;
		ScanOneSharedDir(dirPath);		
	}

	FREE(pSharedDir);

	ReleaseMutex(hScanFilesMutex);

	// Clear the scanned file name when the scan finishs
	_tcscpy(currentScanFileName, _T(""));
	inScanFiles = FALSE;
	
	// Clear the queued database query
	FlushCacheDBQuery();

	return TRUE;
}

// Description: The thread that refreshs one shared dir
// Input:
// 		args: the selected shared directory path
// Output:
//      Return: None
DWORD WINAPI RefreshOneSharedDirThread(LPVOID args)
{
	DBQueryState	queryState;
	CString			*dirPath;
	TCHAR			strQuery[MAX_SQL_STR_LENGTH];

	while (WaitForSingleObject(hScanFilesMutex, 100L) != WAIT_OBJECT_0)
	{
		Sleep(100);
	}

	skipScanFiles = FALSE;

	dirPath = (CString *) args;

	// Delete all files under this directory in database
	//_stprintf(strQuery, _T("delete from SHARED_FOLDER where DirPath = \"%s\""), *dirPath);
	//db_executeT(strQuery);

	_stprintf(strQuery,  _T("select * from FSE_QueryState where FilePath =\"%s\" and pIndex=%d"), 
			  *dirPath, DB_AUDIO_MY_FOLDERS);
	if (db_getOneRecordT(strQuery, &queryState) != 0)
	{
		DeleteOneParentIndexFromDB(queryState.Index);
	}

	_stprintf(strQuery,  _T("select * from FSE_QueryState where FilePath =\"%s\" and pIndex=%d"), 
			  *dirPath, DB_VIDEO_MY_FOLDERS);
	if (db_getOneRecordT(strQuery, &queryState) != 0)
	{
		DeleteOneParentIndexFromDB(queryState.Index);
	}
	_stprintf(strQuery,  _T("select * from FSE_QueryState where FilePath =\"%s\" and pIndex=%d"), 
			  *dirPath, DB_IMAGE_MY_FOLDERS);
	if (db_getOneRecordT(strQuery, &queryState) != 0)
	{
		DeleteOneParentIndexFromDB(queryState.Index);
	}

	// Scan this share folder 
	ScanOneSharedDir(*dirPath);

	ReleaseMutex(hScanFilesMutex);

	// Clear the scanned file name when the scan finishs
	_tcscpy(currentScanFileName, _T(""));
	inScanFiles = FALSE;
	
	// Clear the queued database query
	FlushCacheDBQuery();

	return TRUE;
}

// Description: The thread that refresh the content of all shared folders
// Input: None
// Output:
//      Return: None
DWORD WINAPI RefreshAllSharedDirThread(LPVOID args)
{
	PSharedDirStruct	pSharedDir;
	CString				dirPath;
	int					count, i, j;

	//birdy 2008/1/4 add for fix refresh icon bug
	control_scanICON_change = 0;
	//
	while (WaitForSingleObject(hScanFilesMutex, 100L) != WAIT_OBJECT_0)
	{
		Sleep(100);
	}

	qsCount = 4;
	audioCount = 0;
	videoCount = 0;
	imageCount = 0;
	filterCount = 0;
	playlistCount = 0;
	rejectCount = 0;
	totalFileCount = 0;

	// Clear all records in database
	db_executeT(_T("delete from FSE_QueryState"));

	//birdy 2007/12/25 add for susped Youtube thread
#ifdef YOUTUBE_SUPPORT
	//SuspendThread(YoutubeThreadHandle);
	set_YoutubeRefresh(1);
#endif

#ifdef STOREX
	SuspendThread(Renew_M3U_FreeBox_hreadHandle);
	SuspendThread(Renew_M3UT_hreadHandle);
#endif

	initFSE_QS();

	// Clear all generated video index files
	CString	cacheFolderPath;

	cacheFolderPath = gWorkingDir;
	cacheFolderPath += _T("\\cache");
	CFolderUtils::RemoveFolder(cacheFolderPath);
	CreateDirectory(cacheFolderPath, NULL);

	// Clear all generated bmp files
	CString	thumbnailFolderPath;

	thumbnailFolderPath = gWorkingDir;
	thumbnailFolderPath += _T("\\thumbnail");
	CFolderUtils::RemoveFolder(thumbnailFolderPath);
	CreateDirectory(thumbnailFolderPath, NULL);

	skipScanFiles = FALSE;

	// Load the all shared directories from database
	count = GetSharedDirCount();
	pSharedDir = GetAllSharedDirs();

	for (i = 0; i < count; i++)
	{
		dirPath = pSharedDir[i].DirPath;
		j = ScanOneSharedDir(dirPath);
		if (j == -1)
		{
			control_updata_list = 1;
		}
	}
#ifdef STOREX
	ResumeThread(Renew_M3U_FreeBox_hreadHandle);
	ResumeThread(Renew_M3UT_hreadHandle);
#endif

//birdy 2007/12/25 add for resume Youtube thread
#ifdef YOUTUBE_SUPPORT
	//ResumeThread(YoutubeThreadHandle);
#endif

	//birdy 2008/1/4 add for fix refresh icon bug
	control_scanICON_change = 1;
	//
	FREE(pSharedDir);

	ReleaseMutex(hScanFilesMutex);

	// Clear the scanned file name when the scan finishs
	_tcscpy(currentScanFileName, _T(""));
	inScanFiles = FALSE;
	
	// Clear the queued database query
	FlushCacheDBQuery();

	return TRUE;
}

// Description: The thread that delete one shared dir
// Input: 
// 		args: the selected shared directory path to be deleted
// Output:
//      Return: None
DWORD WINAPI DeleteOneSharedDirThread(LPVOID args)
{
	DBQueryState	queryState;
	CString			*dirPath;
	TCHAR			strQuery[MAX_SQL_STR_LENGTH];

	//birdy 2008/1/4 add for fix refresh icon bug
	control_scanICON_change = 0;
	//
	while (WaitForSingleObject(hScanFilesMutex, 100L) != WAIT_OBJECT_0)
	{
		Sleep(100);
	}

	skipScanFiles = FALSE;

	dirPath = (CString *) args;
	
	_stprintf(strQuery, _T("delete from SHARED_FOLDER where DirPath = \"%s\""), *dirPath);
	db_executeT(strQuery);

	_stprintf(strQuery,  _T("select * from FSE_QueryState where FilePath =\"%s\" and pIndex=%d"), 
			  *dirPath, DB_AUDIO_MY_FOLDERS);
	if (db_getOneRecordT(strQuery, &queryState) != 0)
	{
		DeleteOneParentIndexFromDB(queryState.Index);
	}

	_stprintf(strQuery,  _T("select * from FSE_QueryState where FilePath =\"%s\" and pIndex=%d"), 
			  *dirPath, DB_VIDEO_MY_FOLDERS);
	if (db_getOneRecordT(strQuery, &queryState) != 0)
	{
		DeleteOneParentIndexFromDB(queryState.Index);
	}
	_stprintf(strQuery,  _T("select * from FSE_QueryState where FilePath =\"%s\" and pIndex=%d"), 
			  *dirPath, DB_IMAGE_MY_FOLDERS);
	if (db_getOneRecordT(strQuery, &queryState) != 0)
	{
		DeleteOneParentIndexFromDB(queryState.Index);
	}

	ReleaseMutex(hScanFilesMutex);
	inScanFiles = FALSE;
	
	// Clear the queued database query
	FlushCacheDBQuery();

	//birdy 2008/1/4 add for fix refresh icon bug
	control_scanICON_change = 1;
	//
	return TRUE;
}

void DeleteOneParentIndexFromDB(int pIndex)
{
	DBQueryState	*queryState, oneQueryRecord;
	CList<int, int>	m_pList(100);
	TCHAR			strQuery[MAX_SQL_STR_LENGTH];
	int				i, dbCount;

	// Delete the item with this index ID
	_stprintf(strQuery, _T("delete from FSE_QueryState where MyIndex = %d"), pIndex);
	db_executeT(strQuery);

	_stprintf(strQuery, _T("select * from FSE_QueryState where pIndex = %d"), pIndex);
	dbCount = db_selectT(strQuery);

	if (dbCount == 0)
	{
		// No items with this parent ID
		return;
	}

	// Save these query result in our allocated memory to avoid result is 
	// overwritten by another db_selectT
	queryState = (DBQueryState *) MALLOC(dbCount * sizeof(DBQueryState));
	for (i = 0; i < dbCount; i++)
	{
		queryState[i] = testFSE_QS[i];
	}

	for (i = 0; i < dbCount; i++)
	{
		if (queryState[i].ObjectType == FSE_OT_File)
		{
			TCHAR	wStr[MAX_SQL_STR_LENGTH];
			int		usedCount, queryCount;

			usedCount = 2;				// "My Folder" and "All XXXX"
			if (queryState[i].Album[0] != 0x00)
			{
				// Has a record for Album
				usedCount++;
			}

			if (queryState[i].Author[0] != 0x00)
			{
				// Has a record for Author
				usedCount++;
			}

			if (queryState[i].Genre[0] != 0x00)
			{
				// Has a record for Gener
				usedCount++;
			}

			Utf8ToStr(wStr, queryState[i].FilePath, MAX_PATH);
			_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath =\"%s\""), wStr);
			queryCount = db_selectT(strQuery);

			if (usedCount >= queryCount)
			{
				// Only this directory reference this item with this filepath
				totalFileCount--;

				if (queryState[i].Flags & FLAGS_PLAYLIST)
				{
					// Remove all files under this playlist
					_stprintf(strQuery, _T("delete from FSE_QueryState where pIndex =%d"), 
							  queryState[i].Index);
					db_executeT(strQuery);
					playlistCount -= 2;
					totalFileCount--;
				}
				else if (strcmp(queryState[i].FileType, "Video") == 0)
				{
					// Delete the video index file
			        TCHAR	FilePathStr[MAX_SQL_STR_LENGTH];
			        Utf8ToStr(FilePathStr, queryState[i].FilePath, MAX_PATH);
					DeleteVideoIndexFile(FilePathStr);
					videoCount--;
				}
				else if (strcmp(queryState[i].FileType, "Audio") == 0)
				{
					audioCount--;
				}
				else if (strcmp(queryState[i].FileType, "Image") == 0)
				{
					imageCount--;
				}

				// Delete the items with this file path
				_stprintf(strQuery, _T("delete from FSE_QueryState where FilePath =\"%s\""), wStr);
				db_executeT(strQuery);

				if (queryState[i].Album[0] != 0x00)
				{
					Utf8ToStr(wStr, queryState[i].Album, MAX_PATH);
					_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath =\"%s\""), wStr);
					
					if (db_getOneRecordT(strQuery, &oneQueryRecord))
					{
						if ((oneQueryRecord.Index > 15) && !m_pList.Find(oneQueryRecord.Index))
						{
							m_pList.AddTail(oneQueryRecord.Index);
						}
					}
				}

				if (queryState[i].Author[0] != 0x00)
				{
					Utf8ToStr(wStr, queryState[i].Author, MAX_PATH);
					_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath =\"%s\""), wStr);

					if (db_getOneRecordT(strQuery, &oneQueryRecord))
					{
						if ((oneQueryRecord.Index > 15) && !m_pList.Find(oneQueryRecord.Index))
						{
							m_pList.AddTail(oneQueryRecord.Index);
						}
					}
				}

				if (queryState[i].Genre[0] != 0x00)
				{
					Utf8ToStr(wStr, queryState[i].Genre, MAX_PATH);
					_stprintf(strQuery, _T("select * from FSE_QueryState where FilePath =\"%s\""), wStr);
					
					if (db_getOneRecordT(strQuery, &oneQueryRecord))
					{
						if ((oneQueryRecord.Index > 15) && !m_pList.Find(oneQueryRecord.Index))
						{
							m_pList.AddTail(oneQueryRecord.Index);
						}
					}
				}
			}
			else
			{
				// There is other directories reference the items with this index
				_stprintf(strQuery, _T("delete from FSE_QueryState where MyIndex =%d"), 
					      queryState[i].Index);
				
				db_executeT(strQuery);
			}
		}
		else
		{
			DeleteOneParentIndexFromDB(queryState[i].Index);
		}
	}

	// Remove Album, Author, or Genre records if there is no any reference to it
	while (!m_pList.IsEmpty())
	{
		int		index;

		index = m_pList.GetHead();
		m_pList.RemoveHead();

		_stprintf(strQuery, _T("select * from FSE_QueryState where pIndex = %d"), index);

		if (db_selectT(strQuery) == 0)
		{
			_stprintf(strQuery, _T("select * from FSE_QueryState where MyIndex = %d"), index);

			if (db_getOneRecordT(strQuery, &oneQueryRecord))
			{
				_stprintf(strQuery, _T("delete from FSE_QueryState where FilePath =\"%s\""), 
						  oneQueryRecord.FilePath);
				db_executeT(strQuery);
			}
		}
	}

	FREE(queryState);
}


void ClearAllFilesInDB()
{
	qsCount = 4;
	audioCount = 0;
	videoCount = 0;
	imageCount = 0;
	filterCount = 0;
	playlistCount = 0;
	rejectCount = 0;
	totalFileCount = 0;

	// Clear all records in database
	db_executeT(_T("delete from FSE_QueryState"));
	db_executeT(_T("delete from Shared_Folder"));

	// Reset the database to default
	//birdy 2007/12/25 add for susped Youtube thread
#ifdef YOUTUBE_SUPPORT
	//SuspendThread(YoutubeThreadHandle);
	set_YoutubeRefresh(1);
#endif

#ifdef STOREX
	SuspendThread(Renew_M3U_FreeBox_hreadHandle);
	SuspendThread(Renew_M3UT_hreadHandle);
#endif

	initFSE_QS();
	//Read_Local_FreeBox();
	//Read_Local_FreeBox_ThreadHandle = ::CreateThread(NULL, 0, Read_Local_FreeBox_Thread, NULL, 0, &Read_Local_FreeBox_ThreadId);

#ifdef STOREX
	ResumeThread(Renew_M3U_FreeBox_hreadHandle);
	ResumeThread(Renew_M3UT_hreadHandle);
#endif
	//birdy 2007/12/25 add for resume Youtube thread
#ifdef YOUTUBE_SUPPORT
	//ResumeThread(YoutubeThreadHandle);
#endif

	// Clear all generated video index files
	CString	cacheFolderPath;

	cacheFolderPath = gWorkingDir;
	cacheFolderPath += _T("\\cache");
	CFolderUtils::RemoveFolder(cacheFolderPath);
	CreateDirectory(cacheFolderPath, NULL);

	// Clear all generated bmp files
	CString	thumbnailFolderPath;

	thumbnailFolderPath = gWorkingDir;
	thumbnailFolderPath += _T("\\thumbnail");
	CFolderUtils::RemoveFolder(thumbnailFolderPath);
	CreateDirectory(thumbnailFolderPath, NULL);

#ifdef STOREX
	//birdy add for clear m3u file
	CString	M3UFolderPath;

	M3UFolderPath = gWorkingDir;
	M3UFolderPath += _T("\\m3u");
	CFolderUtils::RemoveFolder(M3UFolderPath);
#endif

	// Clear the queued database query
	FlushCacheDBQuery();
}

void set_Read_Local_FreeBox_Thread(int v)
{
	gWriteThread = v;
}

int is_WriteThread(void)
{
	return gWriteThread;
}

DWORD WINAPI Read_Local_FreeBox_Thread(LPVOID args)
{
	FILE       *out;
	char temp[50*1024];
	CString filePath = gWorkingDir;
	int filesize = 0;

    set_Read_Local_FreeBox_Thread(1);


	filePath += _T("\\FreeBox.m3u");
	out = _wfopen(filePath, _T("rb"));

	if (out != NULL)
	{
		fseek(out,0,SEEK_END);
        filesize = ftell(out);
        fseek(out,0,SEEK_SET);

		fread(temp, sizeof(char), filesize, out);
		freebox_http_parse(temp, filesize, filePath);
	}

	set_Read_Local_FreeBox_Thread(0);
	return 0;
}
