#ifndef __SCANFILES_H__
#define __SCANFILES_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ShellTreeCtrl.h"
#include "ShellPidl.h"

#define     FILE_TYPE_PLAYLIST_M3U      1
#define     FILE_TYPE_PLAYLIST_PLS      2
#define     FILE_TYPE_PLAYLIST_ASX      3
#define     FILE_TYPE_PLAYLIST_WPL      4

#define		SHARED_DRIVER_FIXED			1
#define		SHARED_DRIVER_REMOVABLE		2


DWORD WINAPI ScanFilesThread(LPVOID args);
DWORD WINAPI ScanOneSharedDirThread(LPVOID args);
DWORD WINAPI ScanMultiSharedDirThread(LPVOID args);
DWORD WINAPI ScanAllSharedDirThread(LPVOID args);
DWORD WINAPI RefreshAllSharedDirThread(LPVOID args);
DWORD WINAPI RefreshOneSharedDirThread(LPVOID args);
DWORD WINAPI DeleteOneSharedDirThread(LPVOID args);

int		AddFilesInDirToDB(CShellPidl pidlIn, long parentIDAudio, long parentIDVideo, long parentIDPhoto,
						  int nScanSubFolder);
void 	GenerateNewPlaylist(CString& fileName, CString& outputFilePath, long parentIDAudio);
int     SFGetFileType(CString& filename);
BOOL    IsFilteredFile(CString& filename, int FileFilter);
int		IsFileTypeJ2K(CString& fileName);
void	AddOneFileToDB(CString filePath);
void	AddMyFavoriteFileToDB(CString filePath);
void	DeleteOneFileFromDB(CString filePath, int isMyFavoriteFile);
int		AddOneSharedDirToDB(CString& dirPath);
int		ScanOneSharedDir(CString& dirPath);
void	DeleteOneParentIndexFromDB(int pIndex);
void	ClearAllFilesInDB();

void DeleteOneFileFromDB_watcher(CString filePath);
void ScanOneSharedDir_watcher(CString& dirPath);
void AddOneFileToDB_watcher(CString filePath);
void AddOneURLToDB(CString filePath, CString Title, int FileType);
void AddOneDirectoryToDB_M3u(CString filePath, CString Title, int FileType);
void AddOneURLToDB_M3U(CString filePath, CString Title, int FileType);
void AddOneURLToDB_M3U_FreeBox(CString filePath, CString Title, int FileType);
void AddOneURLToDB_M3U_Neuf(CString filePath, CString Title, int FileType);
void AddYoutubeToDB(CString filePath, CString Title, int FileTypeint, int Youtube_type);

#endif	// __SCANFILES_H__
