#include "stdafx.h"
#include "ServerNameDlg.h"
#include "MessageBoxDlg.h"
#include "dbtools.h"
#include "DMSService.h"
#include "Language.h"

extern "C" {
	#include "mystring.h"
	#include "debug.h"
}

extern "C" char globalServerName[255*3];

extern int control_icon;


IMPLEMENT_DYNAMIC(CServerNameDlg, CPropertyPage)

CServerNameDlg::CServerNameDlg() : CPropertyPage(CServerNameDlg::IDD)
{
}

CServerNameDlg::~CServerNameDlg()
{
}

void CServerNameDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CServerNameDlg, CPropertyPage)
	ON_BN_CLICKED(IDC_SERVER_NAME_OK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_SERVER_NAME_CANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_SERVER_NAME_OK2, OnBnClickedServerNameOk2)
END_MESSAGE_MAP()


void CServerNameDlg::OnBnClickedOk()
{
	CString tempServerName;
	GetDlgItem(IDC_SERVER_NAME_EDIT)->GetWindowText(tempServerName);
	if(!tempServerName.IsEmpty() && (tempServerName.FindOneOf(_T("\\/:*?\"<>|")) == -1))
	{
		char	utf8ServerName[255*3];

/*#ifdef HDDMA
		if (tempServerName.Find(_T("(HD)")) != 0)
		{
			// Cannot find (HD), add it
			tempServerName = _T("(HD)") + tempServerName;
		}
#endif*/
		strToUtf8(utf8ServerName, (char *) tempServerName.GetString(), 255*3, IS_WIDE, NULL);

		db_setAVP("ServerName",utf8ServerName);

		//Birdy 
		if (IsDMSRunning())
        {
			//control_icon = 1;
            MediaServerStop();
            //GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(FALSE);
            Sleep(1000);
            //m_StartServiceButton.SetIcon(IDI_START, 64, 64);
            //m_StartServiceButton.DrawTransparent();
            //m_StartServiceButton.SetTooltipText(QueryLangStr(LANG_STR_STARTSERVICE));
            //Invalidate_Rect(IDC_BUTTON_START_SERVICE);

            //GetDlgItem(IDC_BUTTON_START_SERVICE)->EnableWindow(TRUE);
            //GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);

			MediaServerStart();
		}

	}
	else
	{
		if (parseLangConfigOK)
		{
			CMessageBoxDlg	msgBox(QueryLangStr(LANG_STR_INVALIDSERVERNAME),
								   QueryLangStr(LANG_STR_INVALIDSERVERNAMEMSG),
								   QueryLangStr(LANG_STR_OK));
			msgBox.DoModal();
		}
		else
		{
			CMessageBoxDlg	msgBox(_T("Invalid Server Name"), 
								   _T("Server name cannot be empty string or contain \\/:*?\"<>|"),
								   _T("OK"));
			msgBox.DoModal();
		}
	}

	CDialog::OnOK();
}

BOOL CServerNameDlg::OnInitDialog()
{
	TCHAR	utf8ServerName[255];

	CPropertyPage::OnInitDialog();

	Utf8ToStr(utf8ServerName, globalServerName, 255);
	GetDlgItem(IDC_SERVER_NAME_EDIT)->SetWindowText(utf8ServerName);

	// Change the strings in this dialog according to OS language
	if (parseLangConfigOK)
	{
		SetWindowText(QueryLangStr(LANG_STR_CHANGESERVERNAMECAPTION));
		GetDlgItem(IDC_SERVER_NAME_OK)->SetWindowText(QueryLangStr(LANG_STR_OK));
		GetDlgItem(IDC_SERVER_NAME_CANCEL)->SetWindowText(QueryLangStr(LANG_STR_CANCEL));
		GetDlgItem(IDC_SERVER_NAME_OK2)->SetWindowText(QueryLangStr(LANG_STR_OK));
		GetDlgItem(IDC_SERVER_NAME_STATIC2)->SetWindowText(QueryLangStr(LANG_STR_RESTARTAFTERCHANGESERVERNAME));
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CServerNameDlg::OnBnClickedCancel()
{
	CDialog::OnCancel();
	return;
}

void CServerNameDlg::OnBnClickedServerNameOk2()
{
	CDialog::OnOK();
}
