#include "stdafx.h"
#include "resource.h"
#include "HighColorTab.h"
#include "SystemPage.h"
#include "ServerNameDlg.h"
#include "DragAndDropListBox.h"
#include "dbtools.h"
#include "TransStatus.h"
#include "Language.h"
#include "DMSService.h"

extern "C" {
#include "mystring.h"
#include "FileIoAbstraction.h"
#include ".\systempage.h"
}

//Birdy 2007/11/22
#include "AboutDialog.h"

extern "C" char globalServerName[255*3];
extern int	inScanFiles;
extern int mouse_button_down;
extern int control_m_bIsPressed;
extern int		skipScanFiles;
extern int		skipScanVideoFiles;
extern void set_KillYoutubeThread(int v);
extern int is_YoutubeThreadExited(void);

extern void Close_lighthttp();

void CSystemPage::Invalidate_Rect(int idc)
{
    CRect r,r2,r3;

    GetDlgItem(idc)->GetWindowRect(&r);
    GetWindowRect(&r2);

    r3.left = r.left - r2.left;
    r3.right = r.right - r2.left;
    r3.top = r.top - r2.top;
    r3.bottom = r.bottom -r2.top;

    InvalidateRect(r3,1);
}



IMPLEMENT_DYNAMIC(CSystemPage, CPropertyPage)

CSystemPage::CSystemPage() : CPropertyPage(CSystemPage::IDD)
{
	// Change the title of this page according to the OS language
	if (parseLangConfigOK)
	{
		m_psp.dwFlags |= PSP_USETITLE;
		m_psp.pszTitle = QueryLangStr(LANG_STR_SYSTEM);
	}
}

CSystemPage::~CSystemPage()
{
}

void CSystemPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//DDX_Control(pDX, IDC_CLIENTS_LIST, m_Client_List);
	DDX_Control(pDX, IDC_CLIENTS_LIST2, m_Client_List1);
	DDX_Control(pDX, IDC_BUTTON1, m_Change);
#ifndef STOREX
	DDX_Control(pDX, IDC_BUTTON2, m_DMALIST);
#endif
}


BEGIN_MESSAGE_MAP(CSystemPage, CPropertyPage)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_CLIENTS_LIST, OnLvnItemchangedClientsList)
	//ON_NOTIFY(LVN_ITEMCHANGED, IDC_CLIENTS_LIST1, OnLvnItemchangedClientsList)
	ON_WM_ERASEBKGND()
	ON_WM_SIZE()
	ON_STN_CLICKED(IDC_STATIC_SERVER_NAME, OnStnClickedStaticServerName)
	ON_WM_CTLCOLOR()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton_Exit)
	ON_BN_CLICKED(IDC_BUTTON4, OnBnClickedButton_About)
END_MESSAGE_MAP()

BOOL CSystemPage::OnInitDialog()
{
	BOOL	result;
	TCHAR	str[255*3];

	result = CPropertyPage::OnInitDialog();	
	
	//Birdy setIcon
#ifdef HDDMA
    m_Change.SetIcon(IDI_ServerName, 64, 64);
	m_Change.DrawTransparent();
	m_Change.SetTooltipText(QueryLangStr(LANG_STR_CHANGE));
#endif

#ifdef Conceptronic
	m_Change.SetFlat(FALSE);
	m_DMALIST.SetFlat(FALSE);
#endif

#ifdef HDDMA
	m_DMALIST.SetIcon(IDI_DMALIST, 64, 64);
	m_DMALIST.DrawTransparent();
#endif

	if (strlen(globalServerName) == 0)
	{
		// globalServerName hasn't been initialized, get it by ourselves
		db_getAVP("ServerName",globalServerName);
	}
	// We use UTF8 to store the server name and need to transfer to Unicode firstly
	Utf8ToStr(str, globalServerName, 255*3);

	GetDlgItem(IDC_SERVER_NAME_STATIC)->SetWindowText(str);
	//InitClientList();
	InitClientList1();

	// Change the strings in this dialog according to OS language
	if (parseLangConfigOK)
	{
		CString	str;

		GetDlgItem(IDC_BUTTON1);		
		str = QueryLangStr(LANG_STR_SERVERNAME);
		str += _T(":");
		GetDlgItem(IDC_STATIC_SERVER_NAME)->SetWindowText(str);
		GetDlgItem(IDC_STATIC_CONNECTION_STATUS)->SetWindowText(QueryLangStr(LANG_STR_CONNECTIONSTATUS));

#ifdef Conceptronic
		GetDlgItem(IDC_BUTTON1)->SetWindowText(QueryLangStr(LANG_STR_CHANGE));
		GetDlgItem(IDC_BUTTON2)->SetWindowText(QueryLangStr(LANG_STR_DMASetup));
#endif

		str = QueryLangStr(LANG_STR_EXIT);
        GetDlgItem(IDC_BUTTON3)->SetWindowText(str);

        str = QueryLangStr(LANG_STR_ABOUT);	
        GetDlgItem(IDC_BUTTON4)->SetWindowText(str);
		
	}

#ifdef OEM_ASUS
	m_StartServiceButton.SetIconID(IDI_START_SERVICE_BUTTON);
	m_StopServiceButton.SetIconID(IDI_STOP_SERVICE_BUTTON);
#endif

	return result;  	
}

void CSystemPage::OnBnClickedCancel()
{
	//GetDlgItem(IDD_ABOUTBOX)
}


void CSystemPage::InitClientList1()
{
	LV_COLUMN lvc;

	LONG lStyle = (LONG) m_Client_List1.SendMessage(LVM_GETEXTENDEDLISTVIEWSTYLE);
	lStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES | 
		LVS_EX_HEADERDRAGDROP;
	m_Client_List1.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, 0, (LPARAM)lStyle);
	
	lvc.mask = LVCF_TEXT | LVCF_SUBITEM | LVCF_WIDTH /*| LVCF_FMT*/;

	lvc.iSubItem = 0;
	if (parseLangConfigOK)
		lvc.pszText = QueryLangStr(LANG_STR_FILENAME);
	else
		lvc.pszText = _T("Filename"); 
	
	lvc.cx = 250;
	m_Client_List1.InsertColumn(0,&lvc);

	lvc.iSubItem = 1;
	lvc.pszText = _T("IP");
	lvc.cx = 150;
	m_Client_List1.InsertColumn(1,&lvc);

	lvc.iSubItem = 2;
	if (parseLangConfigOK)
		lvc.pszText = QueryLangStr(LANG_STR_PROGRESS);
	else
		lvc.pszText = _T("Progress");
	lvc.cx = 150;
	m_Client_List1.InsertColumn(2,&lvc);

	// Use this field as index, but don't show it (cx = 0)
	lvc.iSubItem = 3;
	lvc.pszText = _T("Url Path");
	lvc.cx = 100;
	m_Client_List1.InsertColumn(3,&lvc);
}

void CSystemPage::OnBnClickedButton1()
{
	TCHAR	str[255*3];
	CServerNameDlg setServerName;

	if (setServerName.DoModal() == IDOK)
	{
		// Update displayed server name
		db_getAVP("ServerName",globalServerName);
		Utf8ToStr(str, globalServerName, 255*3);
		GetDlgItem(IDC_SERVER_NAME_STATIC)->SetWindowText(str);	
		
		//Birdy
		Invalidate_Rect(IDC_SERVER_NAME_STATIC);
	}
}

BOOL CSystemPage::OnSetActive() 
{
	if (IsDMSRunning())
	{
		GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
	}
	else
	{		
		GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
	}

	//UpdateTransferStatus();
	UpdateTransferStatus1();
	
	return CPropertyPage::OnSetActive();
}

void CSystemPage::OnBnClickedButtonStartService()
{
		
	if (IsDMSRunning())
	{		
		MediaServerStop();
		Sleep(1000);
        m_StartServiceButton.SetIcon(IDI_START, 64, 64);
        m_StartServiceButton.DrawTransparent();
        m_StartServiceButton.SetTooltipText(QueryLangStr(LANG_STR_STARTSERVICE));    

		GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);				        
	}
	else
	{	
		MediaServerStart();
		Sleep(1000);
        m_StartServiceButton.SetIcon(IDI_STOP, 64, 64);
        m_StartServiceButton.DrawTransparent();
        m_StartServiceButton.SetTooltipText(QueryLangStr(LANG_STR_STOPSERVICE));
        
        GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);	        	        
	}

}
		

void CSystemPage::OnBnClickedButtonStopService()
{
	if (IsDMSRunning())
	{
		MediaServerStop();

		GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
	}
}

void CSystemPage::UpdateTransferStatus1() 
{
	TransStatus	showTransStatus[TRANS_MAX_NO_PROGRESS_ITEMS];
	LV_ITEM		lvitem;
	CString		str;
	TCHAR		fileName[MAX_PATH], temp[50];
	int			i, j, count, size, progress;

	count =  GetShowTransStatus(showTransStatus);

	lvitem.mask = LVIF_TEXT;
	lvitem.iSubItem = 0;
	lvitem.cchTextMax = MAX_PATH;	

	for (i = 0; i < count; i++)
	{
		if (showTransStatus[i].flag == TRANS_NEW_ITEM)
		{
			lvitem.iItem = i;
			lvitem.pszText =_itot(i, temp, 10); 
			m_Client_List1.InsertItem(&lvitem);
			
			Utf8ToStr(fileName, showTransStatus[i].filename, MAX_PATH);
			m_Client_List1.SetItemText(i, 0, fileName);
			
			str = showTransStatus[i].ip;
			m_Client_List1.SetItemText(i, 1, str);
						
			progress = (int) (((float) showTransStatus[i].offset / showTransStatus[i].fileSize) * 100);
			if (progress > 100)
				progress = 100;
			_stprintf(temp, _T("%3d%%"), progress);
			m_Client_List1.SetItemText(i, 2, temp);	
			
			// Store the url path as index
			Utf8ToStr(fileName, showTransStatus[i].urlPath, MAX_PATH);
			m_Client_List1.SetItemText(i, 3, fileName);
			
			// Remove the items above TRANS_MAX_NO_PROGRESS_ITEMS
			if (m_Client_List1.GetItemCount() > TRANS_MAX_NO_PROGRESS_ITEMS)
			{
				m_Client_List1.DeleteItem(TRANS_MAX_NO_PROGRESS_ITEMS);			
			}

		}
		else if (showTransStatus[i].flag == TRANS_UPDATE_ITEM)
		{
			Utf8ToStr(fileName, showTransStatus[i].urlPath, MAX_PATH);
			progress = (int) (((double) showTransStatus[i].offset / (double)showTransStatus[i].fileSize) * 100);
			if (progress > 100)
				progress = 100;
			_stprintf(temp, _T("%3d%%"), progress);
	
			// compare the filename with the url path in the list
			size = m_Client_List1.GetItemCount();

			for (j = 0; j < size; j++)
			{
				if ((m_Client_List1.GetItemText(j, 3).Compare(fileName) == 0))
				{
					// Find the correct item, show progress in this item
					m_Client_List1.SetItemText(j, 2, temp);					
					break;
				}
			}
		}
	}
}

void CSystemPage::OnLvnItemchangedClientsList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: b[JiBz`{X
	*pResult = 0;
}

BOOL CSystemPage::OnEraseBkgnd(CDC* pDC)
{
	CBitmap bmp,*poldbmp,*poldbmp_temp,bmp_temp;
	CDC memdc,memdc_temp;
	CRect rc;


	BITMAP bitmap,bitmap_temp;

	int w ,h;
   	
	GetWindowRect(&rc);
  		
	//Load the bitmap resource
	bmp.LoadBitmap(IDB_BITMAP1);//IDB_CORPLOGO);

	// create a compatible memory DC
	memdc.CreateCompatibleDC(pDC );
	// select the bitmap into the DC

	poldbmp = memdc.SelectObject( &bmp);

	// copy (bitblt ) bitmap from memory DC to screen DC
	
	bmp.GetBitmap(&bitmap);

	w = rc.Width();
	h = rc.Height();

	if( w < bitmap.bmWidth )
	{
		w = bitmap.bmWidth;
	}
	if( h< bitmap.bmHeight)
	{
		h = bitmap.bmHeight;
	}

	pDC->StretchBlt(0,0,w,h,&memdc,0,0,bitmap.bmWidth,bitmap.bmHeight,SRCCOPY);


	memdc.SelectObject(poldbmp);

	//bmp.DeleteObject();	


//  //Birdy 2007/3/23 ForceCaptureBackground
	GetWindowRect(&rc);   		
	
	bmp_temp.LoadBitmap(IDB_BITMAP1);

	//create a compatible memory DC
	memdc_temp.CreateCompatibleDC(pDC );	

	// select the bitmap into the DC

	poldbmp = memdc.SelectObject( &bmp);
	poldbmp_temp = memdc_temp.SelectObject( &bmp_temp);

	// copy (bitblt ) bitmap from memory DC to screen DC
	
	bmp_temp.GetBitmap(&bitmap_temp);

	w = rc.Width();
	h = rc.Height();

	if( w < bitmap.bmWidth )
	{
		w = bitmap.bmWidth;
	}
	if( h< bitmap.bmHeight)
	{
		h = bitmap.bmHeight;
	}

	memdc_temp.StretchBlt(0,0,w,h,&memdc,0,0,bitmap.bmWidth,bitmap.bmHeight,SRCCOPY);

	if (control_m_bIsPressed == 0)
	{
        m_Change.ForceCaptureBackground(&memdc_temp);

#ifndef STOREX
    	m_DMALIST.ForceCaptureBackground(&memdc_temp);        
#endif

		control_m_bIsPressed = 1;
	}

	memdc.SelectObject(poldbmp);
	memdc_temp.SelectObject(poldbmp_temp);
	bmp.DeleteObject();	
	bmp_temp.DeleteObject();	

	return FALSE;
}

void CSystemPage::OnSize(UINT nType, int cx, int cy)
{
	CPropertyPage::OnSize(nType, cx, cy);

	// TODO: b[JzTBz`{X
	
	Invalidate(1);
	CRect dir_rect;	
	
	//len = sizeof(c)/sizeof(int);

/*	for(int i=0;i<len;i++)
	{
        w = GetDlgItem(c[i]);

        if( w != NULL )
       	{
            w->GetWindowRect(&dir_rect);
            ScreenToClient(&dir_rect);
            ValidateRect(&dir_rect);
            w->Invalidate(1);
        }

	}*/

}

void CSystemPage::OnStnClickedStaticServerName()
{
	// TODO: b[JiBz`{X
}

HBRUSH CSystemPage::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CPropertyPage::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO:  bܧ DC ݩ

	// TODO:  pGw]ȨëDQnAhǦ^P
	pDC->SetBkMode(TRANSPARENT);
#ifdef HDDMA
	pDC->SetTextColor(RGB(255,255,255));
#endif

#ifdef Conceptronic
	pDC->SetTextColor(RGB(0,0,0));
#endif

	return (HBRUSH)::GetStockObject(NULL_BRUSH);
	//return hbr;
}

void CSystemPage::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: b[JzTBz`{XM () Isw]
	mouse_button_down = 1;
	CPropertyPage::OnLButtonDown(nFlags, point);
}

void CSystemPage::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO: b[JzTBz`{XM () Isw]
	mouse_button_down = 1;
	CPropertyPage::OnRButtonDown(nFlags, point);
}
#include "DragDropListBoxSampleDlg.h"

void CSystemPage::OnBnClickedButton2()
{
	CDragDropListBoxSampleDlg dlg;	
	INT_PTR nResponse = dlg.DoModal();	
}

void CSystemPage::OnBnClickedButton_Exit()
{
	static CTime	endScanTime;
	static int		endTimeValid = FALSE;
	CTimeSpan	elapsedTime = 0;
    CTime		currentTime;

	// Notify taht the program is exiting, please don't show any message
	//fProgExit = TRUE;	

	// Let ScanFiles() and ScanVideoFiles() thread skip
	skipScanFiles = TRUE;
	skipScanVideoFiles = TRUE;
#ifdef YOUTUBE_SUPPORT
	set_KillYoutubeThread(1);
	
	endScanTime = CTime::GetCurrentTime();
	while(elapsedTime.GetTotalSeconds() < 3)
	{
		if (is_YoutubeThreadExited() == 1)
		{
			break;
		}		
		currentTime = CTime::GetCurrentTime();
		elapsedTime = currentTime - endScanTime;
	}
#endif

	//birdy 2008/2/4 DMS server can stop service before exit program
	if (IsDMSRunning())
	{
        MediaServerStop();
	}

	Close_lighthttp();	
	PostQuitMessage(0);
}

void CSystemPage::OnBnClickedButton_About()
{
	CAboutDialog aboutDlg;
	aboutDlg.DoModal();
	//m_TrayIcon.SetMenuDefaultItem(ID_FILE_ABOUT, FALSE);
}

void CSystemPage::Change_Language()
{	
	TCHAR	str[255*3];

	//Birdy setIcon
#ifdef HDDMA
    m_Change.SetIcon(IDI_ServerName, 64, 64);
	m_Change.DrawTransparent();
	m_Change.SetTooltipText(QueryLangStr(LANG_STR_CHANGE));
#endif

#ifdef Conceptronic

#endif

#ifdef HDDMA
	m_DMALIST.SetIcon(IDI_DMALIST, 64, 64);
	m_DMALIST.DrawTransparent();
#endif

	if (strlen(globalServerName) == 0)
	{
		// globalServerName hasn't been initialized, get it by ourselves
		db_getAVP("ServerName",globalServerName);
	}
	// We use UTF8 to store the server name and need to transfer to Unicode firstly
	Utf8ToStr(str, globalServerName, 255*3);

	GetDlgItem(IDC_SERVER_NAME_STATIC)->SetWindowText(str);

	int i, j;	

	i = m_Client_List1.GetItemCount();
	
	struct __status
	{
		CString Filename;
	    CString IP;
	    CString Progress;
	    CString UrlPath;
	} tempstatus[101];;

	
	for (j = 0; j <= i; j++)
	{
		tempstatus[j].Filename = m_Client_List1.GetItemText(j, 0);
		tempstatus[j].IP = m_Client_List1.GetItemText(j, 1);
		tempstatus[j].Progress = m_Client_List1.GetItemText(j, 2);
		tempstatus[j].UrlPath = m_Client_List1.GetItemText(j, 3);
	}

	m_Client_List1.DeleteColumn(3);
	m_Client_List1.DeleteColumn(2);
	m_Client_List1.DeleteColumn(1);
	m_Client_List1.DeleteColumn(0);

	m_Client_List1.DeleteAllItems();
	InitClientList1();

	for (j = 0; j <= i; j++)
	{
		m_Client_List1.InsertItem(j, tempstatus[j].Filename);
		m_Client_List1.SetItemText(j, 1, tempstatus[j].IP);
		m_Client_List1.SetItemText(j, 2, tempstatus[j].Progress);
		m_Client_List1.SetItemText(j, 3, tempstatus[j].UrlPath);	
	}
	
	//UpdateTransferStatus1();

	Invalidate_Rect(IDC_SERVER_NAME_STATIC);
	GetDlgItem(IDC_SERVER_NAME_STATIC)->SetWindowText(str);		

	// Change the strings in this dialog according to OS language
	if (parseLangConfigOK)
	{
		CString str;

		GetDlgItem(IDC_BUTTON1);		
		str = QueryLangStr(LANG_STR_SERVERNAME);
		str += _T(":");
		GetDlgItem(IDC_STATIC_SERVER_NAME)->SetWindowText(str);
		GetDlgItem(IDC_STATIC_CONNECTION_STATUS)->SetWindowText(QueryLangStr(LANG_STR_CONNECTIONSTATUS));

#ifdef Conceptronic
		GetDlgItem(IDC_BUTTON1)->SetWindowText(QueryLangStr(LANG_STR_CHANGE));
		GetDlgItem(IDC_BUTTON2)->SetWindowText(QueryLangStr(LANG_STR_DMASetup));		
#endif

		str = QueryLangStr(LANG_STR_EXIT);
        GetDlgItem(IDC_BUTTON3)->SetWindowText(str);

        str = QueryLangStr(LANG_STR_ABOUT);	
        GetDlgItem(IDC_BUTTON4)->SetWindowText(str);

		m_psp.pszTitle = QueryLangStr(LANG_STR_SYSTEM);
	}
}
