#include "stdafx.h"
#include "Timer.h"

#ifdef WIN32
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#ifndef _WIN32_WCE
#include <crtdbg.h>
#endif
#else
#include <stdlib.h>
#endif

extern "C" {
	#include "debug.h"
}

static DWORD	lastIOTime;
static UINT_PTR	uIDTimer;
static HANDLE	procHandle;

void CALLBACK TimerProc(HWND hwnd, UINT uMsg, UINT_PTR idEvent, DWORD dwTime)
{
	if (dwTime > lastIOTime + MAX_IO_IDLE_TIME)
	{
		if (GetPriorityClass(procHandle) > NORMAL_PRIORITY_CLASS)
		{
			// We have rasied the priority for file transfer file
			// Now, There is no new IO in 1 min, so we lower it
			SetPriorityClass(procHandle, NORMAL_PRIORITY_CLASS); 
		}
	}
}

void	TimerProcStart()
{
	// Get and Save process handle, we will use it to adjust priority
	procHandle = GetCurrentProcess();

	// Create a timer, we can check some status periodically
	lastIOTime = GetTickCount();	
	uIDTimer = SetTimer(NULL, 0, 1000, TimerProc);
}

void	TimerProcStop()
{
	if (uIDTimer)
	{
	    KillTimer(NULL, uIDTimer);
		uIDTimer = 0;
	}
}

extern "C" void IncreaseIOAccessCount()
{
	lastIOTime = GetTickCount();
}

extern "C" void RaiseProcessPriority()
{		
	if (GetPriorityClass(procHandle) <= NORMAL_PRIORITY_CLASS)
	{
		SetPriorityClass(procHandle, ABOVE_NORMAL_PRIORITY_CLASS); 
	}
}