#ifndef __DB_TOOLS_H
#define __DB_TOOLS_H

#include "ado2.h"

#define	DB_ROOT_ID					0
#define	DB_VIDEO_ID					1
#define	DB_AUDIO_ID					2
#define	DB_IMAGE_ID					3
#define	DB_VIDEO_ALL_VIDEO_ID		4
#define	DB_VIDEO_MY_FAVORITES_ID	5
#define	DB_VIDEO_MY_FOLDERS			6
#define	DB_AUDIO_ALL_MUSIC_ID		7
#define	DB_AUDIO_MY_FAVORITES_ID	11
#define	DB_AUDIO_MY_FOLDERS			12
#define	DB_IMAGE_ALL_IMAGE_ID		13
#define	DB_IMAGE_MY_FAVORITES_ID	14
#define	DB_IMAGE_MY_FOLDERS			15


//#define	MAX_SQL_STR_LENGTH	(2*MAX_PATH_LENGTH)+(4*MAX_MEDIA_STR_LENGTH)+512
#define	MAX_SQL_STR_LENGTH	(2*(MAX_PATH*3)+4*1024+512)

#ifndef SAFE_RELEASE
#define SAFE_RELEASE(x) \
	if(x != NULL)        \
	{                    \
	x->Release();     \
	x = NULL;         \
	}
#endif

#ifndef SAFE_ARRAY_DELETE
#define SAFE_ARRAY_DELETE(x) \
	if(x != NULL)             \
	{                         \
	delete[] x;            \
	x = NULL;              \
	}
#endif

struct __SharedDirStruct
{
	TCHAR		DirPath[MAX_PATH];
	DWORD		Flags;
	TCHAR		VolumeName[MAX_PATH];
};
typedef struct	__SharedDirStruct	SharedDirStruct, *PSharedDirStruct;

extern "C" int db_execute(const char *SQLstring);
extern "C" int db_getOneRecord(const char *SQLstring, struct FSE_QueryState *tmpFSE_QS);
extern "C" int db_getOneRecordInIndex(const char *SQLstring, struct FSE_QueryState *tmpFSE_QS, int index);
extern "C" int db_getRecords(const char *SQLstring, struct FSE_QueryState FSE_QSArray[], int startIndex, int readCount);
extern "C" int db_getCount(const char *SQLstring);
extern "C" int db_setAVP(const char *Attribute, const char *value);
extern "C" int db_getAVP(const char *Attribute, char *returnValue);
extern "C" int db_select(const char *SQLstring);

extern "C" int db_executeT(const TCHAR* SQLstring);
extern "C" int db_getCountT(const TCHAR *SQLstring);
extern "C" int db_getOneRecordT(const TCHAR *SQLstring, struct FSE_QueryState *tmpFSE_QS);
extern "C" int db_getRecordsT(const TCHAR *SQLstring, struct FSE_QueryState FSE_QSArray[], int startIndex, int readCount);
extern "C" int db_setAVPT(const TCHAR *Attribute, const TCHAR *value);
extern "C" int db_getAVPT(const TCHAR *Attribute, TCHAR *returnValue);
extern "C" int db_selectT(const TCHAR *SQLstring);

int		GetSharedDirCount();
int		SelectSharedDir(const TCHAR *dirPath, PSharedDirStruct pSharedDir);
PSharedDirStruct GetAllSharedDirs();

int		InitDatabase();
void	CloseDatabase();
int		GetMaxMyIndexNoInDatabase();
void	CleanQueueQueryInDatabase();
void	FlushCacheDBQuery();

extern CADODatabase *g_pDb;
extern HANDLE		hDBMutex; 

extern "C" {
	extern struct FSE_QueryState *testFSE_QS;
	extern struct FSE_QueryState *testFSE_QS_For_Browse;
	extern int maxItemsInQS, maxItemsInQSForBrowse;
}

#endif // #define __DB_TOOLS_H