#ifdef WIN32
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#ifndef _WIN32_WCE
#include <crtdbg.h>
#endif
#else
#include <stdlib.h>
#endif

#include <string.h>
#include "TransferState.h"
#include "ILibAsyncSocket.h"
#include "CommonHttp.h"
#include "FileIoAbstraction.h"



int CHTTP_SendHttpError(struct ILibWebServer_Session *session, unsigned int flags)
{
	int retVal = 0;
	
	if (flags & TS_F_FileNotFound)
	{
		ILibWebServer_Send_Raw(
			session,
			HTTP_STR_ERROR404,
			HTTP_STR_ERROR404_LEN,
			ILibAsyncSocket_MemoryOwnership_STATIC,
			1);

		retVal = HTTP_COD_ERROR404;
	}
	else if (flags & TS_F_BadRequest)
	{
		// albert add
		/*
		if (flags & TS_F_InvalidFormat)
		{
			ILibWebServer_Send_Raw(
				session,
				HTTP_STR_ERROR406,
				HTTP_STR_ERROR406_LEN,
				ILibAsyncSocket_MemoryOwnership_STATIC,
				1);

			retVal = HTTP_COD_ERROR406;
		}
		*/

		ILibWebServer_Send_Raw(
			session,
			HTTP_STR_ERROR400,
			HTTP_STR_ERROR400_LEN,
			ILibAsyncSocket_MemoryOwnership_STATIC,
			1);

		retVal = HTTP_COD_ERROR400;
	}
	else if (flags & TS_F_MethodNotImplemented)
	{
		ILibWebServer_Send_Raw(
			session,
			HTTP_STR_ERROR501,
			HTTP_STR_ERROR501_LEN,
			ILibAsyncSocket_MemoryOwnership_STATIC,
			1);

		retVal = HTTP_COD_ERROR501;
	}
	else if (flags & TS_F_InvalidRange)
	{
		ILibWebServer_Send_Raw(
			session,
			HTTP_STR_ERROR416,
			HTTP_STR_ERROR416_LEN,
			ILibAsyncSocket_MemoryOwnership_STATIC,
			1);

		retVal = HTTP_COD_ERROR416;
	}
	else if (flags & TS_F_InternalError)
	{
		ILibWebServer_Send_Raw(
			session,
			HTTP_STR_ERROR500,
			HTTP_STR_ERROR500_LEN,
			ILibAsyncSocket_MemoryOwnership_STATIC,
			1);

		retVal = HTTP_COD_ERROR416;
	}
	else if (flags & TS_F_InvalidFormat)
	{
		ILibWebServer_Send_Raw(
			session,
			HTTP_STR_ERROR416,
			HTTP_STR_ERROR416_LEN,
			ILibAsyncSocket_MemoryOwnership_STATIC,
			1);

		retVal = HTTP_COD_ERROR416;
	}


	return retVal;
}
