#ifndef _COMMON_HTTTP_H
#define _COMMON_HTTTP_H

#include "TransferState.h"

#define HTTP_STR_GET							"GET"
#define HTTP_STR_GET_LEN						3

#define HTTP_STR_HEAD							"HEAD"
#define HTTP_STR_HEAD_LEN						4

#define HTTP_STR_RANGE							"RANGE"
#define HTTP_STR_RANGE_LEN						5

#define HTTP_COD_OK200							200
#define HTTP_STR_OK200							"HTTP/1.1 200 OK"
#define HTTP_STR_OK200_LEN						15

#define HTTP_COD_OK206							206
#define HTTP_STR_OK206							"HTTP/1.1 206 Partial Content"
#define HTTP_STR_OK206_LEN						28

#define HTTP_STR_OK								"OK"
#define HTTP_STR_OK_LEN							2

#define HTTP_STR_PARTIALCONTENT					"Partial Content"
#define HTTP_STR_PARTIALCONTENT_LEN				15

#define HTTP_STR_ERROR404						"HTTP/1.1 404 File Not Found or File is Locked\r\nContent-Length: 0\r\n\r\n"
#define HTTP_STR_ERROR404_LEN					68
#define HTTP_COD_ERROR404						404

#define HTTP_STR_ERROR400						"HTTP/1.1 400 Request is malformed or invalid \r\nContent-Length: 0\r\n\r\n"
#define HTTP_STR_ERROR400_LEN					68
#define HTTP_COD_ERROR400						400

#define HTTP_STR_ERROR500						"HTTP/1.1 500 Internal Server Error\r\nContent-Length: 0\r\n\r\n"
#define HTTP_STR_ERROR500_LEN					57
#define HTTP_COD_ERROR500						500

#define HTTP_STR_ERROR501						"HTTP/1.1 501 Specified method not implemented\r\nContent-Length: 0\r\n\r\n"
#define HTTP_STR_ERROR501_LEN					68
#define HTTP_COD_ERROR501						501

#define HTTP_STR_ERROR416						"HTTP/1.1 416 Requested range not satisfiable \r\nContent-Length: 0\r\n\r\n"
#define HTTP_STR_ERROR416_LEN					68
#define HTTP_COD_ERROR416						416

#define HTTP_STR_ERROR406						"HTTP/1.1 406 Not Acceptable \r\nContent-Length: 0\r\n\r\n"
#define HTTP_STR_ERROR406_LEN					52
#define HTTP_COD_ERROR406						406

#define HTTP_STR_DLNA_GETCONTENTFEATURES		"getcontentFeatures.dlna.org"
#define HTTP_STR_DLNA_GETCONTENTFEATURES_LEN	27

#define HTTP_STR_DLNA_GETCONTENTFEATURES_VAL	"1"
#define HTTP_STR_DLNA_GETCONTENTFEATURES_VAL_LEN 1

#define HTTP_STR_DLNA_CONTENTFEATURES			"contentFeatures.dlna.org"
#define HTTP_STR_DLNA_CONTENTFEATURES_LEN		24

#define MULTIPART_RANGE_DELIMITER "{%x{%x{%x{%x{-S3P4R470R-}%x}%x}%x}%x}"
#define MULTIPART_RANGE_DELIMITER_SIZE 40

/*
 *	Sends the HTTP error response based on 'flags'.
 *
 *		session				: the websession that carries the response
 *
 *		flags				: error flags mapped by 'enum TransferStateFlags'
 *
 *	Returns nonzero HTTP error code if an error response was transmitted.
 */
int CHTTP_SendHttpError(struct ILibWebServer_Session *session, unsigned int flags);


#endif

