#ifdef WIN32
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#ifndef _WIN32_WCE
#include <crtdbg.h>
#endif
#else
#include <stdlib.h>
#endif
#include <windows.h>
#include <winbase.h>
#include <tchar.h>

#include "debug.h"
#include "mystring.h"

#define	MAX_DEBUG_STR_LENGTH	512

void *malloc_dbg(size_t size, char* fileName, int lineNo) 
{
	TCHAR	msg[MAX_DEBUG_STR_LENGTH], wFileName[MAX_DEBUG_STR_LENGTH];
	void	*p;
	
	p = malloc(size);

	Utf8ToWide(wFileName, fileName, MAX_DEBUG_STR_LENGTH);
	_stprintf(msg, _T("malloc: %s:%d mem=%x size=%d\n"), wFileName, lineNo, p, size);
	OutputDebugString(msg);

	return p;
}

void free_dbg(void *p, char* fileName, int lineNo) 
{
	TCHAR	msg[MAX_DEBUG_STR_LENGTH], wFileName[MAX_DEBUG_STR_LENGTH];

	Utf8ToWide(wFileName, fileName, MAX_DEBUG_STR_LENGTH);
	_stprintf(msg, _T("free: %s:%d mem=%x\n"), wFileName, lineNo, p);
	OutputDebugString(msg);
	
	free(p);
}

void DbgPrintf(TCHAR *fmt, ...)
{
    va_list	marker;
    TCHAR	msg[512];

    va_start(marker, fmt);
    _vstprintf(msg, fmt, marker);
    va_end(marker);

    OutputDebugString(msg);
}
