#ifdef WIN32
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#ifndef _WIN32_WCE
#include <crtdbg.h>
#endif
#else
#include <stdlib.h>
#endif

#include <string.h>
#include "MimeTypes.h"
#include "MyString.h"

#ifndef UNDER_CE
#include <wchar.h>
#endif

#ifdef UNDER_CE
#define stricmp _stricmp
#define stricmp _stricmp
#endif

#ifdef _POSIX
#define stricmp strcasecmp
#endif

#define _TMP_CHAR_BUFFER 30

const char* InternerFileExtensionToMimeType (const char* extension, int wide, int filetype)
{	
	char tt[100], *retVal;	
	int i, nPos;

	for (i = 0; i < 4; i++)
	{
		if (extension [i] != ':')
		{
            tt[i] = extension[i];
		}
	}	
	tt[4] = NULL;
	
	if (filetype == 1)
	{
		//only for free box
		if( strncmp(extension,"rtsp://mafreebox",16 ) == 0 )
		{
			retVal = MIME_TYPE_VIDEO_MPEG; // phillo,2007/12/27 for pact
	
		}
		else
		{
			retVal = MIME_TYPE_VIDEO_AVI; //phillo,2007/10/23
		}
	}
	else if(filetype == 2)
	{
		retVal = MIME_TYPE_AUDIO_MPEG;
	}
	else
	{
		retVal = EXTENSION_OCTETSTREAM;
	}

	return retVal;

}

const char* FileExtensionToMimeType (const char* extension, int wide)
{
	char tempExtension[_TMP_CHAR_BUFFER], temp2[_TMP_CHAR_BUFFER];
	char *retVal = NULL;

	if (wide)
	{
		strToUtf8(temp2, extension, _TMP_CHAR_BUFFER, 1, NULL);
		extension = temp2;
	}
	
	if (extension[0] != '.')
	{
		tempExtension[0] = '.';
		strcpy(tempExtension+1, extension);
		extension = tempExtension;
	}

	if (stricmp(extension, EXTENSION_AUDIO_MPEG) == 0)
	{
		retVal = MIME_TYPE_AUDIO_MPEG;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_WAV) == 0)
	{
		retVal = MIME_TYPE_AUDIO_WAV;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_LPCM) == 0)
	{
		retVal = MIME_TYPE_AUDIO_LPCM;
	}
	// albert add,20050330
	else if (stricmp(extension, EXTENSION_AUDIO_LPCM) == 0)
	{
		retVal = MIME_TYPE_AUDIO_LPCM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_LPCM) == 0)
	{
		retVal = MIME_TYPE_AUDIO_LPCM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_WMA) == 0)
	{
		retVal = MIME_TYPE_AUDIO_WMA;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_OGG) == 0)
	{
		retVal = MIME_TYPE_AUDIO_OGG;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_AAC) == 0)
	{
		retVal = MIME_TYPE_AUDIO_AAC;
	}
	//birdy 2008/07/31 ,support FLAC
	else if (stricmp(extension, EXTENSION_AUDIO_FLAC) == 0)
	{
		retVal = MIME_TYPE_AUDIO_FLAC;
	}
	//birdy 2007/11/14 ,support m4a,mp4a
	else if (stricmp(extension, EXTENSION_AUDIO_M4A) == 0)
	{
		retVal = MIME_TYPE_AUDIO_M4A;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_MP4A) == 0)
	{
		retVal = MIME_TYPE_AUDIO_MP4A;
	}
	//birdy 2007/12/7 support mkv,mka
	else if (stricmp(extension, EXTENSION_VIDEO_MKV) == 0)
	{
		retVal = MIME_TYPE_VIDEO_MKV;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_MKA) == 0)
	{
		retVal = MIME_TYPE_AUDIO_MKA;
	}

	else if (stricmp(extension, EXTENSION_PLAYLIST_ASX) == 0)
	{
		retVal = MIME_TYPE_PLAYLIST_ASX;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_ASF) == 0)
	{
		retVal = MIME_TYPE_VIDEO_ASF;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_AVI) == 0)
	{
		retVal = MIME_TYPE_VIDEO_AVI;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_VOB) == 0)
	{
		retVal = MIME_TYPE_VIDEO_VOB;
	}
	//birdy 2008/5/29 support M2TS,MTS
	else if (stricmp(extension, EXTENSION_VIDEO_M2T) == 0)
	{
		retVal = MIME_TYPE_VIDEO_M2T;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MTS) == 0)
	{
		retVal = MIME_TYPE_VIDEO_MTS;
	}	
	//birdy 2007/5/14 support TS,M2TS,TP
	else if (stricmp(extension, ".ts") == 0)
	{
		retVal = MIME_TYPE_VIDEO_MPEG2;
	}
	else if (stricmp(extension, ".m2ts") == 0)
	{
		retVal = MIME_TYPE_VIDEO_MPEG2;
	}
	else if (stricmp(extension, ".tp") == 0)
	{
		retVal = MIME_TYPE_VIDEO_MPEG2;
	}
	//birdy 2007/8/28
	else if (stricmp(extension, EXTENSION_VIDEO_DAT) == 0)
	{
		retVal = MIME_TYPE_VIDEO_DAT;
	}	
	else if (stricmp(extension, EXTENSION_VIDEO_MPEG2) == 0)
	{
		retVal = MIME_TYPE_VIDEO_MPEG2;
	}
	//birdy 2007/9/27
	//else if (stricmp(extension, "EXTENSION_VIDEO_IFO") == 0)
	else if (stricmp(extension, EXTENSION_VIDEO_IFO) == 0)
	{
		retVal = MIME_TYPE_VIDEO_IFO;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_ISO) == 0)
	{
		retVal = MIME_TYPE_VIDEO_ISO;
	}	
	else if (stricmp(extension, EXTENSION_VIDEO_WMV) == 0)
	{
		retVal = MIME_TYPE_VIDEO_WMV;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MP4) == 0)
	{
		retVal = MIME_TYPE_VIDEO_MP4;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MPEG) == 0)
	{
		retVal = MIME_TYPE_VIDEO_MPEG;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MOV) == 0)
	{
		retVal = MIME_TYPE_VIDEO_MOV;
	}
	else if (stricmp(extension, EXTENSION_IMAGE_JPG) == 0)
	{
		retVal = MIME_TYPE_IMAGE_JPEG;
	}
	else if (stricmp(extension, EXTENSION_IMAGE_J2K) == 0)
	{
		retVal = MIME_TYPE_IMAGE_J2K;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_JP2) == 0)
	{
		retVal = MIME_TYPE_IMAGE_JP2;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_PNG) == 0)
	{
		retVal = MIME_TYPE_IMAGE_PNG;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_TIF) == 0)
	{
		retVal = MIME_TYPE_IMAGE_TIF;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_GIF) == 0)
	{
		retVal = MIME_TYPE_IMAGE_GIF;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_JPEG) == 0)
	{
		retVal = MIME_TYPE_IMAGE_JPEG;
	}	// albert add
	else if (stricmp(extension, EXTENSION_IMAGE_TB) == 0)
	{
		retVal = MIME_TYPE_IMAGE_BMP;
	}
	else if (stricmp(extension, EXTENSION_IMAGE_BMP) == 0)
	{
		retVal = MIME_TYPE_IMAGE_BMP;
	}	
	else if (stricmp(extension, EXTENSION_PLAYLIST_M3U) == 0)
	{
		retVal = MIME_TYPE_PLAYLIST_M3U;
	}
	else if (stricmp(extension, EXTENSION_PLAYLIST_PLS) == 0)
	{
		retVal = MIME_TYPE_PLAYLIST_PLS;
	}
	else if (stricmp(extension, EXTENSION_TXT) == 0)
	{
		retVal = MIME_TYPE_TXT;
	}
	// add by albert 20050330, for testing cse n-MF-02, 04, 05
	else
	{
		retVal = EXTENSION_OCTETSTREAM;
	}

	return retVal;
}

const char* FileExtensionToProtocolInfo (const char* extension, int wide)
{
	char tempExtension[_TMP_CHAR_BUFFER], temp2[_TMP_CHAR_BUFFER];
	char *retVal = NULL;

	if (wide)
	{
		strToUtf8(temp2, extension, _TMP_CHAR_BUFFER, 1, NULL);
		extension = temp2;
	}
	
	if (extension[0] != '.')
	{
		tempExtension[0] = '.';
		strcpy(tempExtension+1, extension);
		extension = tempExtension;
	}

	if (stricmp(extension, EXTENSION_AUDIO_MPEG) == 0)
	{
		retVal = PROTINFO_AUDIO_MPEG;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_WAV) == 0)
	{
		retVal = PROTINFO_AUDIO_WAV;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_LPCM) == 0)
	{
		retVal = PROTINFO_AUDIO_LPCM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_WMA) == 0)
	{
		retVal = PROTINFO_AUDIO_WMA;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_OGG) == 0)
	{
		retVal = PROTINFO_AUDIO_OGG;
	}
	//birdy 2008/07/31 ,support FLAC
	else if (stricmp(extension, EXTENSION_AUDIO_FLAC) == 0)
	{
		retVal = PROTINFO_AUDIO_FLAC;
	}
	//birdy 2007/11/14 ,support m4a,mp4a
	else if (stricmp(extension, EXTENSION_AUDIO_M4A) == 0)
	{
		retVal = PROTINFO_AUDIO_M4A;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_MP4A) == 0)
	{
		retVal = PROTINFO_AUDIO_MP4A;
	}
	//birdy 2007/12/7 support mkv,mka
	else if (stricmp(extension, EXTENSION_VIDEO_MKV) == 0)
	{
		retVal = PROTINFO_VIDEO_MKV;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_MKA) == 0)
	{
		retVal = PROTINFO_AUDIO_MKA;
	}
	else if (stricmp(extension, EXTENSION_PLAYLIST_ASX) == 0)
	{
		retVal = PROTINFO_PLAYLIST_ASX;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_AVI) == 0)
	{
		retVal = PROTINFO_VIDEO_AVI;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_VOB) == 0)
	{
		retVal = PROTINFO_VIDEO_VOB;
	}		
	//birdy 2008/5/29 support M2TS,MTS
	else if (stricmp(extension, EXTENSION_VIDEO_M2T) == 0)
	{
		retVal = PROTINFO_VIDEO_M2T;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MTS) == 0)
	{
		retVal = PROTINFO_VIDEO_MTS;
	}
	//birdy 2007/5/14 support TS,M2TS,TP
	else if (stricmp(extension, ".ts") == 0)
	{
		retVal = PROTINFO_VIDEO_MPEG2;
	}
	else if (stricmp(extension, ".m2ts") == 0)
	{
		retVal = PROTINFO_VIDEO_MPEG2;
	}
	else if (stricmp(extension, ".tp") == 0)
	{
		retVal = PROTINFO_VIDEO_MPEG2;
	}
	//birdy 2007/8/28
	else if (stricmp(extension, EXTENSION_VIDEO_DAT) == 0)
	{
		retVal = PROTINFO_VIDEO_DAT;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MPEG2) == 0)
	{
		retVal = PROTINFO_VIDEO_MPEG2;
	}
    //birdy 2007/9/27
	else if (stricmp(extension, EXTENSION_VIDEO_IFO) == 0)
	{
		retVal = PROTINFO_VIDEO_IFO;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_ISO) == 0)
	{
		retVal = PROTINFO_VIDEO_ISO;
	}

	else if (stricmp(extension, EXTENSION_VIDEO_ASF) == 0)
	{
		retVal = PROTINFO_VIDEO_ASF;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_WMV) == 0)
	{
		retVal = PROTINFO_VIDEO_WMV;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MP4) == 0)
	{
		retVal = PROTINFO_VIDEO_MP4;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MPEG) == 0)
	{
		retVal = PROTINFO_VIDEO_MPEG;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MOV) == 0)
	{
		retVal = PROTINFO_VIDEO_MOV;
	}
	else if (stricmp(extension, EXTENSION_IMAGE_JPG) == 0)
	{
		retVal = PROTINFO_IMAGE_JPEG;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_J2K) == 0)
	{
		retVal = PROTINFO_IMAGE_J2K;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_JP2) == 0)
	{
		retVal = PROTINFO_IMAGE_JP2;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_PNG) == 0)
	{
		retVal = PROTINFO_IMAGE_PNG;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_TIF) == 0)
	{
		retVal = PROTINFO_IMAGE_TIF;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_GIF) == 0)
	{
		retVal = PROTINFO_IMAGE_GIF;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_JPEG) == 0)
	{
		retVal = PROTINFO_IMAGE_JPEG;
	}	// albert add
	else if (stricmp(extension, EXTENSION_IMAGE_TB) == 0)
	{
		retVal = PROTINFO_IMAGE_BMP;
	}
	else if (stricmp(extension, EXTENSION_IMAGE_BMP) == 0)
	{
		retVal = PROTINFO_IMAGE_BMP;
	}	
	else if (stricmp(extension, EXTENSION_PLAYLIST_M3U) == 0)
	{
		retVal = PROTINFO_PLAYLIST_M3U;
	}
	else if (stricmp(extension, EXTENSION_PLAYLIST_PLS) == 0)
	{
		retVal = PROTINFO_PLAYLIST_PLS;
	}
	else if (stricmp(extension, EXTENSION_TXT) == 0)
	{
		retVal = PROTINFO_TXT;
	}
	else
	{
		retVal = "http-get:*:application/octet-stream:*";
	}

	return retVal;
}

const char* MimeTypeToFileExtension (const char* mime_type)
{
	if (stricmp(mime_type, MIME_TYPE_AUDIO_MPEG) == 0)
	{
		return EXTENSION_AUDIO_MPEG;
	}
	else if (stricmp(mime_type, MIME_TYPE_AUDIO_WMA) == 0)
	{
		return EXTENSION_AUDIO_WMA;
	}
	else if (stricmp(mime_type, MIME_TYPE_AUDIO_WAV) == 0)
	{
		return EXTENSION_AUDIO_WAV;
	}
	else if (stricmp(mime_type, MIME_TYPE_AUDIO_LPCM) == 0)
	{
		return EXTENSION_AUDIO_LPCM;
	}
	else if (stricmp(mime_type, MIME_TYPE_AUDIO_OGG) == 0)
	{
		return EXTENSION_AUDIO_OGG;
	}
	//birdy 2008/07/31 ,support FLAC
	else if (stricmp(mime_type, MIME_TYPE_AUDIO_FLAC) == 0)
	{
		return EXTENSION_AUDIO_FLAC;
	}
	//birdy 2007/11/14 ,support m4a,mp4a
	else if (stricmp(mime_type, MIME_TYPE_AUDIO_M4A) == 0)
	{
		return EXTENSION_AUDIO_M4A;
	}
	else if (stricmp(mime_type, MIME_TYPE_AUDIO_MP4A) == 0)
	{
		return EXTENSION_AUDIO_MP4A;
	}
	//birdy 2007/12/7 support mkv,mka
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_MKV) == 0)
	{
		return EXTENSION_VIDEO_MKV;
	}
	else if (stricmp(mime_type, MIME_TYPE_AUDIO_MKA) == 0)
	{
		return EXTENSION_AUDIO_MKA;
	}

	else if (stricmp(mime_type, MIME_TYPE_AUDIO_AAC) == 0)
	{
		return EXTENSION_AUDIO_AAC;
	}
	else if (stricmp(mime_type, MIME_TYPE_PLAYLIST_ASX) == 0)
	{
		return EXTENSION_PLAYLIST_ASX;
	}
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_ASF) == 0)
	{
		return EXTENSION_VIDEO_ASF;
	}
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_AVI) == 0)
	{
		return EXTENSION_VIDEO_AVI;
	}
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_VOB) == 0)
	{
		return EXTENSION_VIDEO_VOB;
	}	
	//birdy 2008/5/29 support M2TS,MTS
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_M2T) == 0)
	{
		return EXTENSION_VIDEO_M2T;
	}
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_MTS) == 0)
	{
		return EXTENSION_VIDEO_MTS;
	}
	//birdy 2007/5/14 support TS,M2TS,TP
	else if (stricmp(mime_type, "video/ts") == 0)
	{
		return EXTENSION_VIDEO_MPEG2;
	}
	else if (stricmp(mime_type, "video/m2ts") == 0)
	{
		return EXTENSION_VIDEO_MPEG2;
	}
	else if (stricmp(mime_type, "video/tp") == 0)
	{
		return EXTENSION_VIDEO_MPEG2;
	}	
	//birdy 2007/8/28
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_DAT) == 0)
	{
		return EXTENSION_VIDEO_DAT;
	}
	//birdy 2007/9/27
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_IFO) == 0)
	{
		return EXTENSION_VIDEO_IFO;
	}
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_ISO) == 0)
	{
		return EXTENSION_VIDEO_ISO;
	}
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_MPEG2) == 0)
	{
		return EXTENSION_VIDEO_MPEG2;
	}
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_WMV) == 0)
	{
		return EXTENSION_VIDEO_WMV;
	}
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_MP4) == 0)
	{
		return EXTENSION_VIDEO_MP4;
	}
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_MPEG) == 0)
	{
		return EXTENSION_VIDEO_MPEG;
	}
	else if (stricmp(mime_type, MIME_TYPE_VIDEO_MOV) == 0)
	{
		return EXTENSION_VIDEO_MOV;
	}
	else if (stricmp(mime_type, MIME_TYPE_IMAGE_JPEG) == 0)
	{
		return EXTENSION_IMAGE_JPG;
	}
	else if (stricmp(mime_type, MIME_TYPE_IMAGE_J2K) == 0)
	{
		return EXTENSION_IMAGE_J2K;
	}
	else if (stricmp(mime_type, MIME_TYPE_IMAGE_JP2) == 0)
	{
		return EXTENSION_IMAGE_JP2;
	}
	else if (stricmp(mime_type, MIME_TYPE_IMAGE_PNG) == 0)
	{
		return EXTENSION_IMAGE_PNG;
	}
	else if (stricmp(mime_type, MIME_TYPE_IMAGE_GIF) == 0)
	{
		return EXTENSION_IMAGE_GIF;
	}
	else if (stricmp(mime_type, MIME_TYPE_IMAGE_TIF) == 0)
	{
		return EXTENSION_IMAGE_TIF;
	}
	else if (stricmp(mime_type, MIME_TYPE_IMAGE_JPEG) == 0)
	{
		return EXTENSION_IMAGE_JPEG;
	}
	else if (stricmp(mime_type, MIME_TYPE_IMAGE_BMP) == 0)
	{
		return EXTENSION_IMAGE_BMP;
	}
	else if (stricmp(mime_type, MIME_TYPE_PLAYLIST_M3U) == 0)
	{
		return EXTENSION_PLAYLIST_M3U;
	}
	else if (stricmp(mime_type, MIME_TYPE_PLAYLIST_PLS) == 0)
	{
		return EXTENSION_PLAYLIST_PLS;
	}


	return ".bin";
}

const char* FileExtensionToUpnpClass (const char* extension, int wide)
{
	char tempExtension[_TMP_CHAR_BUFFER], temp2[_TMP_CHAR_BUFFER];
	char *retVal = NULL;

	if (wide)
	{
		strToUtf8(temp2, extension, _TMP_CHAR_BUFFER, 1, NULL);
		extension = temp2;
	}
	
	if (extension[0] != '.')
	{
		tempExtension[0] = '.';
		strcpy(tempExtension+1, extension);
		extension = tempExtension;
	}

	if (stricmp(extension, EXTENSION_AUDIO_MPEG) == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_WMA) == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_WAV) == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_LPCM) == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	// albert add
	else if (stricmp(extension, ".pcm") == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	else if (stricmp(extension, ".lpcm") == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_WMA) == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_OGG) == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_AAC) == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	//birdy 2008/07/31 ,support FLAC
	else if (stricmp(extension, EXTENSION_AUDIO_FLAC) == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	//birdy 2007/11/14 ,support m4a,mp4a
	else if (stricmp(extension, EXTENSION_AUDIO_M4A) == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_MP4A) == 0)
	{
		retVal = CLASS_AUDIO_ITEM;
	}
	//birdy 2007/12/7 support mkv,mka
	else if (stricmp(extension, EXTENSION_VIDEO_MKV) == 0)
	{
		return CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_MKA) == 0)
	{
		return CLASS_AUDIO_ITEM;
	}

	else if (stricmp(extension, EXTENSION_VIDEO_ASF) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_AVI) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_VOB) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}	
	//birdy 2008/5/29 support M2TS,MTS
	else if (stricmp(extension, EXTENSION_VIDEO_M2T) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MTS) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	//birdy 2007/5/14 support TS,M2TS,TP
	else if (stricmp(extension, ".ts") == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, ".m2ts") == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, ".tp") == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	//birdy 2007/8/28
	else if (stricmp(extension, EXTENSION_VIDEO_DAT) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MPEG2) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	//
	//birdy 2007/9/27
	else if (stricmp(extension, EXTENSION_VIDEO_IFO) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_ISO) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}

	else if (stricmp(extension, EXTENSION_VIDEO_WMV) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MP4) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MPEG) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_DVRMS) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MOV) == 0)
	{
		retVal = CLASS_VIDEO_ITEM;
	}
	else if (stricmp(extension, EXTENSION_IMAGE_JPG) == 0)
	{
		retVal = CLASS_IMAGE_ITEM;
	}
	else if (stricmp(extension, EXTENSION_IMAGE_J2K) == 0)
	{
		retVal = CLASS_IMAGE_ITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_JP2) == 0)
	{
		retVal = CLASS_IMAGE_ITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_PNG) == 0)
	{
		retVal = CLASS_IMAGE_ITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_TIF) == 0)
	{
		retVal = CLASS_IMAGE_ITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_GIF) == 0)
	{
		retVal = CLASS_IMAGE_ITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_JPEG) == 0)
	{
		retVal = CLASS_IMAGE_ITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_BMP) == 0)
	{
		retVal = CLASS_IMAGE_ITEM;
	}	
	else if (stricmp(extension, EXTENSION_PLAYLIST_M3U) == 0)
	{
		retVal = CLASS_PLAYLIST_M3U;
	}
	else if (stricmp(extension, EXTENSION_PLAYLIST_PLS) == 0)
	{
		retVal = CLASS_PLAYLIST_M3U;
	}
	else if (stricmp(extension, EXTENSION_PLAYLIST_ASX) == 0)
	{
		retVal = CLASS_PLAYLIST_ASX;
	}
	else
	{
		retVal = CLASS_ITEM;
	}

	return retVal;
}

unsigned int FileExtensionToClassCode (const char* extension, int wide)
{
	char tempExtension[_TMP_CHAR_BUFFER], temp2[_TMP_CHAR_BUFFER];
	unsigned int retVal;

	if (wide)
	{
		strToUtf8(temp2, extension, _TMP_CHAR_BUFFER, 1, NULL);
		extension = temp2;
	}
	
	if (extension[0] != '.')
	{
		tempExtension[0] = '.';
		strcpy(tempExtension+1, extension);
		extension = tempExtension;
	}

	if (stricmp(extension, EXTENSION_AUDIO_MPEG) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_WAV) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_LPCM) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	// albert add
	else if (stricmp(extension, ".pcm") == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	else if (stricmp(extension, ".lpcm") == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_WMA) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_OGG) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_AAC) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	//birdy 2008/07/31 ,support FLAC
	else if (stricmp(extension, EXTENSION_AUDIO_FLAC) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	//birdy 2007/11/14 ,support m4a,mp4a
	else if (stricmp(extension, EXTENSION_AUDIO_M4A) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_MP4A) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	//birdy 2007/12/7 support mkv,mka
	else if (stricmp(extension, EXTENSION_VIDEO_MKV) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_AUDIO_MKA) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}

	else if (stricmp(extension, EXTENSION_AUDIO_AC3) == 0)
	{
		retVal = CDS_MEDIACLASS_AUDIOITEM;
	}
	// albert add
	else if (stricmp(extension, EXTENSION_VIDEO_AVI) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_VOB) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}	
	//birdy 2008/5/29 support M2TS,MTS
	else if (stricmp(extension, EXTENSION_VIDEO_M2T) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MTS) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	//birdy 2007/5/14 support TS,M2TS,TP
	else if (stricmp(extension, ".ts") == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, ".m2ts") == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, ".tp") == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	//birdy 2007/8/28
	else if (stricmp(extension, EXTENSION_VIDEO_MPEG2) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	//
	//birdy 2007/9/27
	else if (stricmp(extension, EXTENSION_VIDEO_IFO) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_ISO) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}

	else if (stricmp(extension, EXTENSION_VIDEO_DAT) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MP4) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MPA) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}

	else if (stricmp(extension, EXTENSION_VIDEO_ASF) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_WMV) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MP4) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MPEG) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_VIDEO_MOV) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else if (stricmp(extension, EXTENSION_IMAGE_JPG) == 0)
	{
		retVal = CDS_MEDIACLASS_IMAGEITEM;
	}
	else if (stricmp(extension, EXTENSION_IMAGE_J2K) == 0)
	{
		retVal = CDS_MEDIACLASS_IMAGEITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_JP2) == 0)
	{
		retVal = CDS_MEDIACLASS_IMAGEITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_PNG) == 0)
	{
		retVal = CDS_MEDIACLASS_IMAGEITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_JPEG) == 0)
	{
		retVal = CDS_MEDIACLASS_IMAGEITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_TIF) == 0)
	{
		retVal = CDS_MEDIACLASS_IMAGEITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_GIF) == 0)
	{
		retVal = CDS_MEDIACLASS_IMAGEITEM;
	}	
	else if (stricmp(extension, EXTENSION_IMAGE_BMP) == 0)
	{
		retVal = CDS_MEDIACLASS_IMAGEITEM;
	}	
	else if (stricmp(extension, EXTENSION_PLAYLIST_M3U) == 0)
	{
		//james 05.05.11
		retVal = /*CDS_CLASS_MASK_MAJOR_PLAYLISTITEM;*/ CDS_MEDIACLASS_PLAYLISTCONTAINER;
	}
	else if (stricmp(extension, EXTENSION_PLAYLIST_PLS) == 0)
	{
		//james 05.05.11
		retVal = /*CDS_CLASS_MASK_MAJOR_PLAYLISTITEM;*/ CDS_MEDIACLASS_PLAYLISTCONTAINER;
	}
	else if (stricmp(extension, EXTENSION_PLAYLIST_ASX) == 0)
	{
		retVal = CDS_MEDIACLASS_PLAYLISTCONTAINER;
	}
	else if (stricmp(extension, EXTENSION_DVRMS) == 0)
	{
		retVal = CDS_MEDIACLASS_VIDEOITEM;
	}
	else
	{
		retVal = CDS_MEDIACLASS_ITEM;
	}

	return retVal;
}

