#ifndef MIMETYPES_H

#include "CdsMediaClass.h"

/*
 *	Provides forward declarations for methods in
 *	MimeTypes.c
 */

#define CLASS_ITEM			"object.item"
#define CLASS_AUDIO_ITEM	"object.item.audioItem"
#define CLASS_PLAYLIST_M3U	"object.container.playlistContainer"
#define CLASS_PLAYLIST_ASX	"object.container.playlistContainer"
#define CLASS_VIDEO_ITEM	"object.item.videoItem"
#define CLASS_IMAGE_ITEM	"object.item.imageItem"

#define EXTENSION_AUDIO_MPEG		".mp3"
#define MIME_TYPE_AUDIO_MPEG		"audio/mpeg"
#define PROTINFO_AUDIO_MPEG			"http-get:*:audio/mpeg:*"

#define EXTENSION_AUDIO_WMA			".wma"
#define MIME_TYPE_AUDIO_WMA			"audio/x-ms-wma"
#define PROTINFO_AUDIO_WMA			"http-get:*:audio/x-ms-wma:*"

#define EXTENSION_AUDIO_WAV			".wav"
#define MIME_TYPE_AUDIO_WAV			"audio/wav"
#define PROTINFO_AUDIO_WAV			"http-get:*:audio/wav:*"

// albert modify , 20050330
// LPCM , rate= 44100 or rate = 48000, channels = 1 or channels = 2
#define EXTENSION_AUDIO_LPCM		".raw"
#define PROTINFO_AUDIO_LPCM			"http-get:*:audio/L16:*"
#define MIME_TYPE_AUDIO_LPCM		"audio/L16;rate=44100;channels=2"

#define EXTENSION_AUDIO_OGG			".ogg"
#define MIME_TYPE_AUDIO_OGG			"audio/x-ogg"
#define PROTINFO_AUDIO_OGG			"http-get:*:audio/x-ogg:*"

// albert add , support aac
#define EXTENSION_AUDIO_AAC		".aac"
#define MIME_TYPE_AUDIO_AAC		"audio/mp4"		// "audio/vnd.dlna.adts"  "audio/3gpp"
#define PROTINFO_AUDIO_AAC		"http-get:*:audio/mp4:*"

//birdy 2008/07/31 ,support FLAC
#define EXTENSION_AUDIO_FLAC        ".flac"
#define MIME_TYPE_AUDIO_FLAC        "audio/flac "
#define PROTINFO_AUDIO_FLAC         "http-get:*:audio/flac:*" 

//birdy 2007/11/14 ,support m4a,mp4a
#define EXTENSION_AUDIO_M4A        ".m4a"
#define MIME_TYPE_AUDIO_M4A        "audio/mp4"
#define PROTINFO_AUDIO_M4A         "http-get:*:audio/mp4:*" 

#define EXTENSION_AUDIO_MP4A        ".mp4a"
#define MIME_TYPE_AUDIO_MP4A        "audio/mp4"
#define PROTINFO_AUDIO_MP4A         "http-get:*:audio/mp4:*"
//

//birdy 2007/11/14 ,support mkv,mka
#define EXTENSION_VIDEO_MKV        ".mkv"
#define MIME_TYPE_VIDEO_MKV        "video/mkv"
#define PROTINFO_VIDEO_MKV         "http-get:*:video/mkv:*" 

#define EXTENSION_AUDIO_MKA        ".mka"
#define MIME_TYPE_AUDIO_MKA        "audio/mka"
#define PROTINFO_AUDIO_MKA         "http-get:*:audio/mka:*"
//

#define EXTENSION_AUDIO_AC3		".ac3"
#define MIME_TYPE_AUDIO_AC3		"audio/mp4"		// "audio/vnd.dlna.adts"  "audio/3gpp"
#define PROTINFO_AUDIO_AC3		"http-get:*:audio/mp4:*"

#define	EXTENSION_VIDEO_DAT		".mpg"
#define MIME_TYPE_VIDEO_DAT		"video/mpg"
#define PROTINFO_VIDEO_DAT		"http-get:*:video/mpg:*"

#define	EXTENSION_VIDEO_MP4		".mp4"
#define MIME_TYPE_VIDEO_MP4		"video/mp4"
#define PROTINFO_VIDEO_MP4		"http-get:*:video/mp4:*"

#define	EXTENSION_VIDEO_MPA		".mpa"
#define MIME_TYPE_VIDEO_MPA		"video/mpa"
#define PROTINFO_VIDEO_MPA		"http-get:*:video/mpa:*"


// albert add, support avi
#define	EXTENSION_VIDEO_AVI		".avi"
#define MIME_TYPE_VIDEO_AVI		"video/x-ms-avi"
#define PROTINFO_VIDEO_AVI		"http-get:*:video/x-ms-avi:*"

// albert add, support avi
#define	EXTENSION_VIDEO_VOB		".vob"
#define MIME_TYPE_VIDEO_VOB		"video/vob"
#define PROTINFO_VIDEO_VOB		"http-get:*:video/vob:*"

#define EXTENSION_VIDEO_ASF			".asf"
#define MIME_TYPE_VIDEO_ASF			"video/x-ms-asf"
#define PROTINFO_VIDEO_ASF			"http-get:*:video/x-ms-asf:*"

#define EXTENSION_VIDEO_WMV			".wmv"
#define MIME_TYPE_VIDEO_WMV			"video/x-ms-wmv"
#define PROTINFO_VIDEO_WMV			"http-get:*:video/x-ms-wmv:*"

#define EXTENSION_VIDEO_MPEG		".mpg"
#define MIME_TYPE_VIDEO_MPEG		"video/mpeg"
#define PROTINFO_VIDEO_MPEG		"http-get:*:video/mpeg:*"

//birdy 2008/5/29 support M2T
#define EXTENSION_VIDEO_M2T		".m2t"
#define MIME_TYPE_VIDEO_M2T		"video/mpeg2"
#define PROTINFO_VIDEO_M2T		"http-get:*:video/mpeg2:*"

//birdy 2008/5/29 support MTS
#define EXTENSION_VIDEO_MTS		".mts"
#define MIME_TYPE_VIDEO_MTS		"video/mpeg2"
#define PROTINFO_VIDEO_MTS		"http-get:*:video/mpeg2:*"

//birdy 2007/8/28 support mpeg2
#define EXTENSION_VIDEO_MPEG2		".mpg2"
#define MIME_TYPE_VIDEO_MPEG2		"video/mpeg2"
#define PROTINFO_VIDEO_MPEG2		"http-get:*:video/mpeg2:*"

//birdy 2007/9/27 support iso, Ifo
#define EXTENSION_VIDEO_IFO		".ifo"
#define MIME_TYPE_VIDEO_IFO		"content/DVD"
#define PROTINFO_VIDEO_IFO		"http-get:*:content/DVD:*"

#define EXTENSION_VIDEO_ISO		".iso"
#define MIME_TYPE_VIDEO_ISO		"application/X-ISO9660"
#define PROTINFO_VIDEO_ISO		"http-get:*:video/mpeg2:*"
//

#define EXTENSION_VIDEO_MOV			".mov"
#define MIME_TYPE_VIDEO_MOV			"video/quicktime"
#define PROTINFO_VIDEO_MOV			"http-get:*:video/quicktime:*"

#define EXTENSION_IMAGE_PNG			".png"
#define MIME_TYPE_IMAGE_PNG			"image/png"
#define PROTINFO_IMAGE_PNG			"http-get:*:image/png:*"

#define EXTENSION_IMAGE_TIF			".tif"
#define EXTENSION_IMAGE_TIFF		".tiff"
#define MIME_TYPE_IMAGE_TIF			"image/tif"
#define PROTINFO_IMAGE_TIF			"http-get:*:image/tif:*"

#define EXTENSION_IMAGE_GIF			".gif"
#define MIME_TYPE_IMAGE_GIF			"image/gif"
#define PROTINFO_IMAGE_GIF			"http-get:*:image/gif:*"

#define EXTENSION_IMAGE_JPG			".jpg"
#define EXTENSION_IMAGE_JPEG		".jpeg"
#define MIME_TYPE_IMAGE_JPEG		"image/jpeg"
#define PROTINFO_IMAGE_JPEG			"http-get:*:image/jpeg:*"

#define EXTENSION_IMAGE_J2K			".j2k"
#define MIME_TYPE_IMAGE_J2K			"image/j2k"
#define PROTINFO_IMAGE_J2K			"http-get:*:image/j2k:*"

#define EXTENSION_IMAGE_JP2			".jp2"
#define MIME_TYPE_IMAGE_JP2			"image/jp2"
#define PROTINFO_IMAGE_JP2			"http-get:*:image/jp2:*"

// albert add
#define EXTENSION_IMAGE_TB			".tb"
#define EXTENSION_IMAGE_BMP			".bmp"
#define MIME_TYPE_IMAGE_BMP			"image/bmp"
#define PROTINFO_IMAGE_BMP			"http-get:*:image/bmp:*"

#define EXTENSION_PLAYLIST_M3U		".m3u"
#define MIME_TYPE_PLAYLIST_M3U		"audio/x-mpegurl"
#define PROTINFO_PLAYLIST_M3U		"http-get:*:audio/x-mpegurl:*"

#define EXTENSION_PLAYLIST_PLS		".pls"
#define MIME_TYPE_PLAYLIST_PLS		"audio/x-mpegurl"
#define PROTINFO_PLAYLIST_PLS		"http-get:*:audio/x-mpegurl:*"

#define EXTENSION_PLAYLIST_ASX		".asx"
#define MIME_TYPE_PLAYLIST_ASX		"audio/x-ms-asx"
#define PROTINFO_PLAYLIST_ASX		"http-get:*:audio/x-ms-asx:*"

#define EXTENSION_TXT				".txt"
#define MIME_TYPE_TXT				"text/plain"
#define PROTINFO_TXT				"http-get:*:text/plain:*"

#define EXTENSION_OCTETSTREAM		"application/octet-stream"

#define EXTENSION_DVRMS				".dvr-ms"

/*
 *	GetMimeType()
 *		extension				: the file extension, including the dot '.' char
 *
 *	Returns the mime-type of a file with the given file extension.
 *	The method returns static values.
 *	Returns NULL if mapping cannot be determined.
 *	DO NOT CALL FREE ON THE RETURNED VALUE.
 */
const char* FileExtensionToMimeType (const char* extension, int wide);

const char* InternerFileExtensionToMimeType (const char* extension, int wide);

const char* FileExtensionToProtocolInfo (const char* extension, int wide);

/*
 *	MimeTypeToFileExtension()
 *		mime_type				: the mime-type
 *
 *	Returns the file extension of a file with the given mime type.
 *	The method returns static values.
 *	Returns NULL if mapping cannot be determined.
 *	DO NOT CALL FREE ON THE RETURNED VALUE.
 */
const char* MimeTypeToFileExtension (const char* mime_type);

/*
 *	FileExtensionToUpnpClass()
 *		extension				: the file extension, including the dot '.' char
 *
 *	Returns the upnp:class of a file with the given file extension.
 *	The method returns static values.
 *	Returns NULL if mapping cannot be determined.
 *	DO NOT CALL FREE ON THE RETURNED VALUE.
 */
const char* FileExtensionToUpnpClass (const char* extension, int wide);

/*
 *	FileExtensionToClassCode()
 *
 *	Returns a media class value, as described by CdsMediaClass.h
 */
unsigned int FileExtensionToClassCode (const char* extension, int wide);

#endif
