#ifdef WIN32
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#ifndef _WIN32_WCE
#include <crtdbg.h>
#endif
#else
#include <stdlib.h>
#endif

#include "MyThread.h"

void* THRD_SpawnNormalThread(void* method, void* arg)
{
#ifdef _POSIX
	int result;
	void* (*fptr) (void* a);
	pthread_t newThread;
	fptr = method;
	result = pthread_create(&newThread, NULL, fptr, arg);
	pthread_detach(newThread);
	return (void*) result;
#endif

#ifdef WIN32
#ifndef UNDER_CE
	HANDLE hThread = CreateThread(NULL, 0, method, arg, 0, NULL );

	// Raise the priority of MDS service to overcome other tasks occupy too much resource,
	// for example, when run rom update and clinet plays streaming video "Pearl Harbor".
	SetThreadPriority(hThread, THREAD_PRIORITY_HIGHEST);

 	return hThread;
#endif
#endif

#ifdef UNDER_CE
	return CreateThread(NULL, 0, method, arg, 0, NULL );
#endif
}

void THRD_EndThisThread()
{
#ifdef _POSIX
	pthread_exit(NULL);
#endif

#ifdef WIN32
#ifndef UNDER_CE
	ExitThread(0);
#endif
#endif

#ifdef UNDER_CE
	ExitThread(0);
#endif
}

