#ifndef _MYTHREAD_H
#define _MYTHREAD_H

#ifdef WIN32

#include <stdlib.h>
#include <windows.h>

#define sem_t HANDLE
#define sem_init(p_semaphore,y,initialValue) *p_semaphore=CreateSemaphore(NULL,initialValue,FD_SETSIZE,NULL)
#define sem_destroy(x) (CloseHandle(*x)==0?1:0)
#define sem_wait(x) WaitForSingleObject(*x,INFINITE)
#define sem_trywait(x) ((WaitForSingleObject(*x,0)==WAIT_OBJECT_0)?0:1)
#define sem_post(x) ReleaseSemaphore(*x,1,NULL)
#define strncasecmp(x,y,z) _strnicmp(x,y,z)

#endif

#ifdef _POSIX
#include <semaphore.h>
#endif

/*
 *	Spawns a thread to execute 'method' with 'arg' as the parameter.
 */
void* THRD_SpawnNormalThread(void* method, void* arg);

/*
 *	Normal threads should call this before exiting.
 */
void THRD_EndThisThread();

#endif