#ifndef __PRECACHE_H__
#define __PRECACHE_H__

//#define	PRECACHE_DEBUG

#define	PRECACHE_MAX_BUFFER_SIZE		0x400000
#define PRECACHE_MIN_FILE_SIZE			0x1000000
#define PRECACHE_MIN_CACHELINE_SIZE		0x1000
#define PRECACHE_MIN_READBACK_SIZE		PRECACHE_MIN_CACHELINE_SIZE * 8
#define PRECACHE_MAX_CACHELINE_NO		(PRECACHE_MAX_BUFFER_SIZE / PRECACHE_MIN_CACHELINE_SIZE)
#define PRECACHE_HASH_SHIFT				12

struct __CacheLine
{
	HANDLE			fildes;			// The file that we are currently cached
	int				valid;				// Is this entry valid ?
	char			*buffer;			// the buffer to store read data
	unsigned long	time;				// time stamp
	off_t			offset;				// the offset of this entry in file
	unsigned long long			size;
};
typedef struct __CacheLine	CacheLine, *PCacheLine;

struct __PreCacheBuffer
{
	HANDLE				fildes;			// The file that we are currently cached
	CacheLine			cacheLine[PRECACHE_MAX_CACHELINE_NO];		
	DWORD				cacheLineSize;	// the total bytes that a cacheline holds
	int					cacheLineNo;	// The total no. of cache line
	unsigned long		time;			// time stamp
	off_t				rangeStart;		// The min. offset in the cache buffer
	off_t				rangeEnd;		// The max. offset in the cache buffer
	char				buffer[PRECACHE_MAX_BUFFER_SIZE];		
										// the whole cache buffer
	int					bufferSize;		// The total size that we cached
	unsigned long long				fileSize;
	int					cacheValid;		// The whole cache buffer is valid or not
};
typedef struct __PreCacheBuffer	PreCacheBuffer, *PPreCacheBuffer;

int		InitPreCacheBuffer(_WAIO_FDES_TYPE fildes, off_t offset, unsigned long blockSize, _WAIO_FDES_TYPE sync_fildes);
void	UnInitPreCacheBuffer();
void	CacheNextCacheLine(_WAIO_FDES_TYPE fildes, off_t offset);
char*	GetCacheLine(_WAIO_FDES_TYPE fildes, off_t offset, unsigned long long readSize, _WAIO_FDES_TYPE sync_fildes);

#endif	// __PRECACHE_H__