/*******************************************************************
*
*    DESCRIPTION: Transcoding Library
*
*    AUTHOR: Alex Lee
*
*    HISTORY:
*
*    DATE:2006/4/19
*
*******************************************************************/
/** include files **/
#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <assert.h>
#include "TransLibWarp.h" //phillo,2007/10/22
#include "TransLib.h"

extern "C"
{
#include "MyString.h"
	#include "FileIoAbstraction.h" //birdy 2007/11/1
}
/** local definitions **/
#ifndef DBGPRINTF
#if defined(__GNUC__)
    #define DBGPRINTF printf
/*
extern "C" {
#include "debug.h"
#define DBGPRINTF(x) DbgPrintf(_T(x))
}*/
#else
extern "C" {
//#include "debug.h"
//#define DBGPRINTF(x) DbgPrintf(_T(x))
    #define DBGPRINTF printf
}
#endif
#endif // DBGPRINTF

/*
#define LOCK_RING(x) \
    do { \
        dwLockResult = WaitForSingleObject(x, 1000); \
        if (dwLockResult == WAIT_FAILED) \
            return 0; \
        if (dwLockResult == WAIT_TIMEOUT) \
        {   \
            hProc = OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwProcID);   \
            if (hProc == NULL)  \
                return 0;   \
            CloseHandle(hProc); \
        }   \
    } while(dwLockResult != WAIT_OBJECT_0);
*/

extern "C" TCHAR	gWorkingDir[MAX_PATH_LENGTH];    //birdy 2007/11/1

static __inline int LOCK_RING(HANDLE hLock, HANDLE hProc)
{
    DWORD dwLockResult;
	DWORD dwExitStatus;
    do {
        dwLockResult = WaitForSingleObject(hLock, 10);
        if (dwLockResult == WAIT_FAILED)
        {
            return 0;
        }
        else if (dwLockResult == WAIT_ABANDONED)
        {
            ReleaseMutex(hLock);
        }
		//phillo,2007/2/1
		//fix wmv transcode issue
		if (hProc)
		{
			if ((!GetExitCodeProcess(hProc, &dwExitStatus)) ||
				(dwExitStatus != STILL_ACTIVE))
			{
				// Process is gone, but you have to lock it anyway.
				return -1;
			}
		}
		else return -1;
    } while(dwLockResult != WAIT_OBJECT_0);
    return 1;
};

#define UNLOCK_RING(x) \
    ReleaseMutex(x); \


extern TransQualitySetting gTransVideoQuality[];
extern "C"
{
extern int gTransVideoQualitySel;
}

//phillo,2007/11/5
extern TransQualitySetting gMEncoderTransVideoQuality[];
extern "C"
{
extern int gMEncoderTransVideoQualitySel;
}

static int gTransCount = 0;
TransLib::TransLib(const char *pSrcfilename)
{
    m_bFinish = FALSE;
	m_hMapFile  = 0;
	m_lpMapAddress = NULL;
    m_pMapRing = NULL;
    m_BufBase = NULL;
#ifndef UNICODE
    strcpy(m_SrcFilename, pSrcfilename);
#else
    Utf8ToWide(m_SrcFilename, pSrcfilename, MAX_PATH);
#endif
    ZeroMemory( &m_TransProcess, sizeof(m_TransProcess) );
};

TransLib::~TransLib()
{
    Stop();
};

bool TransLib::Start(const int MediaType,const int TransCodec)
{
    BOOL bCreateProc;
    STARTUPINFO si;
	wchar_t CodecLine[1024];

#ifdef UNICODE
    wchar_t CommandLine[1024];
    wchar_t MutexName[20];

#else
    char CommandLine[1024];
#endif
    if (m_SrcFilename == NULL)
        return FALSE;

    // Prepare Memory Map File
#ifdef UNICODE
        _snwprintf(m_MemMapName, 50, L"_honeywld_trans_%03d", gTransCount);
#else
        _snprintf(m_MemMapName, 50, L"_honeywld_trans_%03d", gTransCount);
#endif

    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);

    m_hMapFile = CreateFileMapping(INVALID_HANDLE_VALUE,     // current file handle 
    	NULL,                              // default security 
    	PAGE_READWRITE,                    // read/write permission 
    	0,                              // max. object size 
    	sizeof(MEMMapRing) + MEMRING_SIZE,                              // size of hFile 
    	m_MemMapName);            // name of mapping object
    if (m_hMapFile == NULL)
        return FALSE;
    m_lpMapAddress = (char *)MapViewOfFile(m_hMapFile, // handle to mapping object 
    	FILE_MAP_ALL_ACCESS,               // read/write permission 
    	0,                                 // max. object size 
    	0,                                 // size of hFile 
    	0);                                // map entire file 

    if (m_lpMapAddress == NULL)
    {
        CloseHandle(m_hMapFile);
        return FALSE;
    }

    // Initial Ring Buffer;
    m_pMapRing = (MEMMapRing *)m_lpMapAddress;
    m_pMapRing->nReadOffset = 0;
    m_pMapRing->nWriteOffset = 0;
    m_pMapRing->nSize = MEMRING_SIZE;
    m_pMapRing->read_end = 0;
    _snprintf(m_pMapRing->MutexName, 20, "_honeywld_mutex_%03d%c", gTransCount, 0);

#ifdef UNICODE
    _snwprintf(MutexName, 20, L"_honeywld_mutex_%03d%c", gTransCount, 0);
    m_hMutex = CreateMutex(NULL, FALSE, MutexName);
#else
    m_hMutex = CreateMutex(NULL, FALSE, m_pMapRing->MutexName);
#endif
    if (m_hMutex == NULL)
    {
        DBGPRINTF("Create Mutex fail...\n");
        m_pMapRing = NULL;
        UnmapViewOfFile(m_lpMapAddress);
        CloseHandle(m_hMapFile);
        return FALSE;
    }

    //OutputDebugString("Transcoding Thread stop!!\n");
    m_BufBase = (char *)m_lpMapAddress + sizeof(MEMMapRing);

#if 0
	//phillo,2007/10/22
	if( TransCodec == TRANS_CODEC_FFMPEG )
	{
		if (MediaType == TRANS_MEDIATYPE_VIDEO)
		{
#ifdef UNICODE
		    _snwprintf(CommandLine, 1024,L"Trans.eng -i \"%s\" %s mmap:%s ", m_SrcFilename, gTransVideoQuality[gTransVideoQualitySel].pCommandLine, m_MemMapName);
#else
		    _snprintf(CommandLine, 1024,L"Trans.eng -i \"%s\" %s mmap:%s ", m_SrcFilename, gTransVideoQuality[gTransVideoQualitySel].pCommandLine, m_MemMapName);
#endif
		}
		else if (MediaType == TRANS_MEDIATYPE_AUDIO)
		{
#ifdef UNICODE
		    _snwprintf(CommandLine, 1024,L"Trans.eng -i \"%s\" -f mp3 mmap:%s ", m_SrcFilename, m_MemMapName);
#else
		    _snprintf(CommandLine, 1024,L"Trans.eng -i \"%s\" -f mp3 mmap:%s ", m_SrcFilename, m_MemMapName);
#endif
		}

		//phillo,2007/10/22
		_snwprintf(CodecLine, 1024, L"%s\\Trans.eng",gWorkingDir);

	}
	else if ( TransCodec == TRANS_CODEC_MPLAYER ) //phillo,2007/10/22
#endif //0
	{
		if (MediaType == TRANS_MEDIATYPE_VIDEO)
		{

/*
Very high quality	chroma_opt:vhq=4:bvhq=1:quant_type=mpeg	16fps	0dB
High quality		vhq=2:bvhq=1:chroma_opt:quant_type=mpeg	18fps	-0.1dB
Fast				turbo:vhq=0	28fps	-0.69dB
Realtime			turbo:nochroma_me:notrellis:max_bframes=0:vhq=0	38fps	-1.48dB

DVD quality			-of mpeg -mpegopts format=dvd -ovc copy -oac copy ( mpeg2-ts ==> mpeg2-ps )
*/

#ifdef UNICODE
			//_snwprintf(CommandLine, 1024, L"TransM.eng  -ovc xvid -ffourcc XVID -xvidencopts chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:pass=1:bitrate=1500 -oac mp3lame -o mmap:\\\\%s \"%s\"", m_MemMapName, m_SrcFilename);

			//only for pact
			if( wcsncmp(m_SrcFilename,L"rtsp://mafreebox",16 ) == 0 )
			{
				_snwprintf(CommandLine, 1024, L"TransM.eng  %s -o mmap:\\\\%s \"%s\"",L"-of mpeg -mpegopts format=dvd -ovc copy -oac copy", m_MemMapName, m_SrcFilename);
				//_snwprintf(CommandLine, 1024, L"TransM.eng  %s -o mmap:\\\\%s \"%s\"",L"-of mpeg -mpegopts format=dvd -ovc copy -oac copy", m_MemMapName, L"C:\\Media\\FreeBox\\france3_1_big.mpg");
				//_snwprintf(CommandLine, 1024, L"TransM.eng  %s -o mmap:\\\\%s \"%s\"",L"-of mpeg  -mpegopts format=dvd -ovc copy -oac copy", m_MemMapName, L"E:\\MMM\\france2_3_big.mpg");
				//_snwprintf(CommandLine, 1024, L"TransM.eng  %s -o mmap:\\\\%s \"%s\"",gMEncoderTransVideoQuality[1].pCommandLine, m_MemMapName, L"E:\\MMM\\france2_3_big.mpg");
			}
			else if( wcsncmp(m_SrcFilename,L"http://www.youtube.com",22 ) == 0 )
			{
				const wchar_t *c = L"-ovc xvid -ffourcc XVID -xvidencopts chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:pass=1:bitrate=1500 -oac mp3lame -vf scale=320:240";
				_snwprintf(CommandLine, 1024, L"TransM.eng  %s -o mmap:\\\\%s \"%s\"", c, m_MemMapName, m_SrcFilename);
				//_snwprintf(CommandLine, 1024, L"TransM.eng  %s -o mmap:\\\\%s \"%s\"",L"-of mpeg -mpegopts format=dvd -ovc copy -oac copy", m_MemMapName, L"C:\\Media\\FreeBox\\france3_1_big.mpg");
				//_snwprintf(CommandLine, 1024, L"TransM.eng  %s -o mmap:\\\\%s \"%s\"",L"-of mpeg  -mpegopts format=dvd -ovc copy -oac copy", m_MemMapName, L"E:\\MMM\\france2_3_big.mpg");
				//_snwprintf(CommandLine, 1024, L"TransM.eng  %s -o mmap:\\\\%s \"%s\"",gMEncoderTransVideoQuality[1].pCommandLine, m_MemMapName, L"E:\\MMM\\france2_3_big.mpg");
			}
			else
			{
				_snwprintf(CommandLine, 1024, L"TransM.eng  %s -o mmap:\\\\%s \"%s\"",gMEncoderTransVideoQuality[gMEncoderTransVideoQualitySel].pCommandLine, m_MemMapName, m_SrcFilename);
			}


#else
			//_snprintf(CommandLine, 1024, L"mencoder.exe \"%s\" -ovc lavc -ffourcc DIVX -lavcopts vcodec=mpeg4:vbitrate=500:vpass=1 -oac mp3lame -o mmap:\\\\%s ", m_SrcFilename, m_MemMapName);
			_snprintf(CommandLine, 1024,L"TransM.eng \"%s\" -ovc xvid -ffourcc XVID -xvidencopts pass=1:turbo:vhq=0:bitrate=500 -oac mp3lame -o mmap:\\\\%s ", m_SrcFilename, m_MemMapName);
#endif
		}
		else if (MediaType == TRANS_MEDIATYPE_AUDIO)
		{
#ifdef UNICODE
		    _snwprintf(CommandLine, 1024, L"TransM.eng -i \"%s\" -f mp3 mmap:%s ", m_SrcFilename, m_MemMapName);
#else
		    _snprintf(CommandLine, 1024, L"TransM.eng -i \"%s\" -f mp3 mmap:%s ", m_SrcFilename, m_MemMapName);
#endif
		}

		_snwprintf(CodecLine, 1024, L"%s\\TransM.eng",gWorkingDir);

	}


		m_bFinish = FALSE;

		bCreateProc = CreateProcess(
			CodecLine, //		    L"Trans.eng ", //phillo
		    CommandLine,
		    NULL,               // LPSECURITY_ATTRIBUTES lpProcessAttributes,
		    NULL,               // LPSECURITY_ATTRIBUTES lpThreadAttributes,
		    FALSE,              // BOOL bInheritHandles,
		    CREATE_NO_WINDOW,   // DWORD dwCreationFlags, //phillo,2007/10/24, 0==> create console
		    NULL,               // LPVOID lpEnvironment,
		    NULL,               // LPCTSTR lpCurrentDirectory,
		    &si,               // LPSTARTUPINFO lpStartupInfo,
		    &m_TransProcess    // LPPROCESS_INFORMATION lpProcessInformation
		);


    if (bCreateProc == FALSE)
    {
        DBGPRINTF("Transcoding Thread Start fail...\n");
        m_pMapRing = NULL;
        UnmapViewOfFile(m_lpMapAddress);
        CloseHandle(m_hMapFile);
        CloseHandle(m_hMutex);
        return FALSE;
    }
    DBGPRINTF("Transcoding Thread Start...\n");
    gTransCount ++;
    if (gTransCount > 900)
        gTransCount = 0;
    return TRUE;
}

bool TransLib::Stop()
{
    bool NeedWait = FALSE;
	int LockStatus;

    if (m_pMapRing == NULL)
        return FALSE;
	LockStatus = LOCK_RING(m_hMutex, m_TransProcess.hProcess);
	if (LockStatus == -1)
	{
		// Transcode Process terminated
		m_TransProcess.hProcess = 0;
		m_pMapRing->read_end = 2;
		NeedWait = 0;
	}
    if (m_pMapRing->read_end == 0)
    {
        m_pMapRing->read_end = 1;
        NeedWait = 1;
    }
	if(LockStatus == 1)
		UNLOCK_RING(m_hMutex);
    if (NeedWait)
    {
        while(1)
        {
			LockStatus = LOCK_RING(m_hMutex, m_TransProcess.hProcess);
            if (LockStatus == -1)
			{
                m_pMapRing->read_end = 2;
                break;
            }
            if (m_pMapRing->read_end == 2)
            {
                UNLOCK_RING(m_hMutex);
                break;
            };
            UNLOCK_RING(m_hMutex);
        }
    }

    m_bFinish = TRUE;
    DBGPRINTF("Transcoding Thread Stop...\n");

    Sleep(1000);
    UnmapViewOfFile(m_lpMapAddress);
    CloseHandle(m_hMapFile);
    m_pMapRing = NULL;
    CloseHandle(m_TransProcess.hProcess);
    CloseHandle(m_TransProcess.hThread);
    CloseHandle(m_hMutex);
    return TRUE;
}

static inline int memmap_wait_buffer_data(MEMMapRing *pMapRing, HANDLE hMutex, HANDLE &hFFMpeg)
{
    int DataSize = 0;
	int LockStatus;
    do{
		LockStatus = LOCK_RING(hMutex, hFFMpeg);
        if (LockStatus == 0)
            return 0;
        if (LockStatus == -1)
			hFFMpeg = 0;
        DataSize = 0;
        if (pMapRing->nWriteOffset > pMapRing->nReadOffset)
        {
            DataSize = pMapRing->nWriteOffset - pMapRing->nReadOffset;
        }
        else if (pMapRing->nWriteOffset < pMapRing->nReadOffset)
        {
            DataSize = (pMapRing->nSize - pMapRing->nReadOffset) + pMapRing->nWriteOffset;
        }
        if (DataSize > 0)
            return DataSize;
        UNLOCK_RING(hMutex);  // unlock buffer for data reading by another thread.

		if (LockStatus == -1)	// no data can be read, and transcode process is terminated.
			return 0;

		if (pMapRing->read_end != 0)    // No more data should be written.
        {
            return 0;
        }
        Sleep(100); // Wait for 0.1 Sec.
    }while(1);
    return 0;
};

int TransLib::ReadData(unsigned char *pBuf, const int Size)
{
	int ReadSize = Size;
	int DataSize;
    DataSize = memmap_wait_buffer_data(m_pMapRing, m_hMutex, m_TransProcess.hProcess);
    if (DataSize == 0)
        return 0;

	if (m_bFinish == TRUE)
	{
        UNLOCK_RING(m_hMutex);
        return 0;
	}
    if (m_pMapRing->nWriteOffset > m_pMapRing->nReadOffset)
	{
		if (DataSize < ReadSize)
			ReadSize = DataSize;
		memcpy(pBuf, m_BufBase + m_pMapRing->nReadOffset, ReadSize);
		m_pMapRing->nReadOffset += ReadSize;
		//gTotalRead += ReadSize;
        UNLOCK_RING(m_hMutex);
		return ReadSize;
	}
	else if (m_pMapRing->nWriteOffset < m_pMapRing->nReadOffset)
	{
        int DataSize1 = m_pMapRing->nSize - m_pMapRing->nReadOffset;

		if (DataSize < ReadSize)
			ReadSize = DataSize;

		if (DataSize1 >= ReadSize)
		{
			memcpy(pBuf, m_BufBase + m_pMapRing->nReadOffset, ReadSize);
			m_pMapRing->nReadOffset += ReadSize;
            if (m_pMapRing->nReadOffset == m_pMapRing->nSize)
				m_pMapRing->nReadOffset = 0;
		}
		else
		{
			memcpy(pBuf, m_BufBase + m_pMapRing->nReadOffset, DataSize1);
			memcpy(pBuf+DataSize1, m_BufBase, ReadSize - DataSize1);
			m_pMapRing->nReadOffset = ReadSize - DataSize1;
		}
		//gTotalRead += ReadSize;
        UNLOCK_RING(m_hMutex);
		return ReadSize;
	}
	// SHOW_RING_STATUE(pMemFile);
    assert(0);
    UNLOCK_RING(m_hMutex);
	return 0;
}


//phillo,2007/11/5
int TransLib::CheckBufferSize(void)
{
	int ReadSize = 0;
	int DataSize;
    DataSize = memmap_wait_buffer_data(m_pMapRing, m_hMutex, m_TransProcess.hProcess);
  
    if (DataSize == 0)
        return 0;

	if (m_bFinish == TRUE)
	{
        UNLOCK_RING(m_hMutex);
        return 0;
	}

	UNLOCK_RING(m_hMutex);
	return DataSize;
}
