/*******************************************************************
*
*    DESCRIPTION: Transcoding Library Header File
*
*    AUTHOR: Alex Lee
*
*    HISTORY:
*
*    DATE:2006/4/19
*
*******************************************************************/
#ifndef __TRANSLIB_H__
#define __TRANSLIB_H__

/** include files **/
#include <windows.h>
/** local definitions **/




#define MEMRING_SIZE    (10*1024*1024)
typedef struct _MEMMapRing
{
    char   MutexName[20];   // Mutex Name
    DWORD  nSize;   // Buffer Size;
    DWORD  read_end;
    DWORD  nReadOffset; // Read Pointer Offset from Buffer Start
    DWORD  nWriteOffset;    // Write Offset from Buffer Start;
}MEMMapRing;

typedef struct __TransQualitySetting
{
    const wchar_t *pTitle;
    const wchar_t *pCommandLine;
    const char    *pMimeType;
    const char    *pProtocolInfo;
}TransQualitySetting;

#define TRANS_MEDIATYPE_VIDEO 0
#define TRANS_MEDIATYPE_AUDIO 1
#define TRANS_MEDIATYPE_PHOTO 2
class TransLib
{
public:
	TransLib(const char *pSrcfilename);
    ~TransLib();
	bool Start(const int MediaType,const int TransCodec);
	bool Stop();

    int ReadData(unsigned char *pBuf, const int Size);
	//phillo,2007/11/5
	int CheckBufferSize(void);
    bool m_bFinish;

private:
	// Decode Data
	HANDLE              m_hMapFile;
	char               *m_lpMapAddress;
    MEMMapRing         *m_pMapRing;
    char               *m_BufBase;
    PROCESS_INFORMATION m_TransProcess;
#ifdef UNICODE
	wchar_t   	        m_SrcFilename[MAX_PATH];
    wchar_t             m_MemMapName[50];
#else
	char     	       *m_pSrcFilename;
    char                m_MemMapName[50]; // Memory Map File key name
#endif
    HANDLE              m_hMutex;   // Mutex Lock for This Buffer!
};
#endif // __TRANSLIB_H__

