#include "stdafx.h"
extern "C" {
#include "MyString.h"
#include "MimeTypes.h"
}
#include "TransLibWarp.h"
#include "TransLib.h"
#ifdef __cplusplus
extern "C" {
#endif
extern int	gTranscodingEnable;
extern int	gTransVideoQualitySel;
#ifdef __cplusplus
}
#endif

#include "dbtools.h"
#include "FileSystemTree.h"
#include <assert.h>
extern TransQualitySetting gTransVideoQuality[];


//phillo,2007/10/24
HANDLE CreateTranscodingInternetStream(char *lpFileName, const char *pOrgMimeType,const int TransCodec)
{
	bool r;
    //char fileName[255];
    //WideCharToSingleByte(fileName, lpFileName, 255);
    //WideCharToMultiByte(CP_UTF8, NULL, lpFileName, -1, fileName, 255, NULL, NULL);
    TransLib *pTransLib = new TransLib(lpFileName);
	//phillo,2007/10/22 add force_audio_transcode
    if (stricmp(MIME_TYPE_AUDIO_OGG, pOrgMimeType) == 0 || stricmp("force_audio_transcode",pOrgMimeType) == 0 )
        r = pTransLib->Start(TRANS_MEDIATYPE_AUDIO,TransCodec); // phillo,2007/10/22
    else 
		r = pTransLib->Start(TRANS_MEDIATYPE_VIDEO,TransCodec); //phillo,2007/10/22
    // gpTransFile = fopen("E:\\AAAAA.AVI", "wb");

	//phillo,2008/1/17
	// work-around Start fail issue
	if( r == FALSE )
		return FALSE;
	else
		return (HANDLE) pTransLib;
};


// FILE *gpTransFile;
HANDLE CreateTranscodingFile(LPCTSTR lpFileName, const char *pOrgMimeType,const int TransCodec)
{
    char fileName[255];
	bool r;
    //WideCharToSingleByte(fileName, lpFileName, 255);
    WideCharToMultiByte(CP_UTF8, NULL, lpFileName, -1, fileName, 255, NULL, NULL);
    TransLib *pTransLib = new TransLib(fileName);
	//phillo,2007/10/22 add force_audio_transcode
    if (stricmp(MIME_TYPE_AUDIO_OGG, pOrgMimeType) == 0 || stricmp("force_audio_transcode",pOrgMimeType) == 0 )
        r = pTransLib->Start(TRANS_MEDIATYPE_AUDIO,TransCodec); // phillo,2007/10/22
    else 
		r = pTransLib->Start(TRANS_MEDIATYPE_VIDEO,TransCodec); //phillo,2007/10/22
    // gpTransFile = fopen("E:\\AAAAA.AVI", "wb");

	//phillo,2008/1/17
	// work-around Start fail issue
	if( r == FALSE )
		return FALSE;
	else
	    return (HANDLE) pTransLib;
};

#ifdef __cplusplus
extern "C"
#endif
int   ReadTranscodingFile(HANDLE TransLibHandle, LPVOID pBuf, DWORD nNumberOfBytesToRead)
{
    int NumberOfBytesRead;
    int Retry = 10;
    TransLib *pTransLib = (TransLib *)TransLibHandle;
    while(Retry)
    {
        NumberOfBytesRead = pTransLib->ReadData( (unsigned char *)pBuf, nNumberOfBytesToRead);
        // fwrite(pBuf, NumberOfBytesRead, 1, gpTransFile);
        if (NumberOfBytesRead)
            break;
        Retry--;
    }
    return NumberOfBytesRead;
};


//phillo,2007/11/5
#ifdef __cplusplus
extern "C"
#endif
int   CheckTranscodingBufferSize(HANDLE TransLibHandle)
{
    int NumberOfBytesRead;
    TransLib *pTransLib = (TransLib *)TransLibHandle;
    NumberOfBytesRead = pTransLib->CheckBufferSize();
    return NumberOfBytesRead;
};


#ifdef __cplusplus
extern "C"
#endif
BOOL   CloseTranscodingFile(HANDLE TransLibHandle)
{
    TransLib *pTransLib = (TransLib *)TransLibHandle;
    pTransLib->Stop();
    delete pTransLib;
    // fclose(gpTransFile);
    return TRUE;
};

// There are usually using Default Constant Start, so that there might be same address;
static __inline FastStricmp(const char *pStr1, const char *pStr2)
{
    if (pStr1 == pStr2)
        return 0;
    return stricmp(pStr1, pStr2);
};

#ifdef __cplusplus
extern "C" {
#endif

int    NeedTranscodingByMimeType(const char *pMimeType)
{
/*#ifdef HDDMA
	// Currently, don't need transcoding for HD-DMA
	return 0;
#else*/	
    BOOL bNeed = FALSE;
    if (FastStricmp(MIME_TYPE_VIDEO_DAT, pMimeType) == 0)
    {
        bNeed = TRUE;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MP4, pMimeType) == 0)
    {
        bNeed = TRUE;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MPA, pMimeType) == 0)
    {
        bNeed = TRUE;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_AVI, pMimeType) == 0)
    {
        bNeed = TRUE;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_VOB, pMimeType) == 0)
    {
        bNeed = TRUE;
    }
	//birdy 2007/5/14 support TS,M2TS,TP
	else if (FastStricmp("video/ts", pMimeType) == 0)
	{
		bNeed = TRUE;
	}
	else if (stricmp("video/m2ts", pMimeType) == 0)
	{
		bNeed = TRUE;
	}
	else if (stricmp("video/tp", pMimeType) == 0)
	{
		bNeed = TRUE;
	}
	
    else if (FastStricmp(MIME_TYPE_VIDEO_ASF, pMimeType) == 0)
    {
        bNeed = TRUE;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MPEG, pMimeType) == 0)
    {
        bNeed = TRUE;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MOV, pMimeType) == 0)
    {
        bNeed = TRUE;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MP4, pMimeType) == 0)
    {
        bNeed = TRUE;
    }
	
    if ((gTranscodingEnable == TRUE) && (bNeed == TRUE))
        return 1;
    if (FastStricmp(MIME_TYPE_VIDEO_WMV, pMimeType) == 0)
    {
        return 1;
    }
    if (FastStricmp(MIME_TYPE_VIDEO_MP4, pMimeType) == 0)
    {
        return 1;
    }
    if (FastStricmp(MIME_TYPE_VIDEO_MOV, pMimeType) == 0)
    {
        return 1;
    }
    else if (FastStricmp(MIME_TYPE_AUDIO_OGG, pMimeType) == 0)
    {
        return 1;
    }
    return 0;
	
//#endif
};

int NeedTranscodingByFilename(TCHAR *filename)
{
    unsigned long long RePos = wcslen(filename) - 1;
    BOOL found = FALSE;
    const char *pMimeType;
	
    while(RePos > 0)
    {
        if (filename[RePos] == (TCHAR)'.')
        {
            found = TRUE;
            break;
        }
        if (filename[RePos] == (TCHAR)'\\')
            return 0;
        RePos --;
    }
    if (found == FALSE)
        return 0;
    RePos++;

    if (wcsicmp(&filename[RePos], L"avi") == 0)
    {
    	char strSQL[MAX_SQL_STR_LENGTH];
	    struct FSE_QueryState qs;
        //char pTmpFilename[MAX_PATH];
        char pFilename[MAX_PATH];
        WideCharToMultiByte(CP_UTF8, NULL, filename, -1, pFilename, MAX_PATH, NULL, NULL);
/*
#ifndef UNICODE
        strcpy(pFilename, filename);
#else
        Utf8ToStr(pFilename, filename, MAX_PATH);
#endif
*/
		sprintf(strSQL,"select * from FSE_QueryState where FilePath =\"%s\"", pFilename);
        if ((db_getOneRecord(strSQL, &qs) != 0) && (qs.Flags & FLAGS_FORCETRANSCODING))
		{
			return 1;
		}
    };

    pMimeType = FileExtensionToMimeType((const char *)&filename[RePos], IS_WIDE);
	return NeedTranscodingByMimeType(pMimeType);

};

int HD_NeedTranscodingByFilename(TCHAR *filename)
{
    unsigned long long RePos = wcslen(filename) - 1;
    BOOL found = FALSE;
    const char *pMimeType;
	
    while(RePos > 0)
    {
        if (filename[RePos] == (TCHAR)'.')
        {
            found = TRUE;
            break;
        }
        if (filename[RePos] == (TCHAR)'\\')
            return 0;
        RePos --;
    }
    if (found == FALSE)
        return 0;
    RePos++;

    if (wcsicmp(&filename[RePos], L"avi") == 0)
    {
    	char strSQL[MAX_SQL_STR_LENGTH];
	    struct FSE_QueryState qs;
        //char pTmpFilename[MAX_PATH];
        char pFilename[MAX_PATH];
        WideCharToMultiByte(CP_UTF8, NULL, filename, -1, pFilename, MAX_PATH, NULL, NULL);
/*
#ifndef UNICODE
        strcpy(pFilename, filename);
#else
        Utf8ToStr(pFilename, filename, MAX_PATH);
#endif
*/
		sprintf(strSQL,"select * from FSE_QueryState where FilePath =\"%s\"", pFilename);
        if ((db_getOneRecord(strSQL, &qs) != 0) && (qs.Flags & FLAGS_FORCETRANSCODING))
		{
			return 1;
		}
    };

    pMimeType = FileExtensionToMimeType((const char *)&filename[RePos], IS_WIDE);
	return 0;

};

#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
extern "C"
#endif
const char *GetTranscodedMimeType(const char *pOrgMimeType)
{
    const char *pMimeType = pOrgMimeType;
    if (FastStricmp(MIME_TYPE_VIDEO_DAT, pOrgMimeType) == 0)
    {
        pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MP4, pOrgMimeType) == 0)
    {
        pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MPA, pOrgMimeType) == 0)
    {
        pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_AVI, pOrgMimeType) == 0)
    {
        pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_VOB, pOrgMimeType) == 0)
    {
        pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
    }
	//birdy 2007/5/14 support TS,M2TS,TP
	else if (FastStricmp("video/ts", pOrgMimeType) == 0)
	{
		pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
	}
	else if (stricmp("video/m2ts", pOrgMimeType) == 0)
	{
		pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
	}
	else if (stricmp("video/tp", pOrgMimeType) == 0)
	{
		pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
	}

    else if (FastStricmp(MIME_TYPE_VIDEO_ASF, pOrgMimeType) == 0)
    {
        pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_WMV, pOrgMimeType) == 0)
    {
        pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MPEG, pOrgMimeType) == 0)
    {
        pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MOV, pOrgMimeType) == 0)
    {
        pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MP4, pOrgMimeType) == 0)
    {
        pMimeType = gTransVideoQuality[gTransVideoQualitySel].pMimeType;
    }
    else if (FastStricmp(MIME_TYPE_AUDIO_OGG, pOrgMimeType) == 0)
    {
        pMimeType = MIME_TYPE_AUDIO_MPEG;
    }
    return pMimeType;
}

extern "C" {
extern const char* RP_GetProtocolInfo4thField(const char *localFilePath, const char *mimeType);
}

#ifdef __cplusplus
extern "C"
#endif
const char *GetTranscodedProtocolInfo4thField(const char *localFilePath, const char *pOrgMimeType)
{
    const char *p4thField = NULL;

    if (FastStricmp(MIME_TYPE_VIDEO_AVI, gTransVideoQuality[gTransVideoQualitySel].pMimeType) == 0)
    {
        p4thField = "DLNA.ORG_PN=AVI;DLNA.ORG_OP=00;DLNA.ORG_CI=00";
    }
    else if (FastStricmp(MIME_TYPE_VIDEO_MPEG, pOrgMimeType) == 0)
    {
        p4thField = "DLNA.ORG_PN=MPEG_PS_NTSC;DLNA.ORG_CI=00";		
    }

    if (p4thField == NULL)
    {
        p4thField = RP_GetProtocolInfo4thField(localFilePath, pOrgMimeType);
        assert(0);  // No available type for transcoding should not go through this path!
    };
    return p4thField;
}

#ifdef __cplusplus
extern "C"
#endif
int    GetTranscodedSize(HANDLE TransLibHandle)
{
    return 1024*1024;
}
