#ifndef __DEBUG_H__
#define __DEBUG_H__

#include <tchar.h>

#ifdef	_DEBUG
	//#define	MEM_DEBUG
	#define		DBGPrintf(_x_)	DbgPrintf _x_

	#ifdef	MEM_DEBUG
		#define		MALLOC(x)		malloc_dbg(x, __FILE__, __LINE__)
		#define		FREE(x)			free_dbg(x, __FILE__, __LINE__)
	#else	// MEM_DEBUG
		#define		MALLOC(x)		malloc(x)
		#define		FREE(x)			free(x)
	#endif	// MEM_DEBUG
#else	// _DEBUG
	#define		MALLOC(x)		malloc(x)
	#define		FREE(x)			free(x)
	#define		DBGPrintf(_x_)
#endif	// _DEBUG

void	*malloc_dbg(size_t size, char* fileName, int lineNo) ;
void	free_dbg(void *, char* fileName, int lineNo);
void	DbgPrintf(TCHAR *fmt, ...);

#endif // __DEBUG_H__