#ifndef _bk_extract_h
#define _bk_extract_h
#include "bk.hpp"

//for unistd.h in linux
#define R_OK 4 /*Test for read permission*/
#define W_OK 2 /*Test for write permission*/
#define X_OK 1 /*Test for excute permission*/
#define F_OK 0 /*Test for existence*/
int bk_extract(VolInfo* volInfo, const char* srcPathAndName, 
               const char* destDir, int keepPermissions, 
               void(*progressFunction)(VolInfo*));
int bk_extract_as(VolInfo* volInfo, const char* srcPathAndName, 
                  const char* destDir, const char* nameToUse,
                  int keepPermissions, void(*progressFunction)(VolInfo*));
int extract(VolInfo* volInfo, BkDir* parentDir, char* nameToExtract, 
            const char* destDir, const char* nameToUse, int keepPermissions);
int extractDir(VolInfo* volInfo, BkDir* srcDir, const char* destDir, 
               const char* nameToUse, int keepPermissions);
int copyByteBlock(VolInfo* volInfo, HANDLE src, HANDLE dest, unsigned numBytes);
int extractFile(VolInfo* volInfo, BkFile* srcFileInTree, const char* destDir, 
                const char* nameToUse, int keepPermissions);
#endif