#ifndef _bk_read_h
#define _bk_read_h
#include "bk.hpp"
#include "bkError.hpp"
#define NBYTES_VIRTUAL_SECTOR 512
int bk_open_image(VolInfo *volInfo,TCHAR *filename);
int bk_read_vol_info(VolInfo* volInfo);
DWORD readRead(VolInfo* volInfo, LPBYTE dest, int numBytes);
void stripSpacesFromEndOfString(unsigned char* str);
int bk_read_dir_tree(VolInfo* volInfo, int filenameType, 
                     int keepPosixPermissions, 
                     void(*progressFunction)(VolInfo*));
int readDir(VolInfo* volInfo, BkDir* dir, int filenameType, 
            int keepPosixPermissions);
int readRockridgeFilename(VolInfo* volInfo, char* dest, int lenSU, 
                          unsigned numCharsReadAlready);
int readPosixFileMode(VolInfo* volInfo, unsigned* posixFileMode, int lenSU);
int readDirContents(VolInfo* volInfo, BkDir* dir, unsigned size, 
                    int filenameType, int keepPosixPermissions);
int skipDR(VolInfo* volInfo);
int haveNextRecordInSector(VolInfo* volInfo);
int dirDrFollows(VolInfo* volInfo);
int readFileInfo(VolInfo* volInfo, BkFile* file, int filenameType, 
                 int keepPosixPermissions, BkFileBase** specialFile);
void removeCrapFromFilename(char* filename, int length);
int readRockridgeSymlink(VolInfo* volInfo, BkSymLink** dest, int lenSU);
size_t appendStringIfHaveRoom(char* dest, const char* src, size_t destMaxLen, 
                              size_t destCharsAlreadyUsed, int maxSrcLen);
#endif
