#include <stdafx.h>
#include "bkTime.hpp"

/* 8.4.26.1 -> epoch time */
void longStringToEpoch(const unsigned char* longString, time_t* epoch)
{
    char str[5];
    int number;
    struct tm timeStruct;
    
    /* no daylight savings setting available */
    timeStruct.tm_isdst = -1;
    
    /* YEAR */
    strncpy(str, (char*)longString, 4);
    str[4] = '\0';
    
    sscanf(str, "%d", &number);
    
    timeStruct.tm_year = number - 1900;
    /* END YEAR */
    
    /* MONTH */
    strncpy(str, (char*)longString + 4, 2);
    str[2] = '\0';
    
    sscanf(str, "%d", &number);
    
    timeStruct.tm_mon = number - 1;
    /* END MONTH */
    
    /* DAY */
    strncpy(str, (char*)longString + 6, 2);
    str[2] = '\0';
    
    sscanf(str, "%d", &number);
    
    timeStruct.tm_mday = number;
    /* END DAY */
    
    /* HOUR */
    strncpy(str, (char*)longString + 8, 2);
    str[2] = '\0';
    
    sscanf(str, "%d", &number);
    
    timeStruct.tm_hour = number;
    /* END HOUR */
    
    /* MINUTE */
    strncpy(str, (char*)longString + 10, 2);
    str[2] = '\0';
    
    sscanf(str, "%d", &number);
    
    timeStruct.tm_min = number;
    /* END MINUTE */
    
    /* SECOND */
    strncpy(str, (char*)longString + 12, 2);
    str[2] = '\0';
    
    sscanf(str, "%d", &number);
    
    timeStruct.tm_sec = number;
    /* END SECOND */
    
    *epoch = mktime(&timeStruct);
}
