// isoparser.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "isoparser.h"
#include "bk.hpp"
#include "bkset.h"
#include "bkRead.hpp"
#include "bkDelete.hpp"
#include "bkExtract.hpp"
#include "../_Utility/MyString.h"
#include <stdio.h>

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

void fatalError(const char* message)
{
//	LPCSTR tmpMes[256];
//	wsprintf(tmpMes,("Fatal error:%s\n",message));
    //MessageBox("Fatal error: %s\n", message);
   // exit(1);
}
/* you can use this to update a progress bar or something */
void readProgressUpdaterCbk(VolInfo* volInfo)
{
	return;
   // printf("Read progress updater\n");
}

ISOPARSER_API int fn_extract(VolInfo* volInfo, const char* srcPathAndName, 
               const char* destDir)
{
	return bk_extract(volInfo,srcPathAndName,destDir,1,NULL);
	
}

ISOPARSER_API void	Iso_destroy_vol_info(void *ptr)
{
	VolInfo *volInfo = (VolInfo*)ptr;
	bk_destroy_vol_info(volInfo);
	return;
}
// This is an example of an exported function.ISOPARSER_API int fnIsoparser_to_dir(int argc,char **argv,BkFileBase** base)
ISOPARSER_API int fnIsoparser(TCHAR *argv,VolInfo* volInfo)
{
    int rc;
	TCHAR FileName[255];
    
	rc = bk_init_vol_info(volInfo, 1);
    if(rc <= 0)
    { 
    	//printf("failed vol_info!\n");   
    	fatalError(bk_get_error_string(rc));
    }

//	UTF8ToStr(argv,FileName,255);
	 rc = bk_open_image(volInfo, argv);
	 if(rc <= 0)
     {   
     	 // printf("bk open image error\n");
     	 fatalError(bk_get_error_string(rc));
    }
	rc = bk_read_vol_info(volInfo);
    if(rc <= 0)
	{   
		fatalError(bk_get_error_string(rc));
	}

	if(volInfo->filenameTypes & FNTYPE_ROCKRIDGE)
        rc = bk_read_dir_tree(volInfo, FNTYPE_ROCKRIDGE, 1, readProgressUpdaterCbk);
   else if(volInfo->filenameTypes & FNTYPE_JOLIET)
        rc = bk_read_dir_tree(volInfo, FNTYPE_JOLIET, 0, readProgressUpdaterCbk);
    else
        rc = bk_read_dir_tree(volInfo, FNTYPE_9660, 0, readProgressUpdaterCbk);
    if(rc <= 0)
        fatalError(bk_get_error_string(rc));
	
	return 0;
}

void printNameAndContents(BkFileBase* base, int numSpaces)
{
    int count;
    struct BkFileBase *child;
    /* print the spaces (indentation, for prettyness) */
    for(count = 0; count < numSpaces; count++)
        printf(" ");
    
    if(IS_DIR(base->posixFileMode))
    {
        
        printf("%s (directory)\n", base->name);
		child=BK_DIR_PTR(base)->children;
        while(child != NULL)
        {
            printNameAndContents(child, numSpaces + 2);
            child = child->next;
        }
    }
    else if(IS_REG_FILE(base->posixFileMode))
    {
        
        printf("%s (regular file), size %u\n", base->name, BK_FILE_PTR(base)->size);
    }
    else if(IS_SYMLINK(base->posixFileMode))
    {
       
        printf("%s -> %s (symbolic link)\n", base->name, BK_SYMLINK_PTR(base)->target);
    }
}
