/***********************************************************************
 *    msdl.h:  media stream download header file.
 ***********************************************************************
 * Copyright (C) 2007 metro <me_t_ro@yahoo.com>
 *
 * This file is part of msdl, media stream downloader
 * See README for program usage and information.
 * See COPYING for license information.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 *
 ***********************************************************************/


#ifndef __MSDL_H__
#define __MSDL_H__

//#include <inttypes.h>




enum {
    STREAM_CHECK_DATA_TIME = 5,
};

//phillo
#define INT_MAX 0xFFFFFFFFUL
typedef unsigned int size_t;

/*
 * for parsing command line and environment options
 */
struct options_t {
    char *local_filename;
    char *protocol;
    char *username;
    char *password;
    char *http_proxy;

    int verbose_f;
    int quiet_f;
    int debug_f;
  
    unsigned int bandwidth;
  
    struct p_list *targets; /* target_t list */
};

struct target_t {
    int metafile_f;
    char *target_name;
};


/*
 * option to pass to download_streaming function.
 * everything not file pointer and url goes here.
 */
struct download_opts_t {
    unsigned int bandwidth;
};


struct dlresult_t {
    struct p_list *success_list; /* char[] array */
    struct p_list *failed_list;  /* char[] array */
};




/*******************************************************
 **                   GLOBALs     
 */

extern struct options_t *options;


#endif /* __MSDL_H__ */
